// (C) 2001-2022 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


`timescale 1ps/1ps
module alt_cpriphy_c3 (
       input wire pll_refclk0,
       output wire tx_serial_data,
       input wire  i_clk_ref,
       input wire  i_reconfig_clk,
       input wire  i_reconfig_reset,
       input wire  i_sampling_clk,
       output wire [3:0] o_tx_clkout,
       output wire [3:0] o_tx_clkout2,
       output wire [3:0] o_rx_clkout,
       output wire [3:0] o_rx_clkout2,
       output wire [3:0] o_cdr_lock,
       output wire [3:0] o_tx_pll_locked,
       output wire [3:0] o_tx_serial,
       input wire [3:0] i_rx_serial,
       input wire [75:0] i_xcvr_reconfig_address,
       input wire [3:0] i_xcvr_reconfig_read,
       input wire [3:0] i_xcvr_reconfig_write,
       output wire [31:0] o_xcvr_reconfig_readdata,
       input wire [31:0] i_xcvr_reconfig_writedata,
       output wire [3:0] o_xcvr_reconfig_waitrequest,
       input wire [75:0] i_sl_cpri_reconfig_addr,
       input wire [3:0] i_sl_cpri_reconfig_read,
       input wire [3:0] i_sl_cpri_reconfig_write,
       output wire [127:0] o_sl_cpri_reconfig_readdata,
       output wire [3:0] o_sl_cpri_reconfig_readdata_valid,
       input wire [127:0] i_sl_cpri_reconfig_writedata,
       output wire [3:0] o_sl_cpri_reconfig_waitrequest,
       output wire [3:0] o_sl_rx_hi_ber,
       output wire [3:0] o_sl_tx_lanes_stable,
       output wire [3:0] o_sl_rx_pcs_ready,
       output wire [3:0] o_sl_ehip_ready,
       output wire [3:0] o_sl_rx_block_lock,
       input wire [3:0] i_sl_csr_rst_n,
       input wire [3:0] i_sl_tx_rst_n,
       input wire [3:0] i_sl_rx_rst_n,
       input wire [255:0] i_sl_tx_mii_d,
       input wire [31:0] i_sl_tx_mii_c,
       output wire [255:0] o_sl_rx_mii_d,
       output wire [31:0] o_sl_rx_mii_c
);


    ex_10G av_top (
        .i_reconfig_clk(i_reconfig_clk),
        .i_reconfig_reset(i_reconfig_reset),
        .i_sampling_clk(i_sampling_clk),
        .i_clk_ref({4'b0,i_clk_ref}),
        .o_tx_clkout(o_tx_clkout),
        .o_tx_clkout2(o_tx_clkout2),
        .o_rx_clkout(o_rx_clkout),
        .o_rx_clkout2(o_rx_clkout2),
        .o_cdr_lock(o_cdr_lock),
        .o_tx_pll_locked(o_tx_pll_locked),
        .o_tx_serial(o_tx_serial),
        .i_rx_serial(i_rx_serial),
        .i_xcvr_reconfig_address(i_xcvr_reconfig_address),
        .i_xcvr_reconfig_read(i_xcvr_reconfig_read),
        .i_xcvr_reconfig_write(i_xcvr_reconfig_write),
        .o_xcvr_reconfig_readdata(o_xcvr_reconfig_readdata),
        .i_xcvr_reconfig_writedata(i_xcvr_reconfig_writedata),
        .o_xcvr_reconfig_waitrequest(o_xcvr_reconfig_waitrequest),
        .i_sl_cpri_reconfig_addr(i_sl_cpri_reconfig_addr),
        .i_sl_cpri_reconfig_read(i_sl_cpri_reconfig_read),
        .i_sl_cpri_reconfig_write(i_sl_cpri_reconfig_write),
        .o_sl_cpri_reconfig_readdata(o_sl_cpri_reconfig_readdata),
        .o_sl_cpri_reconfig_readdata_valid(o_sl_cpri_reconfig_readdata_valid),
        .i_sl_cpri_reconfig_writedata(i_sl_cpri_reconfig_writedata),
        .o_sl_cpri_reconfig_waitrequest(o_sl_cpri_reconfig_waitrequest),
        .o_sl_rx_hi_ber(o_sl_rx_hi_ber),
        .o_sl_tx_lanes_stable(o_sl_tx_lanes_stable),
        .o_sl_rx_pcs_ready(o_sl_rx_pcs_ready),
        .o_sl_ehip_ready(o_sl_ehip_ready),
        .o_sl_rx_block_lock(o_sl_rx_block_lock),
        .i_sl_clk_tx({4{i_aib_clk}}),
        .i_sl_clk_rx({4{i_aib_clk}}),
        .i_sl_csr_rst_n(i_sl_csr_rst_n),
        .i_sl_tx_rst_n(i_sl_tx_rst_n),
        .i_sl_rx_rst_n(i_sl_rx_rst_n),
        .i_aib_clk(i_aib_clk),
        .i_aib_2x_clk(i_aib_2x_clk),
        .i_sl_tx_mii_d(i_sl_tx_mii_d),
        .i_sl_tx_mii_c(i_sl_tx_mii_c),
        .o_sl_rx_mii_d(o_sl_rx_mii_d),
        .o_sl_rx_mii_c(o_sl_rx_mii_c)
    );
    
    alt_cpriphy_c3_channel_pll i_channel_pll (
        .pll_locked     (),
        .tx_serial_data (tx_serial_data),
        .pll_refclk0    (pll_refclk0),
        .pll_clkout1    (i_aib_2x_clk),
        .pll_clkout2    (i_aib_clk)
    );

    // Reset Release block
    wire ninit_done, init_done;
    alt_cpriphy_c3_reset_release reset_release(
        .ninit_done (ninit_done) // active high reset
    );

endmodule

