// (C) 2001-2022 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

module alt_cpriphy_c3_hard_7djwtgq
   import alt_cpriphy_c3_package::*;
   #(
    parameter MAX_REFCLK = 1,
    // parameter MAX_CH = 1,
    parameter MAX_XCVR_CH = 4,
    parameter MAX_CLKOUT_CH = 4,
    parameter SL_LANES = 1,
    parameter ENABLE_RSFEC=0,
    parameter ENABLE_RSFEC_MODE=0,
    parameter LANES6 = 6,
    parameter LANES4 = 4,
    parameter LOCATION_SEL = 0,
    parameter enable_external_aib_clocking = 0,
    parameter FIRST_LANE = 0,

    parameter cpri_include_alternate_ports      = 0,
    parameter ehip_mode_sl_0                    = "ehip_mac_no_fec"
    )
   (
    // clocks
    input wire  [MAX_REFCLK-1:0]     i_refclk,
    input wire                       i_reconfig_clk,
    input wire  [SL_LANES-1:0]       i_sl_clk_tx,
    input wire  [SL_LANES-1:0]       i_sl_clk_rx,
    input wire                       i_aib_clk,
    input wire                       i_aib_2x_clk,
    output wire [MAX_CLKOUT_CH-1:0]  o_tx_clk_div64, // 64 clock = 402.3
    output wire [MAX_CLKOUT_CH-1:0]  o_rx_clk_div64, // 64 clock = 402.3
    output wire [MAX_CLKOUT_CH-1:0]  o_tx_clk_div66, // 66 clock = 390.625
    output wire [MAX_CLKOUT_CH-1:0]  o_rx_clk_div66, // 66 clock = 390.625

    // Configuration
    input wire [SL_LANES-1:0]        i_sl_enable_rsfec,

    // Serial Interface signals
    input wire [MAX_XCVR_CH-1:0]     i_rx_serial_data,
    output wire [MAX_XCVR_CH-1:0]    o_tx_serial_data,
    input wire [MAX_XCVR_CH-1:0]     i_rx_serial_data_n,
    output wire [MAX_XCVR_CH-1:0]    o_tx_serial_data_n,

    // Reset controller interface signals
    input wire                       i_ehip_rst_n, // this will
    input wire                       i_ehip_rx_rst_n,
    input wire                       i_ehip_tx_rst_n,
    input wire                       i_ehip_pld_ready,
    input wire                       i_ehip_signal_ok,

    input wire [SL_LANES-1:0]        i_sl_rx_pmaif_reset,
    input wire [SL_LANES-1:0]        i_sl_tx_pmaif_reset,
    input wire [SL_LANES-1:0]        i_sl_tx_aib_reset,
    input wire [SL_LANES-1:0]        i_sl_rx_aib_reset,
    // input wire [SL_LANES-1:0]        i_sl_pmad_reset,
    input  wire [SL_LANES-1:0]       i_sl_tx_reset,
    input  wire [SL_LANES-1:0]       i_sl_rx_reset,

    output wire [SL_LANES-1:0]       o_sl_rx_is_lockedtodata,
    output wire [SL_LANES-1:0]       o_sl_rx_transfer_ready,
    output wire [SL_LANES-1:0]       o_sl_tx_transfer_ready,
    output wire [SL_LANES-1:0]       o_sl_tx_dll_lock,
    output wire [SL_LANES-1:0]       o_sl_rx_pma_ready,
    output wire [SL_LANES-1:0]       o_sl_tx_pma_ready,


    // MAC Interface
    input wire                       i_ehip_clear_internal_err,

    input wire [SL_LANES-1:0][63:0]  i_sl_tx_data, 
    input wire [SL_LANES-1:0]        i_sl_tx_error,
    input wire [SL_LANES-1:0][2:0]   i_sl_tx_empty, 
    input wire [SL_LANES-1:0]        i_sl_tx_inframe,
    input wire [SL_LANES-1:0]        i_sl_tx_skip_crc,
    input wire [SL_LANES-1:0]        i_sl_tx_aib_dsk,

    output wire [SL_LANES-1:0][63:0] o_sl_rx_data,
    output wire [SL_LANES-1:0][2:0]  o_sl_rx_empty,
    output wire [SL_LANES-1:0][1:0]  o_sl_rx_error,
    output wire [SL_LANES-1:0][2:0]  o_sl_rx_status,
    output wire [SL_LANES-1:0]       o_sl_rx_fcs_error,
    output wire [SL_LANES-1:0]       o_sl_rx_inframe,
    output wire [SL_LANES-1:0]       o_sl_rx_aib_dsk,
    output wire [SL_LANES-1:0]       o_sl_rx_aib_dsk_done,

    input  wire [SL_LANES-1:0]       i_sl_tx_valid,
    output wire [SL_LANES-1:0]       o_sl_tx_ready,
    output wire [SL_LANES-1:0]       o_sl_rx_valid,

    // Elane Interface
    output wire [SL_LANES-1:0]       o_sl_rx_pcs_fully_aligned,
    output wire [SL_LANES-1:0]       o_sl_rx_block_lock,
    output wire [SL_LANES-1:0]       o_sl_rx_hi_ber,
    output wire [SL_LANES-1:0]       o_sl_local_fault_status,
    output wire [SL_LANES-1:0]       o_sl_rx_pause,
    output wire [SL_LANES*8-1:0]     o_sl_rx_pfc,
    output wire [SL_LANES-1:0]       o_sl_xcvr_rxfifo_overflow,
    output wire [SL_LANES-1:0]       o_sl_remote_fault_status,
    input  wire [SL_LANES-1:0]       i_sl_ehip_signal_ok,
    input  wire [SL_LANES-1:0]       i_sl_tx_pause,
    input  wire [SL_LANES*8-1:0]     i_sl_tx_pfc,
    output wire [SL_LANES-1:0]       o_sl_xcvr_txfifo_pempty,
    output wire [SL_LANES-1:0]       o_sl_xcvr_txfifo_pfull,
    output wire [SL_LANES-1:0]       o_sl_xcvr_txfifo_overflow,
    output wire [SL_LANES-1:0]       o_sl_xcvr_txfifo_underflow,
    input  wire [SL_LANES-1:0]       i_sl_clear_internal_err,
    output wire [SL_LANES-1:0]       o_sl_internal_err,
    input  wire [SL_LANES-1:0]       i_sl_force_rcfg_reset,
    output wire [SL_LANES-1:0]       o_sl_cfg_load_done,
    input  wire [SL_LANES-1:0]       i_sl_stats_snapshot,
    input  wire [SL_LANES-1:0]       i_sl_custom_cadence,

    input  wire [SL_LANES-1:0]       i_sl_ehip_reset,
    input  wire [SL_LANES-1:0]       i_sl_ehip_rx_reset,
    input  wire [SL_LANES-1:0]       i_sl_ehip_tx_reset,
    output wire [SL_LANES-1:0]       o_sl_ehip_ready,
    input  wire [SL_LANES-1:0]       i_sl_ehip_pld_ready,
    output wire [SL_LANES-1:0]       o_sl_ehip_reset_stat,
    output wire [SL_LANES-1:0]       o_sl_ehip_rx_reset_stat,
    output wire [SL_LANES-1:0]       o_sl_ehip_tx_reset_stat,

    input  wire                      i_sl_rsfec_reset,
    input  wire                      i_sl_rsfec_rx_reset,
    input  wire                      i_sl_rsfec_tx_reset,

    output wire [SL_LANES-1:0]       o_sl_rx_fifo_ready,
    output wire [SL_LANES-1:0]       o_sl_tx_fifo_ready,
    
    output wire [SL_LANES-1:0]       o_sl_rx_nphy_ready,
    output wire [SL_LANES-1:0]       o_sl_tx_nphy_ready,

    // MII Interface
    input  wire [SL_LANES-1:0][63:0] i_sl_tx_mii_d,          // TX MII data
    input  wire [SL_LANES-1:0][7:0]  i_sl_tx_mii_c,          // Tx MII control
    input  wire [SL_LANES-1:0]       i_sl_tx_mii_valid,      // Indicates valid data ports, must follow o_tx_mii_ready
    input  wire [SL_LANES-1:0]       i_sl_tx_mii_am,         // Alignment marker insertion bit
    output wire [SL_LANES-1:0]       o_sl_tx_mii_ready,      // indicates PCS is ready to receive new data
    output wire [SL_LANES-1:0][63:0] o_sl_rx_mii_d,          // RX MII data
    output wire [SL_LANES-1:0][7:0]  o_sl_rx_mii_c,          // RX MII control
    output wire [SL_LANES-1:0]       o_sl_rx_mii_valid,      // Indicates valid datain MII ports
    output wire [SL_LANES-1:0]       o_sl_rx_mii_am_valid,   // Indicates valid datain MII ports

    // PCS66 (OTN, FLEXE) Interface
    input  wire [SL_LANES-1:0][65:0] i_sl_tx_pcs66_d,        // TX PCS66 data
    input  wire [SL_LANES-1:0]       i_sl_tx_pcs66_valid,    // Indicates valid data ports, must follow o_tx_pcs66_ready
    input  wire [SL_LANES-1:0]       i_sl_tx_pcs66_am,       // Alignment marker insertion bit
    output wire [SL_LANES-1:0]       o_sl_tx_pcs66_ready,    // indicates PCS is ready to receive new data
    output wire [SL_LANES-1:0][65:0] o_sl_rx_pcs66_d,        // RX PCS66 data
    output wire [SL_LANES-1:0]       o_sl_rx_pcs66_valid,    // Indicates valid datain PCS66 ports
    output wire [SL_LANES-1:0]       o_sl_rx_pcs66_am_valid, // Indicates valid datain PCS66 ports   

    // PMA Direct Interface
    input  wire [SL_LANES-1:0][79:0] i_sl_tx_pma, // TX PMA direct data
    output wire [SL_LANES-1:0][79:0] o_sl_rx_pma, // RX PMA direct data
    output wire [SL_LANES-1:0]       o_sl_aib_txfifo_empty,
    output wire [SL_LANES-1:0]       o_sl_aib_txfifo_full,
    output wire [SL_LANES-1:0]       o_sl_aib_txfifo_pempty,
    output wire [SL_LANES-1:0]       o_sl_aib_txfifo_pfull,
    output wire [SL_LANES-1:0]       o_sl_aib_rxfifo_empty,
    output wire [SL_LANES-1:0]       o_sl_aib_rxfifo_full,
    output wire [SL_LANES-1:0]       o_sl_aib_rxfifo_pempty,
    output wire [SL_LANES-1:0]       o_sl_aib_rxfifo_pfull,
    input  wire [SL_LANES-1:0]       i_sl_aib_rxfifo_rd_en,

    // RX AIB deskew debug
    input  wire [SL_LANES-1:0]       i_sl_aib_rxfifo_latency_adj_ena,

    // Datapath mux select
    input  wire [SL_LANES-1:0][2:0]  i_sl_dp_sel,

    // Deterministic Latency Interface
    output wire [SL_LANES-1:0]       o_sl_tx_dl_async_pulse,
    output wire [SL_LANES-1:0]       o_sl_rx_dl_async_pulse,
    input  wire [SL_LANES-1:0]       i_sl_latency_sclk,
    input  wire [SL_LANES-1:0]       i_sl_tx_dl_measure_sel,
    input  wire [SL_LANES-1:0]       i_sl_rx_dl_measure_sel,

    // EHIP Interface: Reference Timestamp
    input  wire [SL_LANES-1:0]       i_sl_sclk,
    input  wire [SL_LANES-1:0]       i_sl_tx_sel_sclk_return,
    input  wire [SL_LANES-1:0]       i_sl_rx_sel_sclk_return,
    output wire [SL_LANES-1:0]       o_sl_tx_sclk_return,
    output wire [SL_LANES-1:0]       o_sl_rx_sclk_return,

    //XCVR Reconfig Interface, seperate one for each lane
    input wire                       i_reconfig_reset,
    input wire                       i_rsfec_reconfig_write,
    input wire                       i_rsfec_reconfig_read,
    input wire [11-1:0]              i_rsfec_reconfig_addr,
    input wire [8-1:0]               i_rsfec_reconfig_writedata,
    output wire [8-1:0]              o_rsfec_reconfig_readdata,
    output wire                      o_rsfec_reconfig_waitrequest,

    input  wire                      i_xcvr_reconfig_reset,
    input  wire [MAX_XCVR_CH-1:0]    i_xcvr_reconfig_write,
    input  wire [MAX_XCVR_CH-1:0]    i_xcvr_reconfig_read,
    input  wire [MAX_XCVR_CH*19-1:0] i_xcvr_reconfig_address,
    input  wire [MAX_XCVR_CH*8-1:0]  i_xcvr_reconfig_writedata,
    output wire [MAX_XCVR_CH*8-1:0]  o_xcvr_reconfig_readdata,
    output wire [MAX_XCVR_CH-1:0]    o_xcvr_reconfig_waitrequest,

    output wire [32-1:0]             o_rsfec_channel_ssr
    );


// DESKEW

//     
    

   /***************************************************************************************************************************   
    For C2E - EHIP at hssi_tile_3 ( 4th six pack, hssi_tile0, 1, 2 (six packs 1, 2, 3) for PHIP
    Tile 3  0, 1, 3, 4 run at 25G
    For 100G  Tile 3 - LC0, PMA/PCS Ch0, 1, 3, 4 (adapter 0-4). From remaining chs only Ch5 is available in EHIP BYPass mode and can run upto 12.5G
    For 50G  Tile 3 LC0 , PMA/PCS/Adapter - Ch0, 1, running at 25.78125G
    remaining chs(2, 3, 4, 5)  can be used in EHIP bypass mode for other purpose and can run upto 4.5G
    Adapters are in HIP mode similar to PHIP, 2 speed grades -1, -2. 
    Internally 17G at -1 speed, ext commn 25.78125G.     
    <------------------------  ehipc3  ------------------------->
    |-------------|              |-------------|        |-------|
    |             |              |             |        |       |     
    |   XCVR PCS  |------------->| EHIP Core   |------->|  AIB  | => Soft Logic   
    |             |<-------------|             |<-------|       |    (Reset controller, ADDapter, CSR) 
    |-------------|              |-------------|        |-------|
    
    EHIP PCS Interface - To transfter data safely from EHIP clock domain to PCS clock domain
    It connects EHIP Core and 4 PCS Interface channels
    1) PCS TX Interface - 4 PH Comp FIFOs and 4 muxes, wrclk =EHIP_CLK, rd_clk = pcs_tx_clkout,
    both clocks are from the same TX PLL and should hvae 0 PPM so TX overflow shouldn't happen.
    Underflow flag assertion does not mean failure. Its considered failure when data is corrupted, 
    in which case user should check clock setting to ensure read and write FIFO frequencies
    2) PCS RX Interface - RX FIFO is in elastic mode and handles clk componsation and ph componsation
    between receoverd clock domain and EHIP Clok domain, wrclk =pcs_rx_clkout(recovered clock,rd_clk= ehip_clk
    By design, RX FIFO underflow could never happen because read enable = ~empty flag. 
    RX FIFO overflow could only happen when recover clock frequency over EHIP main clock frequency ratio is 
    more than 66/64 or 30,000ppm difference. According to IEEE specs, ppm difference should be +/-100ppm. 
    When you do see an overflow, user needs to check clocking scheme for any setup issue
    
    //Following will be ack signals for ehip resets,  which will go to the reset controller 
    //o_rx_rst_n          
    //o_tx_rst_n         
    //o_rst_n
    ****************************************************************************************************************************/

    genvar i;


    logic [SL_LANES-1:0]         sl_tx_pma_ready;

    assign o_sl_tx_pma_ready = sl_tx_pma_ready;

    wire     h2a_rx_ehip_rst_n;
    wire     o_ehip_clk;
    wire     o_ehip_dist_fr_rx_clk;
    wire     o_fec_dist_fr_rx_clk;

    wire [4:0]                             sl_refclk;
    generate
        for(i = 0; i < 5; i = i + 1) begin : SL_REFCLK_LOOP
            if(MAX_REFCLK > i) begin : SL_REFCLK_SYNTH
                assign sl_refclk[i] = i_refclk[i];
            end
            else begin : SL_REFCLK_UNUSED
                assign sl_refclk[i] = 1'b0;
            end
        end
    endgenerate


    wire [SL_LANES-1:0]                    sl_tx_coreclkin;
    wire [SL_LANES-1:0]                    sl_rx_coreclkin;
    wire [SL_LANES-1:0]                    sl_tx_coreclkin2;
    wire [SL_LANES-1:0]                    sl_rx_aib_reset_sync;


    wire [SL_LANES-1:0]         sl_tx_transfer_ready;
    wire [SL_LANES-1:0]         sl_rx_transfer_ready;

    assign o_sl_tx_transfer_ready = sl_tx_transfer_ready;
    assign o_sl_rx_transfer_ready = sl_rx_transfer_ready;

    wire [LANES4-1:0]           sl_rsfec_not_align;
    wire [LANES4-1:0]           sl_rsfec_not_align_sync;
    reg                         sl_rsfec_reset_assert_locked;
    wire [LANES4-1:0]           sl_ehip_signal_ok;
    wire [SL_LANES-1:0]         sl_ehip_pld_ready_sync;
    reg                         sl_rsfec_pld_ready;

    localparam                  STM_SL_RSFEC_RESET_INIT          = 7'b0000001;
    localparam                  STM_SL_RSFEC_RX_RESET_ASSERT     = 7'b0000010;
    localparam                  STM_SL_RSFEC_TX_RESET_ASSERT     = 7'b0000100;
    localparam                  STM_SL_RSFEC_RESET_ASSERT        = 7'b0001000;
    localparam                  STM_SL_RSFEC_RESET_DEASSERT      = 7'b0010000;
    localparam                  STM_SL_RSFEC_TX_RESET_DEASSERT   = 7'b0100000;
    localparam                  STM_SL_RSFEC_RX_RESET_DEASSERT   = 7'b1000000;

    reg  [6:0]                  sl_rsfec_reset_nextstate;
    reg  [6:0]                  sl_rsfec_reset_state;
    reg  [7:0]                  sl_rsfec_reset_count;
    wire [8:0]                  sl_rsfec_reset_count_plus_one;
    wire                        sl_rsfec_clock_stable;
    wire                        sl_rsfec_clock_stable_sync;
    reg                         sl_global_rsfec_reset;
    reg                         sl_global_rsfec_tx_reset;
    reg                         sl_global_rsfec_rx_reset;


    wire [LANES6*4-1:0]       hip_aib_fsr_in;
    wire [LANES6*40-1:0]      hip_aib_ssr_in;

    assign hip_aib_fsr_in[23:4] = 20'b0;
    assign hip_aib_fsr_in[3] = i_ehip_pld_ready;
    assign hip_aib_fsr_in[2] = i_ehip_rx_rst_n;
    assign hip_aib_fsr_in[1] = i_ehip_tx_rst_n;
    assign hip_aib_fsr_in[0] = i_ehip_rst_n;
    assign hip_aib_ssr_in[239:3] = 237'b0;
    assign hip_aib_ssr_in[2] = i_ehip_clear_internal_err;
    assign hip_aib_ssr_in[1] = 1'b1;
    assign hip_aib_ssr_in[0] = i_ehip_signal_ok;

    wire [MAX_CLKOUT_CH-1:0]               rx_clkout;
    wire [MAX_CLKOUT_CH-1:0]               tx_clkout;
    wire [MAX_CLKOUT_CH-1:0]               rx_clkout2;
    wire [MAX_CLKOUT_CH-1:0]               tx_clkout2;

    assign sl_tx_coreclkin [SL_LANES-1:0] = enable_external_aib_clocking ? {SL_LANES{i_aib_clk}}    : i_sl_clk_tx[SL_LANES-1:0];
    assign sl_rx_coreclkin [SL_LANES-1:0] = enable_external_aib_clocking ? {SL_LANES{i_aib_clk}}    : i_sl_clk_rx[SL_LANES-1:0];
    assign sl_tx_coreclkin2[SL_LANES-1:0] = enable_external_aib_clocking ? {SL_LANES{i_aib_2x_clk}} : {SL_LANES{1'b0}};

    assign o_tx_clk_div64 = tx_clkout;
    assign o_rx_clk_div64 = rx_clkout;
    assign o_tx_clk_div66 = tx_clkout2;
    assign o_rx_clk_div66 = rx_clkout2;


    // Single Lane Datapath
    wire [SL_LANES-1:0][79:0]    sl_tx_parallel_data;
    wire [SL_LANES-1:0][79:0]    sl_rx_parallel_data;
    reg  [SL_LANES-1:0]          sl_tx_ready_r;

    wire [LANES6*78-1:0]      ehip_aib_sync_data_in;

    wire [LANES6*3-1:0] elane_ehip_ptp_deskewed_byte_offset;        //        elane_ehip_ptp_deskewed_byte_offset.elane_ehip_ptp_deskewed_byte_offset
    wire [LANES6*3-1:0] elane_ehip_ptp_deskewed_ins_type;           //           elane_ehip_ptp_deskewed_ins_type.elane_ehip_ptp_deskewed_ins_type
    wire [LANES6*24-1:0]elane_ehip_ptp_deskewed_ts;                 //                 elane_ehip_ptp_deskewed_ts.elane_ehip_ptp_deskewed_ts
    wire [LANES6*2-1:0] elane_ehip_ptp_deskewed_tx_fp;              //              elane_ehip_ptp_deskewed_tx_fp.elane_ehip_ptp_deskewed_tx_fp
    wire [LANES6-1:0]   elane_ehip_ptp_lane_deskew_deskew_marker;   //   elane_ehip_ptp_lane_deskew_deskew_marker.elane_ehip_ptp_lane_deskew_deskew_marker
    wire [LANES6-1:0]   elane_ehip_ptp_lane_deskew_got_marker;      //      elane_ehip_ptp_lane_deskew_got_marker.elane_ehip_ptp_lane_deskew_got_marker
    wire [LANES6*6-1:0] elane_ehip_ptp_lane_deskew_tap_sel_one_hot; // elane_ehip_ptp_lane_deskew_tap_sel_one_hot.elane_ehip_ptp_lane_deskew_tap_sel_one_hot
    wire [LANES6*3-1:0] elane_ehip_ptp_mac_byte_offset;             //             elane_ehip_ptp_mac_byte_offset.elane_ehip_ptp_mac_byte_offset
    wire [LANES6*3-1:0] elane_ehip_ptp_mac_ins_type;                //                elane_ehip_ptp_mac_ins_type.elane_ehip_ptp_mac_ins_type
    wire [LANES6*24-1:0]elane_ehip_ptp_mac_ts;                      //                      elane_ehip_ptp_mac_ts.elane_ehip_ptp_mac_ts
    wire [LANES6*2-1:0] elane_ehip_ptp_mac_tx_fp;                   //                   elane_ehip_ptp_mac_tx_fp.elane_ehip_ptp_mac_tx_fp
    wire [LANES6-1:0]   elane_ehip_shared_clk;                      //                      elane_ehip_shared_clk.elane_ehip_shared_clk

    wire [LANES4-1:0]   sl_rsfec_signal_ok;
    wire sl_rsfec_o_fec_ready;


    genvar                  sli;

    wire [SL_LANES-1:0]     sl_tx_dl_async_pulse;
    wire [SL_LANES-1:0]     sl_rx_dl_async_pulse;
    wire [SL_LANES-1:0]     sl_latency_sclk;
    wire [SL_LANES-1:0]     sl_tx_dl_measure_sel;
    wire [SL_LANES-1:0]     sl_rx_dl_measure_sel;


    generate
        for(sli = 0; sli < 4; sli++) begin : SL_PARALLEL_DATA_LOOP
            if(sli < SL_LANES) begin : SL_PARALLEL_DATA_SYNTH
                alt_xcvr_resync_std #(
                    .SYNC_CHAIN_LENGTH  (3),
                    .WIDTH              (1),
                    .INIT_VALUE         (0)
                ) sl_rx_aib_reset_sync_inst (
                    .clk                (i_sl_clk_rx[sli]),
                    .reset              (1'b0),
                    .d                  (i_sl_rx_aib_reset[sli]),
                    .q                  (sl_rx_aib_reset_sync[sli])
                );

                alt_cpriphy_c3_dp_mux #(
                    .INCLUDE_ALTERNATE_PORTS    (cpri_include_alternate_ports),
                    .EHIP_MODE                  (ehip_mode_sl_0), // used when INCLUDE_ALTERNATE_PORTS = 0
                    .REGISTER_TX_OUTPUT         (1),
                    .REGISTER_RX_INPUT          (1)
                )
                sl_dp_mux (
                    //Clock, reset, and mux select ports
                    .i_sl_clk_tx                (i_sl_clk_tx            [sli]),
                    .i_sl_clk_rx                (i_sl_clk_rx            [sli]),
                    .i_sl_tx_rst_n              (1'b1                        ), // Do not reset TX path for output register, else TX deskew will not work
                    .i_sl_rx_rst_n              (!sl_rx_aib_reset_sync  [sli]),
                    .i_sl_dp_sel                (i_sl_dp_sel            [sli]), // 0=MAC,1=MAC(PTP),2=PCS,3=PCS66(OTN),4=PCS66,else=PMA
                                                                                // used when INCLUDE_ALTERNATE_PORTS = "enable"

                    //Shared TX ports for the MAC, PCS, and PCS66 modes
                    .i_sl_stats_snapshot        (i_sl_stats_snapshot    [sli]),
                    .i_sl_custom_cadence        (i_sl_custom_cadence    [sli]),
                    .i_sl_deskew                (i_sl_tx_aib_dsk        [sli]),

                    // MAC Interface
                    .i_sl_tx_data               (i_sl_tx_data           [sli]),
                    .i_sl_tx_error              (i_sl_tx_error          [sli]),
                    .i_sl_tx_empty              (i_sl_tx_empty          [sli]),
                    .i_sl_tx_skip_crc           (i_sl_tx_skip_crc       [sli]),
                    .i_sl_tx_valid              (i_sl_tx_valid          [sli]),
                    .i_sl_tx_inframe            (i_sl_tx_inframe        [sli]),
                    .o_sl_tx_ready              (),

                    .o_sl_rx_data               (o_sl_rx_data           [sli]),
                    .o_sl_rx_empty              (o_sl_rx_empty          [sli]),
                    .o_sl_rx_fcs_error          (o_sl_rx_fcs_error      [sli]),
                    .o_sl_rx_error              (o_sl_rx_error          [sli]),
                    .o_sl_rx_status             (o_sl_rx_status         [sli]),
                    .o_sl_rx_inframe            (o_sl_rx_inframe        [sli]),
                    .o_sl_rx_valid              (o_sl_rx_valid          [sli]),

                    // PCS Interface
                    .i_sl_tx_mii_d              (i_sl_tx_mii_d          [sli]),
                    .i_sl_tx_mii_c              (i_sl_tx_mii_c          [sli]),
                    .i_sl_tx_mii_valid          (i_sl_tx_mii_valid      [sli]),
                    .i_sl_tx_mii_am             (i_sl_tx_mii_am         [sli]),
                    .o_sl_tx_mii_ready          (o_sl_tx_mii_ready      [sli]),

                    .o_sl_rx_mii_d              (o_sl_rx_mii_d          [sli]),
                    .o_sl_rx_mii_c              (o_sl_rx_mii_c          [sli]),
                    .o_sl_rx_mii_valid          (o_sl_rx_mii_valid      [sli]),
                    .o_sl_rx_mii_am_valid       (o_sl_rx_mii_am_valid   [sli]),

                    // PCS66 Interface
                    .i_sl_tx_pcs66_d            (i_sl_tx_pcs66_d        [sli]),
                    .i_sl_tx_pcs66_valid        (i_sl_tx_pcs66_valid    [sli]),
                    .i_sl_tx_pcs66_am           (i_sl_tx_pcs66_am       [sli]),
                    .o_sl_tx_pcs66_ready        (o_sl_tx_pcs66_ready    [sli]),

                    .o_sl_rx_pcs66_d            (o_sl_rx_pcs66_d        [sli]),
                    .o_sl_rx_pcs66_valid        (o_sl_rx_pcs66_valid    [sli]),
                    .o_sl_rx_pcs66_am_valid     (o_sl_rx_pcs66_am_valid [sli]),

                    // PMA Direct Interface
                    .i_sl_tx_pma                (i_sl_tx_pma            [sli]),
                    .o_sl_rx_pma                (o_sl_rx_pma            [sli]),

                    // AIB Interface
                    .i_aib_rx_data              (sl_rx_parallel_data    [sli]),
                    .o_aib_tx_data              (sl_tx_parallel_data    [sli]),

                    // PTP Interface
                    .i_sl_ptp_sclk              (i_sl_sclk              [sli]),
                    .i_sl_ptp_tx_sel_sclk_return(i_sl_tx_sel_sclk_return[sli]),
                    .i_sl_ptp_rx_sel_sclk_return(i_sl_rx_sel_sclk_return[sli]),
                    .o_sl_ptp_tx_sclk_return    (o_sl_tx_sclk_return    [sli]),
                    .o_sl_ptp_rx_sclk_return    (o_sl_rx_sclk_return    [sli]),

                    // Deterministic Latency Interface
                    .i_sl_latency_sclk          (i_sl_latency_sclk      [sli]),
                    .i_sl_tx_dl_measure_sel     (i_sl_tx_dl_measure_sel [sli]),
                    .i_sl_rx_dl_measure_sel     (i_sl_rx_dl_measure_sel [sli]),
                    .o_sl_tx_dl_async_pulse     (o_sl_tx_dl_async_pulse [sli]),
                    .o_sl_rx_dl_async_pulse     (o_sl_rx_dl_async_pulse [sli]),

                    // Native PHY Interface for DL
                    .o_sl_latency_sclk          (sl_latency_sclk        [sli]),
                    .o_sl_tx_dl_measure_sel     (sl_tx_dl_measure_sel   [sli]),
                    .o_sl_rx_dl_measure_sel     (sl_rx_dl_measure_sel   [sli]),
                    .i_sl_tx_dl_async_pulse     (sl_tx_dl_async_pulse   [sli]),
                    .i_sl_rx_dl_async_pulse     (sl_rx_dl_async_pulse   [sli])
                );

                always @(posedge i_sl_clk_rx[sli]) begin
                    sl_tx_ready_r[sli] <= sl_rx_parallel_data[sli][76];
                end

                assign o_sl_tx_ready[sli]                     = sl_tx_ready_r[sli];
                assign o_sl_rx_aib_dsk[sli]                   = sl_rx_parallel_data[sli][78];
                assign o_sl_rx_aib_dsk_done[sli]              = 1'b0;
            end
        end
    endgenerate

    assign o_ehip_clk = 1'b0;
    assign o_ehip_dist_fr_rx_clk = 1'b0;
    assign o_fec_dist_fr_rx_clk = 1'b0;
    assign h2a_rx_ehip_rst_n = 1'b0;
    assign elane_ehip_ptp_mac_tx_fp = '0;
    assign elane_ehip_ptp_mac_ts = '0;
    assign elane_ehip_ptp_mac_ins_type = '0;
    assign elane_ehip_ptp_mac_byte_offset = '0;
    assign elane_ehip_ptp_deskewed_tx_fp = '0;
    assign elane_ehip_ptp_deskewed_ts = '0;
    assign elane_ehip_ptp_deskewed_ins_type = '0;
    assign elane_ehip_ptp_deskewed_byte_offset = '0;
    assign elane_ehip_ptp_lane_deskew_got_marker = '0;
    assign elane_ehip_ptp_lane_deskew_tap_sel_one_hot = '0;
    assign elane_ehip_ptp_lane_deskew_deskew_marker = '0;
    assign ehip_aib_sync_data_in = '0;


    generate
    //for (sli=0; sli<SL_LANES; sli++) begin : SL_NPHY_PMAD
    if ((ehip_mode_sl_0 == "ehip_disable") && (ENABLE_RSFEC == 0) && (ENABLE_RSFEC_MODE == 0)
        ) begin : SL_NPHY_PMAD // Single Lane

        assign elane_ehip_shared_clk = {LANES6{o_ehip_clk}};

        assign o_rsfec_channel_ssr = '0;
        assign o_rsfec_reconfig_readdata = '0;
        assign o_rsfec_reconfig_waitrequest = '0;

        `ifdef ALTERA_RESERVED_QIS
            ex_10G_alt_cpriphy_c3_xcvrnphy_fme_1961_zc6nr6a altera_xcvr_native_inst (
        `else
            ex_10G_alt_cpriphy_c3_xcvrnphy_fme_1961_kdzmh3a altera_xcvr_native_inst (
        `endif

                .aib_ehip_rx_ehip_clk                       ({SL_LANES{o_ehip_clk}}),                               //input,   width = 1, 
                .aib_ehip_rx_ehip_fr_clk                    ({SL_LANES{o_ehip_dist_fr_rx_clk}}),                    //input,   width = 1, 
                .aib_ehip_rx_fec_fr_clk                     ({SL_LANES{o_fec_dist_fr_rx_clk}}),                     //input,   width = 1, 
                .aib_ehip_rx_sync_data                      (ehip_aib_sync_data_in[LOCATION_SEL*78+:SL_LANES*78]),  //input,   width = 78, 
                .aib_ehip_tx_ehip_clk                       ({SL_LANES{o_ehip_clk}}),                               //input,   width = 1, 

                .ehip_aib_aib_status                        (),             //output,  width = 3,
                .ehip_aib_tx_sync_data                      (),             //output,  width = 78,
                .ehip_aib_tx_transfer_div2_clk              (),             //output,  width = 1,
                .ehip_elane_am_detect                       (),             //input,   width = 1, 
                .ehip_elane_am_insert                       (),             //input,   width = 1, 
                .ehip_elane_ptp_fifo_share_rd_en            (),             //input,   width = 1, 
                .ehip_elane_ptp_fifo_share_wr_en            (),             //input,   width = 1, 
                .ehip_elane_ptp_tx_ts                       (),             //input,   width = 12, 
                .ehip_elane_ptp_tx_ts_fp                    (),             //input,   width = 2, 
                .ehip_elane_ptp_tx_ts_valid                 (),             //input,   width = 1, 
                .ehip_elane_rx_ptp_ts                       (),             //input,   width = 23, 
                .ehip_elane_shared_clear                    (),             //input,   width = 1, 
                .ehip_elane_shared_dsk_done                 (),             //input,   width = 1, 

                .ehip_pma_tx_pma_clk                        (),             //output,  width = 1,
                .ehip_pmaRsfec_fec_rx_data                  (),             //output,  width = 66
                .ehip_pmaRsfec_fec_rx_data_am_valid         (),             //output,  width = 1
                .ehip_pmaRsfec_fec_rx_data_valid            (),             //output,  width = 1

                .elane_ehip_ptp_deskewed_byte_offset        (elane_ehip_ptp_deskewed_byte_offset[LOCATION_SEL*3+:SL_LANES*3]),          //output,   width = 3,
                .elane_ehip_ptp_deskewed_ins_type           (elane_ehip_ptp_deskewed_ins_type[LOCATION_SEL*3+:SL_LANES*3]),             //output,   width = 3,
                .elane_ehip_ptp_deskewed_ts                 (elane_ehip_ptp_deskewed_ts[LOCATION_SEL*24+:SL_LANES*24]),                 //output,   width = 24,
                .elane_ehip_ptp_deskewed_tx_fp              (elane_ehip_ptp_deskewed_tx_fp[LOCATION_SEL*2+:SL_LANES*2]),                //output,   width = 2,
                .elane_ehip_ptp_lane_deskew_deskew_marker   (elane_ehip_ptp_lane_deskew_deskew_marker[LOCATION_SEL+:SL_LANES]),         //output,   width = 1,
                .elane_ehip_ptp_lane_deskew_got_marker      (elane_ehip_ptp_lane_deskew_got_marker[LOCATION_SEL+:SL_LANES]),            //output,   width = 1,
                .elane_ehip_ptp_lane_deskew_tap_sel_one_hot (elane_ehip_ptp_lane_deskew_tap_sel_one_hot[LOCATION_SEL*6+:SL_LANES*6]),   //output,   width = 6,
                .elane_ehip_ptp_mac_byte_offset             (elane_ehip_ptp_mac_byte_offset[LOCATION_SEL*3+:SL_LANES*3]),               //output,   width = 3,
                .elane_ehip_ptp_mac_ins_type                (elane_ehip_ptp_mac_ins_type[LOCATION_SEL*3+:SL_LANES*3]),                  //output,   width = 3,
                .elane_ehip_ptp_mac_ts                      (elane_ehip_ptp_mac_ts[LOCATION_SEL*24+:SL_LANES*24]),                      //output,   width = 24,
                .elane_ehip_ptp_mac_tx_fp                   (elane_ehip_ptp_mac_tx_fp[LOCATION_SEL*2+:SL_LANES*2]),                     //output,   width = 2,
                .elane_ehip_shared_clk                      (elane_ehip_shared_clk[LOCATION_SEL+:SL_LANES]),                            //output,   width = 1,

                .enh_clear_internal_error                   (i_sl_clear_internal_err),              //input,   width = 1, 
                .enh_force_rcfg_reset                       (i_sl_force_rcfg_reset),                //input,   width = 1, 
                .enh_initialized                            (o_sl_cfg_load_done),                   //output,  width = 1,
                .enh_internal_error                         (o_sl_internal_err),                    //output,  width = 1,
                .enh_pld_ready                              (i_sl_ehip_pld_ready),                  //input,   width = 1, 
                .enh_ready                                  (o_sl_ehip_ready),                      //output,  width = 1,
                .enh_reset                                  (~i_sl_ehip_reset),                     //input,   width = 1, 
                .enh_reset_stat                             (o_sl_ehip_reset_stat),                 //output,  width = 1,
                .hip_aib_fsr_in                             (hip_aib_fsr_in[SL_LANES*4-1:0]),
                .hip_aib_ssr_in                             (hip_aib_ssr_in[SL_LANES*40-1:0]),
                .EHIP_out_o_xcvrif_aib_fsr_out              (),                                     //output,  width = 1.
                .latency_sclk                               (sl_latency_sclk),                      //input,   width = 1
                .osc_transfer_en                            (),                                     //output,  width = 1,
                .pll_refclk0                                (sl_refclk[0]),                         //input,   width = 1, 
                .pll_refclk1                                (sl_refclk[1]),                         //input,   width = 1, 
                .pll_refclk2                                (sl_refclk[2]),                         //input,   width = 1, 
                .pll_refclk3                                (sl_refclk[3]),                         //input,   width = 1, 
                .pll_refclk4                                (sl_refclk[4]),                         //input,   width = 1, 
                .pma_ehip_rx_ehip_clk_div2                  ({SL_LANES{1'b0}}),                     //input,   width = 1
                .pma_ehip_rx_ehip_fifo_rst_n                ({SL_LANES{h2a_rx_ehip_rst_n}}),        //input,   width = 1, 
                .pma_ehip_tx_ehip_clk_div2                  ({SL_LANES{1'b0}}),                     //input,   width = 1
                .pmaRsfec_ehip_tx_ehip_data                 ({SL_LANES{66'd0}}),                    //input,   width = 66
                .pmaRsfec_ehip_tx_ehip_data_am_valid_in     ({SL_LANES{1'b0}}),                     //input,   width = 1
                .pmaRsfec_ehip_tx_ehip_dv                   ({SL_LANES{1'b0}}),                     //input,   width = 1
                .pmaRsfec_ehip_tx_ehip_fifo_rst_n           ({SL_LANES{1'b0}}),                     //input,   width = 1

                .reconfig_clk                               ({SL_LANES{i_reconfig_clk}}),           //input,   width = 1, 
                .reconfig_reset                             ({SL_LANES{i_xcvr_reconfig_reset}}),    //input,   width = 1, 
                .reconfig_address                           (i_xcvr_reconfig_address),              //input,   width = 20, 
                .reconfig_write                             (i_xcvr_reconfig_write),                //input,   width = 1, 
                .reconfig_read                              (i_xcvr_reconfig_read),                 //input,   width = 1, 
                .reconfig_writedata                         (i_xcvr_reconfig_writedata),            //input,   width = 32, 
                .reconfig_readdata                          (o_xcvr_reconfig_readdata),             //output,  width = 32,
                .reconfig_waitrequest                       (o_xcvr_reconfig_waitrequest),          //output,  width = 1,

                .RSFEC_ehip_clock                           (o_ehip_clk),                           //input,   width=1;
                .RSFEC_ehip_tx_adpt_clock                   ({SL_LANES{1'b0}}),                     //input,   width=1;
                
                // .reset                                      (i_sl_pmad_reset),                      //input,   width = 1, 
                .tx_reset                                   (i_sl_tx_reset),
                .rx_reset                                   (i_sl_rx_reset),
                .tx_ready                                   (o_sl_tx_nphy_ready),                   //output,  width = 1,
                .rx_ready                                   (o_sl_rx_nphy_ready),                   //output,  width = 1,
                // .rx_aib_reset                               (i_sl_rx_aib_reset),                 //input,   width = 1, 
                // .tx_aib_reset                               (i_sl_tx_aib_reset),                 //input,   width = 1, 
                // .rx_pmaif_reset                             (i_sl_rx_pmaif_reset),               //input,   width = 1, 
                // .tx_pmaif_reset                             (i_sl_tx_pmaif_reset),               //input,   width = 1, 
                .rx_clkout                                  (rx_clkout[MAX_XCVR_CH-1:0]),           //output,  width = 1,
                .rx_clkout2                                 (rx_clkout2[MAX_XCVR_CH-1:0]),          //output,  width = 1,
                .rx_coreclkin                               (sl_rx_coreclkin),                      //input,   width = 1, 
                .rx_dl_async_pulse                          (sl_rx_dl_async_pulse),                 //input,   width = 1, 
                .rx_dl_measure_sel                          (sl_rx_dl_measure_sel),                 //input,   width = 1, 
                .rx_enh_aligned                             (o_sl_rx_pcs_fully_aligned),            //output,  width = 1,
                .rx_enh_blk_lock                            (o_sl_rx_block_lock),                   //output,  width = 1,
                .rx_enh_highber                             (o_sl_rx_hi_ber),                       //output,  width = 1,
                .rx_enh_local_fault                         (o_sl_local_fault_status),              //output,  width = 1,
                .rx_enh_pause                               (o_sl_rx_pause),                        //output,  width = 1,
                .rx_enh_pfc                                 (o_sl_rx_pfc),                          //output,  width = 8,
                .rx_enh_pmaif_fifo_overflow                 (o_sl_xcvr_rxfifo_overflow),            //output,  width = 1,
                .rx_enh_remote_fault                        (o_sl_remote_fault_status),             //output,  width = 1,
                .rx_enh_reset                               (~i_sl_ehip_rx_reset),                  //input,   width = 1,
                .rx_enh_reset_stat                          (o_sl_ehip_rx_reset_stat),              //output,  width = 1,
                .rx_enh_signal_ok                           (i_sl_ehip_signal_ok),                  //input,   width = 1, 
                .rx_fifo_empty                              (o_sl_aib_rxfifo_empty),                //output,  width = 1,
                .rx_fifo_pfull                              (o_sl_aib_rxfifo_pfull),                //output,  width = 1,
                .rx_fifo_full                               (o_sl_aib_rxfifo_full),                 //output,  width = 1,
                .rx_fifo_pempty                             (o_sl_aib_rxfifo_pempty),               //output,  width = 1,
                .rx_fifo_ready                              (o_sl_rx_fifo_ready),                   //output,  width = 1,
                .rx_fifo_rd_en                              (i_sl_aib_rxfifo_rd_en),                //input,   width = 1, 
                .rx_fifo_latency_adj_ena                    (i_sl_aib_rxfifo_latency_adj_ena),      //input,   width = 1, 
                .rx_is_lockedtodata                         (o_sl_rx_is_lockedtodata),              //output,  width = 1,
                .rx_parallel_data                           (sl_rx_parallel_data),                  //output,  width = 80,
                .rx_pma_ready                               (o_sl_rx_pma_ready),                    //output,  width = 1,
                .rx_serial_data                             (i_rx_serial_data),                     //input,   width = 1, 
                .rx_serial_data_n                           (i_rx_serial_data_n),                   //input,   width = 1, 
                .rx_transfer_ready                          (sl_rx_transfer_ready),                 //output,  width = 1,
                .tx_clkout                                  (tx_clkout[MAX_XCVR_CH-1:0]),           //output,  width = 1,
                .tx_clkout2                                 (tx_clkout2[MAX_XCVR_CH-1:0]),          //output,  width = 1,
                .tx_coreclkin                               (sl_tx_coreclkin),                      //input,   width = 1, 
                .tx_coreclkin2                              (sl_tx_coreclkin2),                     //input,   width = 1,
                .tx_dl_async_pulse                          (sl_tx_dl_async_pulse),                 //input,   width = 1, 
                .tx_dl_measure_sel                          (sl_tx_dl_measure_sel),                 //input,   width = 1, 
                .tx_dll_lock                                (o_sl_tx_dll_lock),                     //output,  width = 1,
                .tx_enh_pause                               (i_sl_tx_pause),                        //input,   width = 1, 
                .tx_enh_pfc                                 (i_sl_tx_pfc),                          //input,   width = 8, 
                .tx_enh_pmaif_fifo_almost_empty             (o_sl_xcvr_txfifo_pempty),              //output,  width = 1,
                .tx_enh_pmaif_fifo_almost_full              (o_sl_xcvr_txfifo_pfull),               //output,  width = 1,
                .tx_enh_pmaif_fifo_overflow                 (o_sl_xcvr_txfifo_overflow),            //output,  width = 1,
                .tx_enh_pmaif_fifo_underflow                (o_sl_xcvr_txfifo_underflow),           //output,  width = 1,
                .tx_enh_reset                               (~i_sl_ehip_tx_reset),                  //input,   width = 1, 
                .tx_enh_reset_stat                          (o_sl_ehip_tx_reset_stat),              //output,  width = 1,
                .tx_fifo_empty                              (o_sl_aib_txfifo_empty),
                .tx_fifo_full                               (o_sl_aib_txfifo_full),
                .tx_fifo_pempty                             (o_sl_aib_txfifo_pempty),
                .tx_fifo_pfull                              (o_sl_aib_txfifo_pfull),
                .tx_fifo_ready                              (o_sl_tx_fifo_ready),                   //output,  width = 1,
                .tx_parallel_data                           (sl_tx_parallel_data),                  //input,   width = 80, 
                .tx_pma_ready                               (sl_tx_pma_ready),                      //output,  width = 1,
                .tx_serial_data                             (o_tx_serial_data),                     //output,  width = 1,
                .tx_serial_data_n                           (o_tx_serial_data_n),                   //output,  width = 1,
                .tx_transfer_ready                          (sl_tx_transfer_ready)                  //output,  width = 1,
            );

    end // Single Lane SL_NPHY_PMAD
  //end
    else
    //for (sli=0; sli<SL_LANES; sli++) begin : SL_NPHY_PCS
    if ((ENABLE_RSFEC == 0) && (ENABLE_RSFEC_MODE == 0)
        ) begin : SL_NPHY // Single Lane

        assign elane_ehip_shared_clk = {LANES6{o_ehip_clk}};

        assign o_rsfec_channel_ssr = '0;
        assign o_rsfec_reconfig_readdata = '0;
        assign o_rsfec_reconfig_waitrequest = '0;
        assign o_sl_tx_nphy_ready = '0;
        assign o_sl_rx_nphy_ready = '0;

        `ifdef ALTERA_RESERVED_QIS
            ex_10G_alt_cpriphy_c3_xcvrnphy_fme_1961_zc6nr6a altera_xcvr_native_inst (
        `else
            ex_10G_alt_cpriphy_c3_xcvrnphy_fme_1961_kdzmh3a altera_xcvr_native_inst (
        `endif

                .aib_ehip_rx_ehip_clk                       ({SL_LANES{o_ehip_clk}}),                     //input,   width = 1, 
                .aib_ehip_rx_ehip_fr_clk                    ({SL_LANES{o_ehip_dist_fr_rx_clk}}),                     //input,   width = 1, 
                .aib_ehip_rx_fec_fr_clk                     ({SL_LANES{o_fec_dist_fr_rx_clk}}),                      //input,   width = 1, 
                .aib_ehip_rx_sync_data                      (ehip_aib_sync_data_in[LOCATION_SEL*78+:SL_LANES*78]),            //input,  width = 78, 
                .aib_ehip_tx_ehip_clk                       ({SL_LANES{o_ehip_clk}}),                     //input,   width = 1, 

                .ehip_aib_aib_status                        (),                  //output,   width = 3,
                .ehip_aib_tx_sync_data                      (),            //output,  width = 78,
                .ehip_aib_tx_transfer_div2_clk              (),                                      //output,   width = 1,
                .ehip_elane_am_detect                       (),             //input,   width = 1, 
                .ehip_elane_am_insert                       (),             //input,   width = 1, 
                .ehip_elane_ptp_fifo_share_rd_en            (),         //input,   width = 1, 
                .ehip_elane_ptp_fifo_share_wr_en            (),         //input,   width = 1, 
                .ehip_elane_ptp_tx_ts                       (),             //input,  width = 12, 
                .ehip_elane_ptp_tx_ts_fp                    (),                 //input,   width = 2, 
                .ehip_elane_ptp_tx_ts_valid                 (),              //input,   width = 1, 
                .ehip_elane_rx_ptp_ts                       (),             //input,  width = 23, 
                .ehip_elane_shared_clear                    (),                 //input,   width = 1, 
                .ehip_elane_shared_dsk_done                 (),              //input,   width = 1, 

                .ehip_pma_tx_pma_clk                        (),                              //output,   width = 1,
                .ehip_pmaRsfec_fec_rx_data                  (),                                //output,  width = 66
                .ehip_pmaRsfec_fec_rx_data_am_valid         (),                                //output,  width = 1
                .ehip_pmaRsfec_fec_rx_data_valid            (),                                //output,  width = 1

                .elane_ehip_ptp_deskewed_byte_offset        (elane_ehip_ptp_deskewed_byte_offset[LOCATION_SEL*3+:SL_LANES*3]),        //output,   width = 3,
                .elane_ehip_ptp_deskewed_ins_type           (elane_ehip_ptp_deskewed_ins_type[LOCATION_SEL*3+:SL_LANES*3]),               //output,   width = 3,
                .elane_ehip_ptp_deskewed_ts                 (elane_ehip_ptp_deskewed_ts[LOCATION_SEL*24+:SL_LANES*24]),                //output,  width = 24,
                .elane_ehip_ptp_deskewed_tx_fp              (elane_ehip_ptp_deskewed_tx_fp[LOCATION_SEL*2+:SL_LANES*2]),              //output,   width = 2,
                .elane_ehip_ptp_lane_deskew_deskew_marker   (elane_ehip_ptp_lane_deskew_deskew_marker[LOCATION_SEL+:SL_LANES]),   //output,   width = 1,
                .elane_ehip_ptp_lane_deskew_got_marker      (elane_ehip_ptp_lane_deskew_got_marker[LOCATION_SEL+:SL_LANES]),      //output,   width = 1,
                .elane_ehip_ptp_lane_deskew_tap_sel_one_hot (elane_ehip_ptp_lane_deskew_tap_sel_one_hot[LOCATION_SEL*6+:SL_LANES*6]), //output,   width = 6,
                .elane_ehip_ptp_mac_byte_offset             (elane_ehip_ptp_mac_byte_offset[LOCATION_SEL*3+:SL_LANES*3]),             //output,   width = 3,
                .elane_ehip_ptp_mac_ins_type                (elane_ehip_ptp_mac_ins_type[LOCATION_SEL*3+:SL_LANES*3]),                //output,   width = 3,
                .elane_ehip_ptp_mac_ts                      (elane_ehip_ptp_mac_ts[LOCATION_SEL*24+:SL_LANES*24]),            //output,  width = 24,
                .elane_ehip_ptp_mac_tx_fp                   (elane_ehip_ptp_mac_tx_fp[LOCATION_SEL*2+:SL_LANES*2]),                   //output,   width = 2,
                .elane_ehip_shared_clk                      (elane_ehip_shared_clk[LOCATION_SEL+:SL_LANES]),            //output,   width = 1,

                .enh_clear_internal_error                   (i_sl_clear_internal_err),                    //input,   width = 1, 
                .enh_force_rcfg_reset                       (i_sl_force_rcfg_reset),                     //input,   width = 1, 
                .enh_initialized                            (o_sl_cfg_load_done),                          //output,   width = 1,
                .enh_internal_error                         (o_sl_internal_err),                       //output,   width = 1,
                .enh_pld_ready                              (i_sl_ehip_pld_ready),                    //input,   width = 1, 
                .enh_ready                                  (o_sl_ehip_ready),                        //output,   width = 1,
                .enh_reset                                  (~i_sl_ehip_reset),                        //input,   width = 1, 
                .enh_reset_stat                             (o_sl_ehip_reset_stat),                   //output,   width = 1,
                .hip_aib_fsr_in                             (hip_aib_fsr_in[SL_LANES*4-1:0]),
                .hip_aib_ssr_in                             (hip_aib_ssr_in[SL_LANES*40-1:0]),
                .latency_sclk                               (sl_latency_sclk),                               //                               latency_sclk.latency_sclk
                .osc_transfer_en                            (),                                  //output,   width = 1,
                .pll_refclk0                                (sl_refclk[0]),                              //input,   width = 1, 
                .pll_refclk1                                (sl_refclk[1]),                              //input,   width = 1, 
                .pll_refclk2                                (sl_refclk[2]),                              //input,   width = 1, 
                .pll_refclk3                                (sl_refclk[3]),                              //input,   width = 1, 
                .pll_refclk4                                (sl_refclk[4]),                              //input,   width = 1, 
                .pma_ehip_rx_ehip_clk_div2                  (),                                //input,   width = 
                .pma_ehip_rx_ehip_fifo_rst_n                ({SL_LANES{h2a_rx_ehip_rst_n}}),                     //input,   width = 1, 
                .pma_ehip_tx_ehip_clk_div2                  (),                                //input,   width = 1
                .pmaRsfec_ehip_tx_ehip_data                 (),                                //input,   width = 66
                .pmaRsfec_ehip_tx_ehip_data_am_valid_in     (),                                //input,   width = 1
                .pmaRsfec_ehip_tx_ehip_dv                   (),                                //input,   width = 1
                .pmaRsfec_ehip_tx_ehip_fifo_rst_n           (),                                //input,   width = 1

                .reconfig_clk                               ({SL_LANES{i_reconfig_clk}}),                     //input,   width = 1, 
                .reconfig_reset                             ({SL_LANES{i_xcvr_reconfig_reset}}),                   //input,   width = 1, 
                .reconfig_address                           (i_xcvr_reconfig_address),             //input,  width = 20, 
                .reconfig_write                             (i_xcvr_reconfig_write),                   //input,   width = 1, 
                .reconfig_read                              (i_xcvr_reconfig_read),                    //input,   width = 1, 
                .reconfig_writedata                         (i_xcvr_reconfig_writedata),           //input,  width = 32, 
                .reconfig_readdata                          (o_xcvr_reconfig_readdata),            //output,  width = 32,
                .reconfig_waitrequest                       (o_xcvr_reconfig_waitrequest),             //output,   width = 1,

                .RSFEC_ehip_clock                           (o_ehip_clk),                                //input, width=1;
                .RSFEC_ehip_tx_adpt_clock                   (),                                //input, width=1;

                .rx_aib_reset                               (i_sl_rx_aib_reset),                             //input,   width = 1, 
                .rx_clkout                                  (rx_clkout[MAX_XCVR_CH-1:0]),                                //output,   width = 1,
                .rx_clkout2                                 (rx_clkout2[MAX_XCVR_CH-1:0]),                               //output,   width = 1,
                .rx_coreclkin                               (sl_rx_coreclkin),                         //input,   width = 1, 
                .rx_dl_async_pulse                          (sl_rx_dl_async_pulse),                          //                          rx_dl_async_pulse.rx_dl_async_pulse
                .rx_dl_measure_sel                          (sl_rx_dl_measure_sel),                          //                          rx_dl_measure_sel.rx_dl_measure_sel
                .rx_enh_aligned                             (o_sl_rx_pcs_fully_aligned),                           //output,   width = 1,
                .rx_enh_blk_lock                            (o_sl_rx_block_lock),                          //output,   width = 1,
                .rx_enh_highber                             (o_sl_rx_hi_ber),                           //output,   width = 1,
                .rx_enh_local_fault                         (o_sl_local_fault_status),                       //output,   width = 1,
                .rx_enh_pause                               (o_sl_rx_pause),                             //output,   width = 1,
                .rx_enh_pfc                                 (o_sl_rx_pfc),                               //output,   width = 8,
                .rx_enh_pmaif_fifo_overflow                 (o_sl_xcvr_rxfifo_overflow),                         //output,   width = 1,
                .rx_enh_remote_fault                        (o_sl_remote_fault_status),                      //output,   width = 1,
                .rx_enh_reset                               (~i_sl_ehip_rx_reset),                        //input,   width = 1,
                .rx_enh_reset_stat                          (o_sl_ehip_rx_reset_stat),                        //output,   width = 1,
                .rx_enh_signal_ok                           (i_sl_ehip_signal_ok),                         //input,   width = 1, 
                .rx_fifo_empty                              (o_sl_aib_rxfifo_empty),
                .rx_fifo_pfull                              (o_sl_aib_rxfifo_pfull),
                .rx_fifo_full                               (o_sl_aib_rxfifo_full),
                .rx_fifo_pempty                             (o_sl_aib_rxfifo_pempty),
                .rx_fifo_ready                              (o_sl_rx_fifo_ready),                            //output,   width = 1,
                .rx_fifo_rd_en                              (i_sl_aib_rxfifo_rd_en),
                .rx_fifo_latency_adj_ena                    (i_sl_aib_rxfifo_latency_adj_ena),
                .rx_is_lockedtodata                         (o_sl_rx_is_lockedtodata),               //output,   width = 1,
                .rx_parallel_data                           (sl_rx_parallel_data),                 //output,  width = 80,
                .rx_pma_ready                               (o_sl_rx_pma_ready),                     //output,   width = 1,
                .rx_pmaif_reset                             (i_sl_rx_pmaif_reset),                           //input,   width = 1, 
                .rx_serial_data                             (i_rx_serial_data),                           //input,   width = 1, 
                .rx_serial_data_n                           (i_rx_serial_data_n),                         //input,   width = 1, 
                .rx_transfer_ready                          (sl_rx_transfer_ready),                //output,   width = 1,
                .tx_aib_reset                               (i_sl_tx_aib_reset),                             //input,   width = 1, 
                .tx_clkout                                  (tx_clkout[MAX_XCVR_CH-1:0]),                                //output,   width = 1,
                .tx_clkout2                                 (tx_clkout2[MAX_XCVR_CH-1:0]),                               //output,   width = 1,
                .tx_coreclkin                               (sl_tx_coreclkin),                         //input,   width = 1, 
                .tx_coreclkin2                              (sl_tx_coreclkin2),                               //   input,    width = 1,                               tx_coreclkin.clk
                .tx_dl_async_pulse                          (sl_tx_dl_async_pulse),                          //                          tx_dl_async_pulse.tx_dl_async_pulse
                .tx_dl_measure_sel                          (sl_tx_dl_measure_sel),                          //                          tx_dl_measure_sel.tx_dl_measure_sel
                .tx_dll_lock                                (o_sl_tx_dll_lock),                      //output,   width = 1,
                .tx_enh_pause                               (i_sl_tx_pause),                     //input,   width = 1, 
                .tx_enh_pfc                                 (i_sl_tx_pfc),                       //input,   width = 8, 
                .tx_enh_pmaif_fifo_almost_empty             (o_sl_xcvr_txfifo_pempty),            //output,   width = 1,
                .tx_enh_pmaif_fifo_almost_full              (o_sl_xcvr_txfifo_pfull),             //output,   width = 1,
                .tx_enh_pmaif_fifo_overflow                 (o_sl_xcvr_txfifo_overflow),                //output,   width = 1,
                .tx_enh_pmaif_fifo_underflow                (o_sl_xcvr_txfifo_underflow),               //output,   width = 1,
                .tx_enh_reset                               (~i_sl_ehip_tx_reset),                     //input,   width = 1, 
                .tx_enh_reset_stat                          (o_sl_ehip_tx_reset_stat),                //output,   width = 1,
                .tx_fifo_empty                              (o_sl_aib_txfifo_empty),
                .tx_fifo_full                               (o_sl_aib_txfifo_full),
                .tx_fifo_pempty                             (o_sl_aib_txfifo_pempty),
                .tx_fifo_pfull                              (o_sl_aib_txfifo_pfull),
                .tx_fifo_ready                              (o_sl_tx_fifo_ready),                    //output,   width = 1,
                .tx_parallel_data                           (sl_tx_parallel_data),                 //input,  width = 80, 
                .tx_pma_ready                               (sl_tx_pma_ready),                     //output,   width = 1,
                .tx_pmaif_reset                             (i_sl_tx_pmaif_reset),                   //input,   width = 1, 
                .tx_serial_data                             (o_tx_serial_data),                   //output,   width = 1,
                .tx_serial_data_n                           (o_tx_serial_data_n),                                 //output,   width = 1,
                .tx_transfer_ready                          (sl_tx_transfer_ready)                 //output,   width = 1,
            );

    end // Single Lane SL_NPHY
  //end
    else
  //for (sli=0; sli<SL_LANES; sli++) begin : SL_NPHY_RSFEC
    if ((ENABLE_RSFEC != 0) || (ENABLE_RSFEC_MODE != 0)
        ) begin : SL_NPHY_RSFEC // Single Lane

        assign elane_ehip_shared_clk = {LANES6{o_ehip_clk}};
        
        assign sl_rsfec_not_align[0] = o_rsfec_channel_ssr[8*LOCATION_SEL+2];
        assign sl_rsfec_not_align[1] = o_rsfec_channel_ssr[8*1+2];
        assign sl_rsfec_not_align[2] = o_rsfec_channel_ssr[8*2+2];
        assign sl_rsfec_not_align[3] = o_rsfec_channel_ssr[8*3+2];

        assign o_sl_tx_nphy_ready = '0;
        assign o_sl_rx_nphy_ready = '0;

        for (sli=0; sli<SL_LANES; sli++) begin : SL_NPHY_RSFEC_SIGNAL_OK_CH
            assign sl_rsfec_signal_ok[sli+FIRST_LANE] = o_sl_rx_is_lockedtodata[sli] && sl_rsfec_o_fec_ready;
            assign sl_ehip_signal_ok[sli] = i_sl_enable_rsfec[sli] ? (i_sl_ehip_signal_ok[sli] && !sl_rsfec_not_align[sli+FIRST_LANE]) : i_sl_ehip_signal_ok[sli];
        end

        for (sli=0; sli<FIRST_LANE; sli++) begin : SL_NPHY_RSFEC_SIGNAL_OK_UNUSED
            assign sl_rsfec_signal_ok[sli] = 1'b1;
        end

        for (sli=FIRST_LANE+SL_LANES; sli<4; sli++) begin : SL_NPHY_RSFEC_SIGNAL_OK_UNUSED1
            assign sl_rsfec_signal_ok[sli] = 1'b1;
        end

        // The tx_pma_ready should be based on the primary clock source for multi-channel design
        // For PTP case, it is distributed from PTP channel-0.
        // For non-PTP case, the distribution depends on selection passed down to Native PHY.
        assign sl_rsfec_clock_stable = sl_tx_pma_ready[0];

        alt_xcvr_resync_std #(
            .SYNC_CHAIN_LENGTH  (3),
            .WIDTH              (1),
            .INIT_VALUE         (0)
        ) sl_rsfec_clock_stable_sync_inst (
            .clk                (i_reconfig_clk),
            .reset              (1'b0),
            .d                  (sl_rsfec_clock_stable),
            .q                  (sl_rsfec_clock_stable_sync)
        );            

        alt_xcvr_resync_std #(
            .SYNC_CHAIN_LENGTH  (3),
            .WIDTH              (LANES4),
            .INIT_VALUE         (0)
        ) sl_rsfec_not_align_sync_inst (
            .clk                (i_reconfig_clk),
            .reset              (1'b0),
            .d                  (sl_rsfec_not_align),
            .q                  (sl_rsfec_not_align_sync)
        ); 

        always @(posedge i_reconfig_clk) begin
            if(~(&sl_rsfec_not_align_sync)) begin
                sl_rsfec_reset_assert_locked <= 1'b1;
            end
            else begin
                sl_rsfec_reset_assert_locked <= 1'b0;
            end
        end

        always @(posedge i_reconfig_clk) begin
            if(!sl_rsfec_clock_stable_sync) begin
                sl_rsfec_reset_state <= STM_SL_RSFEC_RESET_INIT;
            end
            else begin
                sl_rsfec_reset_state <= sl_rsfec_reset_nextstate;
            end
        end

        always @(*) begin
            case(sl_rsfec_reset_state)
                STM_SL_RSFEC_RESET_INIT        : sl_rsfec_reset_nextstate = (&sl_rsfec_reset_count) ? STM_SL_RSFEC_RX_RESET_ASSERT : STM_SL_RSFEC_RESET_INIT;
                STM_SL_RSFEC_RX_RESET_ASSERT   : sl_rsfec_reset_nextstate = (&sl_rsfec_reset_count) ? STM_SL_RSFEC_TX_RESET_ASSERT : STM_SL_RSFEC_RX_RESET_ASSERT;
                STM_SL_RSFEC_TX_RESET_ASSERT   : sl_rsfec_reset_nextstate = (&sl_rsfec_reset_count) ? STM_SL_RSFEC_RESET_ASSERT : STM_SL_RSFEC_TX_RESET_ASSERT;
                STM_SL_RSFEC_RESET_ASSERT      : sl_rsfec_reset_nextstate = (&sl_rsfec_reset_count) ? STM_SL_RSFEC_RESET_DEASSERT : STM_SL_RSFEC_RESET_ASSERT;
                STM_SL_RSFEC_RESET_DEASSERT    : sl_rsfec_reset_nextstate = (&sl_rsfec_reset_count) ? STM_SL_RSFEC_TX_RESET_DEASSERT : STM_SL_RSFEC_RESET_DEASSERT;
                STM_SL_RSFEC_TX_RESET_DEASSERT : sl_rsfec_reset_nextstate = (&sl_rsfec_reset_count) ? STM_SL_RSFEC_RX_RESET_DEASSERT : STM_SL_RSFEC_TX_RESET_DEASSERT;
                STM_SL_RSFEC_RX_RESET_DEASSERT : sl_rsfec_reset_nextstate = STM_SL_RSFEC_RX_RESET_DEASSERT;
                default                        : sl_rsfec_reset_nextstate = STM_SL_RSFEC_RESET_INIT;
            endcase
        end

        assign sl_rsfec_reset_count_plus_one = sl_rsfec_reset_count[7:0] + 1'b1;

        always @(posedge i_reconfig_clk) begin
            if(!sl_rsfec_clock_stable_sync | sl_rsfec_reset_assert_locked) begin
                sl_rsfec_reset_count     <= 8'd0;
                sl_global_rsfec_reset    <= 1'b0;
                sl_global_rsfec_tx_reset <= 1'b0;
                sl_global_rsfec_rx_reset <= 1'b0;
            end
            else begin
                sl_rsfec_reset_count <= sl_rsfec_reset_count_plus_one[7:0];

                case(sl_rsfec_reset_state)
                    STM_SL_RSFEC_RESET_INIT : begin
                        sl_global_rsfec_reset    <= 1'b0;
                        sl_global_rsfec_tx_reset <= 1'b0;
                        sl_global_rsfec_rx_reset <= 1'b0;
                    end

                    STM_SL_RSFEC_RX_RESET_ASSERT : begin
                        sl_global_rsfec_reset    <= 1'b0;
                        sl_global_rsfec_tx_reset <= 1'b0;
                        sl_global_rsfec_rx_reset <= 1'b1;
                    end

                    STM_SL_RSFEC_TX_RESET_ASSERT : begin
                        sl_global_rsfec_reset    <= 1'b0;
                        sl_global_rsfec_tx_reset <= 1'b1;
                        sl_global_rsfec_rx_reset <= 1'b1;
                    end

                    STM_SL_RSFEC_RESET_ASSERT : begin
                        sl_global_rsfec_reset    <= 1'b1;
                        sl_global_rsfec_tx_reset <= 1'b1;
                        sl_global_rsfec_rx_reset <= 1'b1;
                    end

                    STM_SL_RSFEC_RESET_DEASSERT : begin
                        sl_global_rsfec_reset    <= 1'b0;
                        sl_global_rsfec_tx_reset <= 1'b1;
                        sl_global_rsfec_rx_reset <= 1'b1;
                    end

                    STM_SL_RSFEC_TX_RESET_DEASSERT : begin
                        sl_global_rsfec_reset    <= 1'b0;
                        sl_global_rsfec_tx_reset <= 1'b0;
                        sl_global_rsfec_rx_reset <= 1'b1;
                    end

                    STM_SL_RSFEC_RX_RESET_DEASSERT : begin
                        sl_global_rsfec_reset    <= 1'b0;
                        sl_global_rsfec_tx_reset <= 1'b0;
                        sl_global_rsfec_rx_reset <= 1'b0;
                    end

                    default: begin
                        sl_global_rsfec_reset    <= 1'b0;
                        sl_global_rsfec_tx_reset <= 1'b0;
                        sl_global_rsfec_rx_reset <= 1'b0;
                    end
                endcase
            end
        end

        alt_xcvr_resync_std #(
            .SYNC_CHAIN_LENGTH  (3),
            .WIDTH              (SL_LANES),
            .INIT_VALUE         (0)
        ) sl_ehip_pld_ready_sync_inst (
            .clk                (sl_tx_coreclkin[0]),
            .reset              (1'b0),
            .d                  (i_sl_ehip_pld_ready),
            .q                  (sl_ehip_pld_ready_sync)
        ); 

        always @(posedge sl_tx_coreclkin[0]) begin
            if(!(|sl_ehip_pld_ready_sync)) begin
                sl_rsfec_pld_ready <= 1'b0;
            end
            else if(&sl_ehip_pld_ready_sync) begin
                sl_rsfec_pld_ready <= 1'b1;
            end
        end

        `ifdef ALTERA_RESERVED_QIS
            ex_10G_alt_cpriphy_c3_xcvrnphy_fme_1961_zc6nr6a altera_xcvr_native_inst (
        `else
            ex_10G_alt_cpriphy_c3_xcvrnphy_fme_1961_kdzmh3a altera_xcvr_native_inst (
        `endif

                .aib_ehip_rx_ehip_clk                       ({SL_LANES{o_ehip_clk}}),                     //input,   width = 1, 
                .aib_ehip_rx_ehip_fr_clk                    ({SL_LANES{o_ehip_dist_fr_rx_clk}}),                     //input,   width = 1, 
                .aib_ehip_rx_fec_fr_clk                     ({SL_LANES{o_fec_dist_fr_rx_clk}}),                      //input,   width = 1, 
                .aib_ehip_rx_sync_data                      (ehip_aib_sync_data_in[LOCATION_SEL*78+:SL_LANES*78]),            //input,  width = 78, 
                .aib_ehip_tx_ehip_clk                       ({SL_LANES{o_ehip_clk}}),                     //input,   width = 1, 

                .ehip_aib_aib_status                        (),                  //output,   width = 3,
                .ehip_aib_tx_sync_data                      (),            //output,  width = 78,
                .ehip_aib_tx_transfer_div2_clk              (),                                      //output,   width = 1,
                .ehip_elane_am_detect                       (),             //input,   width = 1, 
                .ehip_elane_am_insert                       (),             //input,   width = 1, 
                .ehip_elane_ptp_fifo_share_rd_en            (),         //input,   width = 1, 
                .ehip_elane_ptp_fifo_share_wr_en            (),         //input,   width = 1, 
                .ehip_elane_ptp_tx_ts                       (),             //input,  width = 12, 
                .ehip_elane_ptp_tx_ts_fp                    (),                 //input,   width = 2, 
                .ehip_elane_ptp_tx_ts_valid                 (),              //input,   width = 1, 
                .ehip_elane_rx_ptp_ts                       (),             //input,  width = 23, 
                .ehip_elane_shared_clear                    (),                 //input,   width = 1, 
                .ehip_elane_shared_dsk_done                 (),              //input,   width = 1, 

                .ehip_pma_tx_pma_clk                        (),                              //output,   width = 1,
                .ehip_pmaRsfec_fec_rx_data                  (),                                //output,  width = 66
                .ehip_pmaRsfec_fec_rx_data_am_valid         (),                                //output,  width = 1
                .ehip_pmaRsfec_fec_rx_data_valid            (),                                //output,  width = 1

                .elane_ehip_ptp_deskewed_byte_offset        (elane_ehip_ptp_deskewed_byte_offset[LOCATION_SEL*3+:SL_LANES*3]),        //output,   width = 3,
                .elane_ehip_ptp_deskewed_ins_type           (elane_ehip_ptp_deskewed_ins_type[LOCATION_SEL*3+:SL_LANES*3]),               //output,   width = 3,
                .elane_ehip_ptp_deskewed_ts                 (elane_ehip_ptp_deskewed_ts[LOCATION_SEL*24+:SL_LANES*24]),                //output,  width = 24,
                .elane_ehip_ptp_deskewed_tx_fp              (elane_ehip_ptp_deskewed_tx_fp[LOCATION_SEL*2+:SL_LANES*2]),              //output,   width = 2,
                .elane_ehip_ptp_lane_deskew_deskew_marker   (elane_ehip_ptp_lane_deskew_deskew_marker[LOCATION_SEL+:SL_LANES]),   //output,   width = 1,
                .elane_ehip_ptp_lane_deskew_got_marker      (elane_ehip_ptp_lane_deskew_got_marker[LOCATION_SEL+:SL_LANES]),      //output,   width = 1,
                .elane_ehip_ptp_lane_deskew_tap_sel_one_hot (elane_ehip_ptp_lane_deskew_tap_sel_one_hot[LOCATION_SEL*6+:SL_LANES*6]), //output,   width = 6,
                .elane_ehip_ptp_mac_byte_offset             (elane_ehip_ptp_mac_byte_offset[LOCATION_SEL*3+:SL_LANES*3]),             //output,   width = 3,
                .elane_ehip_ptp_mac_ins_type                (elane_ehip_ptp_mac_ins_type[LOCATION_SEL*3+:SL_LANES*3]),                //output,   width = 3,
                .elane_ehip_ptp_mac_ts                      (elane_ehip_ptp_mac_ts[LOCATION_SEL*24+:SL_LANES*24]),            //output,  width = 24,
                .elane_ehip_ptp_mac_tx_fp                   (elane_ehip_ptp_mac_tx_fp[LOCATION_SEL*2+:SL_LANES*2]),                   //output,   width = 2,
                .elane_ehip_shared_clk                      (elane_ehip_shared_clk[LOCATION_SEL+:SL_LANES]),            //output,   width = 1,

                .enh_clear_internal_error                   (i_sl_clear_internal_err),                    //input,   width = 1, 
                .enh_force_rcfg_reset                       (i_sl_force_rcfg_reset),                     //input,   width = 1, 
                .enh_initialized                            (o_sl_cfg_load_done),                          //output,   width = 1,
                .enh_internal_error                         (o_sl_internal_err),                       //output,   width = 1,
                .enh_pld_ready                              (i_sl_ehip_pld_ready),                    //input,   width = 1, 
                .enh_ready                                  (o_sl_ehip_ready),                        //output,   width = 1,
                .enh_reset                                  (~i_sl_ehip_reset),                        //input,   width = 1, 
                .enh_reset_stat                             (o_sl_ehip_reset_stat),                   //output,   width = 1,
                .i_rsfec_pld_ready                          (sl_rsfec_pld_ready),
                .hip_aib_fsr_in                             (hip_aib_fsr_in[SL_LANES*4-1:0]),
                .hip_aib_ssr_in                             (hip_aib_ssr_in[SL_LANES*40-1:0]),
                .latency_sclk                               (sl_latency_sclk),                               //                               latency_sclk.latency_sclk
                .o_rsfec_channel_ssr                        (o_rsfec_channel_ssr),
                .osc_transfer_en                            (),                                  //output,   width = 1,
                .pll_refclk0                                (sl_refclk[0]),                              //input,   width = 1, 
                .pll_refclk1                                (sl_refclk[1]),                              //input,   width = 1, 
                .pll_refclk2                                (sl_refclk[2]),                              //input,   width = 1, 
                .pll_refclk3                                (sl_refclk[3]),                              //input,   width = 1, 
                .pll_refclk4                                (sl_refclk[4]),                              //input,   width = 1, 
                .pma_ehip_rx_ehip_clk_div2                  (),                                //input,   width = 
                .pma_ehip_rx_ehip_fifo_rst_n                ({SL_LANES{h2a_rx_ehip_rst_n}}),                     //input,   width = 1, 
                .pma_ehip_tx_ehip_clk_div2                  (),                                //input,   width = 1
                .pmaRsfec_ehip_tx_ehip_data                 (),                                //input,   width = 66
                .pmaRsfec_ehip_tx_ehip_data_am_valid_in     (),                                //input,   width = 1
                .pmaRsfec_ehip_tx_ehip_dv                   (),                                //input,   width = 1
                .pmaRsfec_ehip_tx_ehip_fifo_rst_n           (),                                //input,   width = 1

                .reconfig_clk                               ({SL_LANES{i_reconfig_clk}}),                     //input,   width = 1, 
                .reconfig_reset                             ({SL_LANES{i_xcvr_reconfig_reset}}),                   //input,   width = 1, 
                .reconfig_address                           (i_xcvr_reconfig_address),             //input,  width = 20, 
                .reconfig_write                             (i_xcvr_reconfig_write),                   //input,   width = 1, 
                .reconfig_read                              (i_xcvr_reconfig_read),                    //input,   width = 1, 
                .reconfig_writedata                         (i_xcvr_reconfig_writedata),           //input,  width = 32, 
                .reconfig_readdata                          (o_xcvr_reconfig_readdata),            //output,  width = 32,
                .reconfig_waitrequest                       (o_xcvr_reconfig_waitrequest),             //output,   width = 1,
                //enable rsfec
                .reconfig_rsfec_write                       (i_rsfec_reconfig_write),                     //input,   width = 1, //for rsfec enable 
                .reconfig_rsfec_read                        (i_rsfec_reconfig_read),                      //input,   width = 1, 
                .reconfig_rsfec_address                     (i_rsfec_reconfig_addr),                      //input,  width = 11, 
                .reconfig_rsfec_writedata                   (i_rsfec_reconfig_writedata),                    //input,  width = 32, 
                .reconfig_rsfec_readdata                    (o_rsfec_reconfig_readdata),        //output,  width = 32,
                .reconfig_rsfec_waitrequest                 (o_rsfec_reconfig_waitrequest),                         //output,   width = 1,
                .reconfig_rsfec_clk                         (i_reconfig_clk),                       //input,   width = 1, 
                .reconfig_rsfec_reset                       (i_xcvr_reconfig_reset),                     //input,   width = 1, 

                .RSFEC_ehip_clock                           (o_ehip_clk),                                //input, width=1;
                .RSFEC_ehip_tx_adpt_clock                   (i_sl_clk_tx),                                //input, width=1;
                .rsfec_reset                                (sl_global_rsfec_reset),
                .rsfec_signal_ok                            (sl_rsfec_signal_ok),
                .rsfec_usr_avmm2_rst                        (1'b0),
                .rsfec_o_config_done                        (),
                .rsfec_o_fec_ready                          (sl_rsfec_o_fec_ready),
                .rsfec_o_internal_error                     (),
                .rsfec_o_status_rx_not_align                (),
                .rsfec_o_status_rx_not_deskew               (),
                .rsfec_o_tx_dsk_valid                       (),

                .rx_aib_reset                               (i_sl_rx_aib_reset),                             //input,   width = 1, 
                .rx_clkout                                  (rx_clkout[MAX_XCVR_CH-1:0]),                                //output,   width = 1,
                .rx_clkout2                                 (rx_clkout2[MAX_XCVR_CH-1:0]),                               //output,   width = 1,
                .rx_coreclkin                               (sl_rx_coreclkin),                         //input,   width = 1, 
                .rx_dl_async_pulse                          (sl_rx_dl_async_pulse),                          //                          rx_dl_async_pulse.rx_dl_async_pulse
                .rx_dl_measure_sel                          (sl_rx_dl_measure_sel),                          //                          rx_dl_measure_sel.rx_dl_measure_sel
                .rx_enh_aligned                             (o_sl_rx_pcs_fully_aligned),                           //output,   width = 1,
                .rx_enh_blk_lock                            (o_sl_rx_block_lock),                          //output,   width = 1,
                .rx_enh_highber                             (o_sl_rx_hi_ber),                           //output,   width = 1,
                .rx_enh_local_fault                         (o_sl_local_fault_status),                       //output,   width = 1,
                .rx_enh_pause                               (o_sl_rx_pause),                             //output,   width = 1,
                .rx_enh_pfc                                 (o_sl_rx_pfc),                               //output,   width = 8,
                .rx_enh_pmaif_fifo_overflow                 (o_sl_xcvr_rxfifo_overflow),                         //output,   width = 1,
                .rx_enh_remote_fault                        (o_sl_remote_fault_status),                      //output,   width = 1,
                .rx_enh_reset                               (~i_sl_ehip_rx_reset),                        //input,   width = 1,
                .rx_enh_reset_stat                          (o_sl_ehip_rx_reset_stat),                        //output,   width = 1,
                .rx_enh_signal_ok                           (sl_ehip_signal_ok[SL_LANES-1:0]),                         //input,   width = 1, 
                .rx_fifo_empty                              (o_sl_aib_rxfifo_empty),
                .rx_fifo_pfull                              (o_sl_aib_rxfifo_pfull),
                .rx_fifo_full                               (o_sl_aib_rxfifo_full),
                .rx_fifo_pempty                             (o_sl_aib_rxfifo_pempty),
                .rx_fifo_ready                              (o_sl_rx_fifo_ready),                            //output,   width = 1,
                .rx_fifo_rd_en                              (i_sl_aib_rxfifo_rd_en),
                .rx_fifo_latency_adj_ena                    (i_sl_aib_rxfifo_latency_adj_ena),
                .rx_is_lockedtodata                         (o_sl_rx_is_lockedtodata),               //output,   width = 1,
                .rx_parallel_data                           (sl_rx_parallel_data),                 //output,  width = 80,
                .rx_pma_ready                               (o_sl_rx_pma_ready),                     //output,   width = 1,
                .rx_pmaif_reset                             (i_sl_rx_pmaif_reset),                           //input,   width = 1, 
                .rx_rsfec_reset                             (sl_global_rsfec_rx_reset),
                .rx_serial_data                             (i_rx_serial_data),                           //input,   width = 1, 
                .rx_serial_data_n                           (i_rx_serial_data_n),                         //input,   width = 1, 
                .rx_transfer_ready                          (sl_rx_transfer_ready),                //output,   width = 1,
                .tx_aib_reset                               (i_sl_tx_aib_reset),                             //input,   width = 1, 
                .tx_clkout                                  (tx_clkout[MAX_XCVR_CH-1:0]),                                //output,   width = 1,
                .tx_clkout2                                 (tx_clkout2[MAX_XCVR_CH-1:0]),                               //output,   width = 1,
                .tx_coreclkin                               (sl_tx_coreclkin),                         //input,   width = 1, 
                .tx_coreclkin2                              (sl_tx_coreclkin2),                               //   input,    width = 2,                               tx_coreclkin.clk
                .tx_dl_async_pulse                          (sl_tx_dl_async_pulse),                          //                          tx_dl_async_pulse.tx_dl_async_pulse
                .tx_dl_measure_sel                          (sl_tx_dl_measure_sel),                          //                          tx_dl_measure_sel.tx_dl_measure_sel
                .tx_dll_lock                                (o_sl_tx_dll_lock),                      //output,   width = 1,
                .tx_enh_pause                               (i_sl_tx_pause),                     //input,   width = 1, 
                .tx_enh_pfc                                 (i_sl_tx_pfc),                       //input,   width = 8, 
                .tx_enh_pmaif_fifo_almost_empty             (o_sl_xcvr_txfifo_pempty),            //output,   width = 1,
                .tx_enh_pmaif_fifo_almost_full              (o_sl_xcvr_txfifo_pfull),             //output,   width = 1,
                .tx_enh_pmaif_fifo_overflow                 (o_sl_xcvr_txfifo_overflow),                //output,   width = 1,
                .tx_enh_pmaif_fifo_underflow                (o_sl_xcvr_txfifo_underflow),               //output,   width = 1,
                .tx_enh_reset                               (~i_sl_ehip_tx_reset),                     //input,   width = 1, 
                .tx_enh_reset_stat                          (o_sl_ehip_tx_reset_stat),                //output,   width = 1,
                .tx_fifo_empty                              (o_sl_aib_txfifo_empty),
                .tx_fifo_full                               (o_sl_aib_txfifo_full),
                .tx_fifo_pempty                             (o_sl_aib_txfifo_pempty),
                .tx_fifo_pfull                              (o_sl_aib_txfifo_pfull),
                .tx_fifo_ready                              (o_sl_tx_fifo_ready),                    //output,   width = 1,
                .tx_parallel_data                           (sl_tx_parallel_data),                 //input,  width = 80, 
                .tx_pma_ready                               (sl_tx_pma_ready),                     //output,   width = 1,
                .tx_pmaif_reset                             (i_sl_tx_pmaif_reset),                   //input,   width = 1, 
                .tx_rsfec_reset                             (sl_global_rsfec_tx_reset),
                .tx_serial_data                             (o_tx_serial_data),                   //output,   width = 1,
                .tx_serial_data_n                           (o_tx_serial_data_n),                                 //output,   width = 1,
                .tx_transfer_ready                          (sl_tx_transfer_ready)                 //output,   width = 1,
            );

    end // Single Lane SL_NPHY_RSFEC
    //end
    else begin
        assign sl_tx_transfer_ready = '0;
        assign sl_rx_transfer_ready = '0;
        assign o_sl_rx_pcs_fully_aligned = '0;
        assign o_sl_rx_hi_ber = '0;

        assign o_rsfec_channel_ssr = '0;
        assign o_rsfec_reconfig_readdata = '0;
        assign o_rsfec_reconfig_waitrequest = '0;
        assign o_sl_tx_nphy_ready = '0;
        assign o_sl_rx_nphy_ready = '0;
    end
    endgenerate

endmodule // alt_cpriphy_c3_hard


