	component ex_10G is
		generic (
			sim_mode : string := "enable"
		);
		port (
			o_cdr_lock                        : out std_logic_vector(3 downto 0);                      -- o_cdr_lock
			o_tx_pll_locked                   : out std_logic_vector(3 downto 0);                      -- o_tx_pll_locked
			i_clk_ref                         : in  std_logic_vector(4 downto 0)   := (others => 'X'); -- i_clk_ref
			o_tx_clkout                       : out std_logic_vector(3 downto 0);                      -- o_tx_clkout
			o_tx_clkout2                      : out std_logic_vector(3 downto 0);                      -- o_tx_clkout2
			o_rx_clkout                       : out std_logic_vector(3 downto 0);                      -- o_rx_clkout
			o_rx_clkout2                      : out std_logic_vector(3 downto 0);                      -- o_rx_clkout2
			i_sampling_clk                    : in  std_logic                      := 'X';             -- i_sampling_clk
			o_tx_serial                       : out std_logic_vector(3 downto 0);                      -- o_tx_serial
			i_rx_serial                       : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- i_rx_serial
			i_reconfig_clk                    : in  std_logic                      := 'X';             -- clk
			i_reconfig_reset                  : in  std_logic                      := 'X';             -- i_reconfig_reset
			i_xcvr_reconfig_address           : in  std_logic_vector(75 downto 0)  := (others => 'X'); -- i_xcvr_reconfig_address
			i_xcvr_reconfig_read              : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- i_xcvr_reconfig_read
			i_xcvr_reconfig_write             : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- i_xcvr_reconfig_write
			o_xcvr_reconfig_readdata          : out std_logic_vector(31 downto 0);                     -- o_xcvr_reconfig_readdata
			i_xcvr_reconfig_writedata         : in  std_logic_vector(31 downto 0)  := (others => 'X'); -- i_xcvr_reconfig_writedata
			o_xcvr_reconfig_waitrequest       : out std_logic_vector(3 downto 0);                      -- o_xcvr_reconfig_waitrequest
			o_sl_rx_hi_ber                    : out std_logic_vector(3 downto 0);                      -- o_sl_rx_hi_ber
			i_sl_cpri_reconfig_addr           : in  std_logic_vector(75 downto 0)  := (others => 'X'); -- i_sl_cpri_reconfig_addr
			i_sl_cpri_reconfig_read           : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- i_sl_cpri_reconfig_read
			i_sl_cpri_reconfig_write          : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- i_sl_cpri_reconfig_write
			o_sl_cpri_reconfig_readdata       : out std_logic_vector(127 downto 0);                    -- o_sl_cpri_reconfig_readdata
			o_sl_cpri_reconfig_readdata_valid : out std_logic_vector(3 downto 0);                      -- o_sl_cpri_reconfig_readdata_valid
			i_sl_cpri_reconfig_writedata      : in  std_logic_vector(127 downto 0) := (others => 'X'); -- i_sl_cpri_reconfig_writedata
			o_sl_cpri_reconfig_waitrequest    : out std_logic_vector(3 downto 0);                      -- o_sl_cpri_reconfig_waitrequest
			o_sl_tx_lanes_stable              : out std_logic_vector(3 downto 0);                      -- o_sl_tx_lanes_stable
			o_sl_rx_pcs_ready                 : out std_logic_vector(3 downto 0);                      -- o_sl_rx_pcs_ready
			o_sl_ehip_ready                   : out std_logic_vector(3 downto 0);                      -- o_sl_ehip_ready
			o_sl_rx_block_lock                : out std_logic_vector(3 downto 0);                      -- o_sl_rx_block_lock
			i_sl_clk_tx                       : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- i_sl_clk_tx
			i_sl_clk_rx                       : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- i_sl_clk_rx
			i_sl_csr_rst_n                    : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- i_sl_csr_rst_n
			i_sl_tx_rst_n                     : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- i_sl_tx_rst_n
			i_sl_rx_rst_n                     : in  std_logic_vector(3 downto 0)   := (others => 'X'); -- i_sl_rx_rst_n
			i_aib_clk                         : in  std_logic                      := 'X';             -- i_aib_clk
			i_aib_2x_clk                      : in  std_logic                      := 'X';             -- i_aib_2x_clk
			i_sl_tx_mii_d                     : in  std_logic_vector(255 downto 0) := (others => 'X'); -- i_sl_tx_mii_d
			i_sl_tx_mii_c                     : in  std_logic_vector(31 downto 0)  := (others => 'X'); -- i_sl_tx_mii_c
			o_sl_rx_mii_d                     : out std_logic_vector(255 downto 0);                    -- o_sl_rx_mii_d
			o_sl_rx_mii_c                     : out std_logic_vector(31 downto 0)                      -- o_sl_rx_mii_c
		);
	end component ex_10G;

	u0 : component ex_10G
		generic map (
			sim_mode => STRING_VALUE_FOR_sim_mode
		)
		port map (
			o_cdr_lock                        => CONNECTED_TO_o_cdr_lock,                        --                        o_cdr_lock.o_cdr_lock
			o_tx_pll_locked                   => CONNECTED_TO_o_tx_pll_locked,                   --                   o_tx_pll_locked.o_tx_pll_locked
			i_clk_ref                         => CONNECTED_TO_i_clk_ref,                         --                         i_clk_ref.i_clk_ref
			o_tx_clkout                       => CONNECTED_TO_o_tx_clkout,                       --                       o_tx_clkout.o_tx_clkout
			o_tx_clkout2                      => CONNECTED_TO_o_tx_clkout2,                      --                      o_tx_clkout2.o_tx_clkout2
			o_rx_clkout                       => CONNECTED_TO_o_rx_clkout,                       --                       o_rx_clkout.o_rx_clkout
			o_rx_clkout2                      => CONNECTED_TO_o_rx_clkout2,                      --                      o_rx_clkout2.o_rx_clkout2
			i_sampling_clk                    => CONNECTED_TO_i_sampling_clk,                    --                    i_sampling_clk.i_sampling_clk
			o_tx_serial                       => CONNECTED_TO_o_tx_serial,                       --                          serial_p.o_tx_serial
			i_rx_serial                       => CONNECTED_TO_i_rx_serial,                       --                                  .i_rx_serial
			i_reconfig_clk                    => CONNECTED_TO_i_reconfig_clk,                    --                    i_reconfig_clk.clk
			i_reconfig_reset                  => CONNECTED_TO_i_reconfig_reset,                  --                  i_reconfig_reset.i_reconfig_reset
			i_xcvr_reconfig_address           => CONNECTED_TO_i_xcvr_reconfig_address,           --           i_xcvr_reconfig_address.i_xcvr_reconfig_address
			i_xcvr_reconfig_read              => CONNECTED_TO_i_xcvr_reconfig_read,              --              i_xcvr_reconfig_read.i_xcvr_reconfig_read
			i_xcvr_reconfig_write             => CONNECTED_TO_i_xcvr_reconfig_write,             --             i_xcvr_reconfig_write.i_xcvr_reconfig_write
			o_xcvr_reconfig_readdata          => CONNECTED_TO_o_xcvr_reconfig_readdata,          --          o_xcvr_reconfig_readdata.o_xcvr_reconfig_readdata
			i_xcvr_reconfig_writedata         => CONNECTED_TO_i_xcvr_reconfig_writedata,         --         i_xcvr_reconfig_writedata.i_xcvr_reconfig_writedata
			o_xcvr_reconfig_waitrequest       => CONNECTED_TO_o_xcvr_reconfig_waitrequest,       --       o_xcvr_reconfig_waitrequest.o_xcvr_reconfig_waitrequest
			o_sl_rx_hi_ber                    => CONNECTED_TO_o_sl_rx_hi_ber,                    --                    o_sl_rx_hi_ber.o_sl_rx_hi_ber
			i_sl_cpri_reconfig_addr           => CONNECTED_TO_i_sl_cpri_reconfig_addr,           --           i_sl_cpri_reconfig_addr.i_sl_cpri_reconfig_addr
			i_sl_cpri_reconfig_read           => CONNECTED_TO_i_sl_cpri_reconfig_read,           --           i_sl_cpri_reconfig_read.i_sl_cpri_reconfig_read
			i_sl_cpri_reconfig_write          => CONNECTED_TO_i_sl_cpri_reconfig_write,          --          i_sl_cpri_reconfig_write.i_sl_cpri_reconfig_write
			o_sl_cpri_reconfig_readdata       => CONNECTED_TO_o_sl_cpri_reconfig_readdata,       --       o_sl_cpri_reconfig_readdata.o_sl_cpri_reconfig_readdata
			o_sl_cpri_reconfig_readdata_valid => CONNECTED_TO_o_sl_cpri_reconfig_readdata_valid, -- o_sl_cpri_reconfig_readdata_valid.o_sl_cpri_reconfig_readdata_valid
			i_sl_cpri_reconfig_writedata      => CONNECTED_TO_i_sl_cpri_reconfig_writedata,      --      i_sl_cpri_reconfig_writedata.i_sl_cpri_reconfig_writedata
			o_sl_cpri_reconfig_waitrequest    => CONNECTED_TO_o_sl_cpri_reconfig_waitrequest,    --    o_sl_cpri_reconfig_waitrequest.o_sl_cpri_reconfig_waitrequest
			o_sl_tx_lanes_stable              => CONNECTED_TO_o_sl_tx_lanes_stable,              --              o_sl_tx_lanes_stable.o_sl_tx_lanes_stable
			o_sl_rx_pcs_ready                 => CONNECTED_TO_o_sl_rx_pcs_ready,                 --                 o_sl_rx_pcs_ready.o_sl_rx_pcs_ready
			o_sl_ehip_ready                   => CONNECTED_TO_o_sl_ehip_ready,                   --                   o_sl_ehip_ready.o_sl_ehip_ready
			o_sl_rx_block_lock                => CONNECTED_TO_o_sl_rx_block_lock,                --                o_sl_rx_block_lock.o_sl_rx_block_lock
			i_sl_clk_tx                       => CONNECTED_TO_i_sl_clk_tx,                       --                       i_sl_clk_tx.i_sl_clk_tx
			i_sl_clk_rx                       => CONNECTED_TO_i_sl_clk_rx,                       --                       i_sl_clk_rx.i_sl_clk_rx
			i_sl_csr_rst_n                    => CONNECTED_TO_i_sl_csr_rst_n,                    --                    i_sl_csr_rst_n.i_sl_csr_rst_n
			i_sl_tx_rst_n                     => CONNECTED_TO_i_sl_tx_rst_n,                     --                     i_sl_tx_rst_n.i_sl_tx_rst_n
			i_sl_rx_rst_n                     => CONNECTED_TO_i_sl_rx_rst_n,                     --                     i_sl_rx_rst_n.i_sl_rx_rst_n
			i_aib_clk                         => CONNECTED_TO_i_aib_clk,                         --                     aib_clk_ports.i_aib_clk
			i_aib_2x_clk                      => CONNECTED_TO_i_aib_2x_clk,                      --                                  .i_aib_2x_clk
			i_sl_tx_mii_d                     => CONNECTED_TO_i_sl_tx_mii_d,                     --                      sl_mii_ports.i_sl_tx_mii_d
			i_sl_tx_mii_c                     => CONNECTED_TO_i_sl_tx_mii_c,                     --                                  .i_sl_tx_mii_c
			o_sl_rx_mii_d                     => CONNECTED_TO_o_sl_rx_mii_d,                     --                                  .o_sl_rx_mii_d
			o_sl_rx_mii_c                     => CONNECTED_TO_o_sl_rx_mii_c                      --                                  .o_sl_rx_mii_c
		);

