
namespace eval ex_10G {
  proc get_design_libraries {} {
    set libraries [dict create]
    dict set libraries altera_common_sv_packages           1
    dict set libraries xcvrnphy_fme_410                    1
    dict set libraries alt_cpriphy_c3_1961                 1
    dict set libraries altera_merlin_slave_translator_191  1
    dict set libraries altera_merlin_master_translator_191 1
    dict set libraries altera_merlin_master_agent_191      1
    dict set libraries altera_merlin_slave_agent_191       1
    dict set libraries altera_avalon_sc_fifo_1931          1
    dict set libraries altera_merlin_router_1921           1
    dict set libraries altera_merlin_demultiplexer_1921    1
    dict set libraries altera_merlin_multiplexer_1921      1
    dict set libraries altera_mm_interconnect_1920         1
    dict set libraries alt_cpriphy_c3_sl_avmm_rcfg_191     1
    dict set libraries ex_10G                              1
    return $libraries
  }
  
  proc get_memory_files {QSYS_SIMDIR} {
    set memory_files [list]
    lappend memory_files "[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/serdes.firmware.rom"]"
    lappend memory_files "[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/serdes.firmware.rom"]"
    return $memory_files
  }
  
  proc get_common_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
    set design_files [dict create]
    dict set design_files "altera_common_sv_packages::altera_xcvr_native_s10_functions_h" "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_native_s10_functions_h.sv"]\"  -work altera_common_sv_packages"
    dict set design_files "altera_common_sv_packages::alt_cpriphy_c3_package"             "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_package.sv"]\"  -work altera_common_sv_packages"         
    return $design_files
  }
  
  proc get_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
    set design_files [list]
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_arbiter.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/mentor/alt_xcvr_arbiter.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                 
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_std_synchronizer_nocut.v"]\"  -work xcvrnphy_fme_410"                                                                                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_resync_std.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                     
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/s10_avmm_h_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_native_avmm_csr_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_native_rcfg_arb.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_native_rx_reset_seq_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_native_tx_reset_seq_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_reset_counter_s10_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_reset_control_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_reset_top_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_ical_int_table.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_ical_top_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_ical_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_pma_spico_reset_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                       
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_native_dskw_pam4.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_resync_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                   
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_std_synchronizer_nocut_etile.v"]\"  -work xcvrnphy_fme_410"                                                                                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/ex_10G_xcvrnphy_fme_410_nfrv6oi.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_native_rcfg_opt_logic_nfrv6oi.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                  
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/ex_10G_alt_cpriphy_c3_xcvrnphy_fme_1961_zc6nr6a.v"]\"  -work alt_cpriphy_c3_1961"                                                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_arbiter.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/mentor/alt_xcvr_arbiter.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                 
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_std_synchronizer_nocut.v"]\"  -work xcvrnphy_fme_410"                                                                                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_resync_std.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                     
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/s10_avmm_h_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_native_avmm_csr_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_native_rcfg_arb.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_native_rx_reset_seq_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_native_tx_reset_seq_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_reset_counter_s10_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_reset_control_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_reset_top_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_ical_int_table.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_ical_top_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_ical_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_pma_spico_reset_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                       
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_xcvr_native_dskw_pam4.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_resync_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                                   
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/altera_std_synchronizer_nocut_etile.v"]\"  -work xcvrnphy_fme_410"                                                                                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/ex_10G_xcvrnphy_fme_410_o7oz4fq.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_410/sim/alt_xcvr_native_rcfg_opt_logic_o7oz4fq.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_410"                                                  
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/ex_10G_alt_cpriphy_c3_xcvrnphy_fme_1961_kdzmh3a.v"]\"  -work alt_cpriphy_c3_1961"                                                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_slave_translator_191/sim/ex_10G_altera_merlin_slave_translator_191_x56fcki.sv"]\" -L altera_common_sv_packages -work altera_merlin_slave_translator_191"   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_master_translator_191/sim/ex_10G_altera_merlin_master_translator_191_g7h47bq.sv"]\" -L altera_common_sv_packages -work altera_merlin_master_translator_191"
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_master_agent_191/sim/ex_10G_altera_merlin_master_agent_191_mpbm6tq.sv"]\" -L altera_common_sv_packages -work altera_merlin_master_agent_191"               
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_slave_agent_191/sim/ex_10G_altera_merlin_slave_agent_191_ncfkfri.sv"]\" -L altera_common_sv_packages -work altera_merlin_slave_agent_191"                  
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_slave_agent_191/sim/altera_merlin_burst_uncompressor.sv"]\" -L altera_common_sv_packages -work altera_merlin_slave_agent_191"                              
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_avalon_sc_fifo_1931/sim/ex_10G_altera_avalon_sc_fifo_1931_fzgstwy.v"]\"  -work altera_avalon_sc_fifo_1931"                                                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_router_1921/sim/ex_10G_altera_merlin_router_1921_snzeu6a.sv"]\" -L altera_common_sv_packages -work altera_merlin_router_1921"                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_router_1921/sim/ex_10G_altera_merlin_router_1921_fcdqtmq.sv"]\" -L altera_common_sv_packages -work altera_merlin_router_1921"                              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_demultiplexer_1921/sim/ex_10G_altera_merlin_demultiplexer_1921_jmq6taq.sv"]\" -L altera_common_sv_packages -work altera_merlin_demultiplexer_1921"         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_multiplexer_1921/sim/ex_10G_altera_merlin_multiplexer_1921_jkzpava.sv"]\" -L altera_common_sv_packages -work altera_merlin_multiplexer_1921"               
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_multiplexer_1921/sim/altera_merlin_arbitrator.sv"]\" -L altera_common_sv_packages -work altera_merlin_multiplexer_1921"                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_demultiplexer_1921/sim/ex_10G_altera_merlin_demultiplexer_1921_6naommy.sv"]\" -L altera_common_sv_packages -work altera_merlin_demultiplexer_1921"         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_multiplexer_1921/sim/ex_10G_altera_merlin_multiplexer_1921_sr4xmui.sv"]\" -L altera_common_sv_packages -work altera_merlin_multiplexer_1921"               
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_merlin_multiplexer_1921/sim/altera_merlin_arbitrator.sv"]\" -L altera_common_sv_packages -work altera_merlin_multiplexer_1921"                                    
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../altera_mm_interconnect_1920/sim/ex_10G_altera_mm_interconnect_1920_dkve4vy.v"]\"  -work altera_mm_interconnect_1920"                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_sl_avmm_rcfg_191/sim/ex_10G_alt_cpriphy_c3_sl_avmm_rcfg_191_hyq43hq.v"]\"  -work alt_cpriphy_c3_sl_avmm_rcfg_191"                                             
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_sl_avmm_rcfg.v"]\"  -work alt_cpriphy_c3_1961"                                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_lut6.v"]\"  -work alt_cpriphy_c3_1961"                                                                                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_efifo_async_fifo.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_efifo_custom_controller.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_efifo_rd_en_toggle.v"]\"  -work alt_cpriphy_c3_1961"                                                                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_efifo_top.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                   
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_efifo_wr_en_toggle.v"]\"  -work alt_cpriphy_c3_1961"                                                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_am_muxsel_gen.v"]\"  -work alt_cpriphy_c3_1961"                                                                                
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_calc_delay.v"]\"  -work alt_cpriphy_c3_1961"                                                                                   
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_latency_count_async.v"]\"  -work alt_cpriphy_c3_1961"                                                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_latency_count_rxsync.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_latency_count_txsync.v"]\"  -work alt_cpriphy_c3_1961"                                                                         
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_c3_latency_measure.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                             
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_decoder_8b10b.v"]\"  -work alt_cpriphy_c3_1961"                                                                                   
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_decoder_8b10b_top.v"]\"  -work alt_cpriphy_c3_1961"                                                                               
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_encoder_8b10b.v"]\"  -work alt_cpriphy_c3_1961"                                                                                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_ls_pcs_top.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_pcs20.v"]\"  -work alt_cpriphy_c3_1961"                                                                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_wordalign20.v"]\"  -work alt_cpriphy_c3_1961"                                                                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_x2_decoder_8b10b.v"]\"  -work alt_cpriphy_c3_1961"                                                                                
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/mentor/alt_cpriphy_x2_encoder_8b10b.v"]\"  -work alt_cpriphy_c3_1961"                                                                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_dp_mux.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_clock_mon.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_soft.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                               
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_ehip_rst.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_reset_controller.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_rx_ch_rst.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_tx_ch_rst.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_avmm_32to8.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_csr.v"]\"  -work alt_cpriphy_c3_1961"                                                                                                 
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_and3t0.v"]\"  -work alt_cpriphy_c3_1961"                                                                                              
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_and3t1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                              
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_and4t0.v"]\"  -work alt_cpriphy_c3_1961"                                                                                              
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_and4t1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                              
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_cnt6.v"]\"  -work alt_cpriphy_c3_1961"                                                                                                
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_eqc15h7cfbt2.v"]\"  -work alt_cpriphy_c3_1961"                                                                                        
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_eqc19h4e1fbt2.v"]\"  -work alt_cpriphy_c3_1961"                                                                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_eqc4h9t1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                            
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_eqc5h07t1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_eqc5h0ft1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_eqc5h18t1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_eqc5h1bt1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_eqc5h1ft1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                           
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_fmon8.v"]\"  -work alt_cpriphy_c3_1961"                                                                                               
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_metronome32000.v"]\"  -work alt_cpriphy_c3_1961"                                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_metronome320000.v"]\"  -work alt_cpriphy_c3_1961"                                                                                     
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_mux2w1t0s0.v"]\"  -work alt_cpriphy_c3_1961"                                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_mux2w1t0s1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_mux2w1t0s2.v"]\"  -work alt_cpriphy_c3_1961"                                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_mux2w1t1s2.v"]\"  -work alt_cpriphy_c3_1961"                                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_mux4w1t0s0.v"]\"  -work alt_cpriphy_c3_1961"                                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_mux4w1t0s1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_mux4w1t1s1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_mux8w1t2s1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                          
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_ripple16.v"]\"  -work alt_cpriphy_c3_1961"                                                                                            
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_status_sync.v"]\"  -work alt_cpriphy_c3_1961"                                                                                         
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_sync1r1.v"]\"  -work alt_cpriphy_c3_1961"                                                                                             
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/ex_10G_alt_cpriphy_c3_1961_b3tf34y.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/alt_cpriphy_c3_hard_b3tf34y.sv"]\" -L altera_common_sv_packages -work alt_cpriphy_c3_1961"                                                       
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_cpriphy_c3_1961/sim/altera_std_synchronizer_nocut.v"]\"  -work alt_cpriphy_c3_1961"                                                                                      
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/ex_10G.v"]\"  -work ex_10G"                                                                                                                                                     
    return $design_files
  }
  
  proc get_elab_options {SIMULATOR_TOOL_BITNESS} {
    set ELAB_OPTIONS ""
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ELAB_OPTIONS
  }
  
  
  proc get_sim_options {SIMULATOR_TOOL_BITNESS} {
    set SIM_OPTIONS ""
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $SIM_OPTIONS
  }
  
  
  proc get_env_variables {SIMULATOR_TOOL_BITNESS} {
    set ENV_VARIABLES [dict create]
    set LD_LIBRARY_PATH [dict create]
    dict set ENV_VARIABLES "LD_LIBRARY_PATH" $LD_LIBRARY_PATH
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ENV_VARIABLES
  }
  
  
  proc normalize_path {FILEPATH} {
      if {[catch { package require fileutil } err]} { 
          return $FILEPATH 
      } 
      set path [fileutil::lexnormalize [file join [pwd] $FILEPATH]]  
      if {[file pathtype $FILEPATH] eq "relative"} { 
          set path [fileutil::relative [pwd] $path] 
      } 
      return $path 
  } 
}
