// ex_10G.v

// Generated using ACDS version 22.1 174

`timescale 1 ps / 1 ps
module ex_10G #(
		parameter sim_mode = "enable"
	) (
		input  wire         i_reconfig_clk,                    //       i_reconfig_clk.clk,                  XCVR reconfiguration bus clock
		input  wire         i_reconfig_reset,                  //     i_reconfig_reset.reset,                XCVR reconfig reset
		input  wire         i_sampling_clk,                    //       i_sampling_clk.clk,                  Deterministic Latency sampling clock
		input  wire [4:0]   i_clk_ref,                         //            i_clk_ref.clk,                  Reference clock used by the RX PHY
		output wire [3:0]   o_tx_clkout,                       //          o_tx_clkout.clk,                  CPRI PHY system clock, this is /64 clock (380.16 MHz)
		output wire [3:0]   o_tx_clkout2,                      //         o_tx_clkout2.clk,                  This is /66 clock (368.64 MHz)
		output wire [3:0]   o_rx_clkout,                       //          o_rx_clkout.clk,                  This is /64 recovered clock (380.16 MHz)
		output wire [3:0]   o_rx_clkout2,                      //         o_rx_clkout2.clk,                  This is /66 recovered clock (368.64 MHz)
		output wire [3:0]   o_cdr_lock,                        //           o_cdr_lock.o_cdr_lock,           RX CDR Locked
		output wire [3:0]   o_tx_pll_locked,                   //      o_tx_pll_locked.o_tx_pll_locked,      TX PLL Locked
		output wire [3:0]   o_tx_serial,                       //             serial_p.o_tx_serial,          TX XCVR serial pins
		input  wire [3:0]   i_rx_serial,                       //                     .i_rx_serial,          RX XCVR serial pins
		input  wire [75:0]  i_xcvr_reconfig_address,           //  reconfig_xcvr_slave.address,              reconfig access address
		input  wire [3:0]   i_xcvr_reconfig_read,              //                     .read,                 read signal asserted to start a read cycle
		input  wire [3:0]   i_xcvr_reconfig_write,             //                     .write,                write signal asserted to write data on reconfig_writedata bus
		output wire [31:0]  o_xcvr_reconfig_readdata,          //                     .readdata,             data that was read by a read signal to indicate a valid readcycle
		input  wire [31:0]  i_xcvr_reconfig_writedata,         //                     .writedata,            data to be written on a write cycle
		output wire [3:0]   o_xcvr_reconfig_waitrequest,       //                     .waitrequest,          AVMM stalling signal. The read/write cycle is only complete when this signal goes low
		input  wire [75:0]  i_sl_cpri_reconfig_addr,           //  reconfig_cpri_slave.address,              CSR access address
		input  wire [3:0]   i_sl_cpri_reconfig_read,           //                     .read,                 read signal asserted to start a read cycle
		input  wire [3:0]   i_sl_cpri_reconfig_write,          //                     .write,                write signal asserted to write data on status_writedata bus
		output wire [127:0] o_sl_cpri_reconfig_readdata,       //                     .readdata,             data that was read by a read cycle
		output wire [3:0]   o_sl_cpri_reconfig_readdata_valid, //                     .readdatavalid,        signal to indicate a valid read
		input  wire [127:0] i_sl_cpri_reconfig_writedata,      //                     .writedata,            data to be written on a write cycle
		output wire [3:0]   o_sl_cpri_reconfig_waitrequest,    //                     .waitrequest,          AVMM stalling signal. The read/write cycle is only complete when this signal goes low
		output wire [3:0]   o_sl_rx_hi_ber,                    //       o_sl_rx_hi_ber.o_sl_rx_hi_ber,       High BER
		output wire [3:0]   o_sl_tx_lanes_stable,              // o_sl_tx_lanes_stable.o_sl_tx_lanes_stable, Asserted when TX MAC is ready to send data
		output wire [3:0]   o_sl_rx_pcs_ready,                 //    o_sl_rx_pcs_ready.o_sl_rx_pcs_ready,    Asserted when RX PCS is ready to receive data
		output wire [3:0]   o_sl_ehip_ready,                   //      o_sl_ehip_ready.o_sl_ehip_ready,      Signal to indicate EHIP CSRs are ready to access
		output wire [3:0]   o_sl_rx_block_lock,                //   o_sl_rx_block_lock.o_sl_rx_block_lock,   Asserted when 66b block alignment is finished on all PCS lanes
		input  wire [3:0]   i_sl_clk_tx,                       //          i_sl_clk_tx.clk,                  TX Avalon-ST interface clock, in synchronous mode connect o_tx_clkout to this clock
		input  wire [3:0]   i_sl_clk_rx,                       //          i_sl_clk_rx.clk,                  RX Avalon-ST interface clock, in synchronous mode connect o_tx_clkout to this clock
		input  wire [3:0]   i_sl_csr_rst_n,                    //       i_sl_csr_rst_n.reset_n,              Resets the entire CPRI core. Active low.
		input  wire [3:0]   i_sl_tx_rst_n,                     //        i_sl_tx_rst_n.reset_n,              Resets the TX digital path (MAC, PCS)
		input  wire [3:0]   i_sl_rx_rst_n,                     //        i_sl_rx_rst_n.reset_n,              Resets the RX digital path (MAC, PCS)
		input  wire         i_aib_clk,                         //            i_aib_clk.clk
		input  wire         i_aib_2x_clk,                      //         i_aib_2x_clk.clk
		input  wire [255:0] i_sl_tx_mii_d,                     //         sl_mii_ports.i_sl_tx_mii_d
		input  wire [31:0]  i_sl_tx_mii_c,                     //                     .i_sl_tx_mii_c
		output wire [255:0] o_sl_rx_mii_d,                     //                     .o_sl_rx_mii_d
		output wire [31:0]  o_sl_rx_mii_c                      //                     .o_sl_rx_mii_c
	);

	ex_10G_alt_cpriphy_c3_1961_b3tf34y #(
		.ehip_mode_sl_0               ("ehip_pcs_no_fec"),
		.cpri_rate_sl_0               ("10G"),
		.ENABLE_RSFEC                 (0),
		.enable_external_aib_clocking (1),
		.enable_rsfec_rst_ports       (0),
		.cpri_include_alternate_ports (0),
		.sim_mode                     (sim_mode)
	) alt_cpriphy_c3_0 (
		.i_reconfig_clk                    (i_reconfig_clk),                                                       //   input,    width = 1,       i_reconfig_clk.clk
		.i_reconfig_reset                  (i_reconfig_reset),                                                     //   input,    width = 1,     i_reconfig_reset.reset
		.i_sampling_clk                    (i_sampling_clk),                                                       //   input,    width = 1,       i_sampling_clk.clk
		.i_clk_ref                         (i_clk_ref),                                                            //   input,    width = 5,            i_clk_ref.clk
		.o_tx_clkout                       (o_tx_clkout),                                                          //  output,    width = 4,          o_tx_clkout.clk
		.o_tx_clkout2                      (o_tx_clkout2),                                                         //  output,    width = 4,         o_tx_clkout2.clk
		.o_rx_clkout                       (o_rx_clkout),                                                          //  output,    width = 4,          o_rx_clkout.clk
		.o_rx_clkout2                      (o_rx_clkout2),                                                         //  output,    width = 4,         o_rx_clkout2.clk
		.o_cdr_lock                        (o_cdr_lock),                                                           //  output,    width = 4,           o_cdr_lock.o_cdr_lock
		.o_tx_pll_locked                   (o_tx_pll_locked),                                                      //  output,    width = 4,      o_tx_pll_locked.o_tx_pll_locked
		.o_tx_serial                       (o_tx_serial),                                                          //  output,    width = 4,             serial_p.o_tx_serial
		.i_rx_serial                       (i_rx_serial),                                                          //   input,    width = 4,                     .i_rx_serial
		.i_xcvr_reconfig_address           (i_xcvr_reconfig_address),                                              //   input,   width = 76,  reconfig_xcvr_slave.address
		.i_xcvr_reconfig_read              (i_xcvr_reconfig_read),                                                 //   input,    width = 4,                     .read
		.i_xcvr_reconfig_write             (i_xcvr_reconfig_write),                                                //   input,    width = 4,                     .write
		.o_xcvr_reconfig_readdata          (o_xcvr_reconfig_readdata),                                             //  output,   width = 32,                     .readdata
		.i_xcvr_reconfig_writedata         (i_xcvr_reconfig_writedata),                                            //   input,   width = 32,                     .writedata
		.o_xcvr_reconfig_waitrequest       (o_xcvr_reconfig_waitrequest),                                          //  output,    width = 4,                     .waitrequest
		.i_sl_cpri_reconfig_addr           (i_sl_cpri_reconfig_addr),                                              //   input,   width = 76,  reconfig_cpri_slave.address
		.i_sl_cpri_reconfig_read           (i_sl_cpri_reconfig_read),                                              //   input,    width = 4,                     .read
		.i_sl_cpri_reconfig_write          (i_sl_cpri_reconfig_write),                                             //   input,    width = 4,                     .write
		.o_sl_cpri_reconfig_readdata       (o_sl_cpri_reconfig_readdata),                                          //  output,  width = 128,                     .readdata
		.o_sl_cpri_reconfig_readdata_valid (o_sl_cpri_reconfig_readdata_valid),                                    //  output,    width = 4,                     .readdatavalid
		.i_sl_cpri_reconfig_writedata      (i_sl_cpri_reconfig_writedata),                                         //   input,  width = 128,                     .writedata
		.o_sl_cpri_reconfig_waitrequest    (o_sl_cpri_reconfig_waitrequest),                                       //  output,    width = 4,                     .waitrequest
		.o_sl_rx_hi_ber                    (o_sl_rx_hi_ber),                                                       //  output,    width = 4,       o_sl_rx_hi_ber.o_sl_rx_hi_ber
		.o_sl_tx_lanes_stable              (o_sl_tx_lanes_stable),                                                 //  output,    width = 4, o_sl_tx_lanes_stable.o_sl_tx_lanes_stable
		.o_sl_rx_pcs_ready                 (o_sl_rx_pcs_ready),                                                    //  output,    width = 4,    o_sl_rx_pcs_ready.o_sl_rx_pcs_ready
		.o_sl_ehip_ready                   (o_sl_ehip_ready),                                                      //  output,    width = 4,      o_sl_ehip_ready.o_sl_ehip_ready
		.o_sl_rx_block_lock                (o_sl_rx_block_lock),                                                   //  output,    width = 4,   o_sl_rx_block_lock.o_sl_rx_block_lock
		.i_sl_clk_tx                       (i_sl_clk_tx),                                                          //   input,    width = 4,          i_sl_clk_tx.clk
		.i_sl_clk_rx                       (i_sl_clk_rx),                                                          //   input,    width = 4,          i_sl_clk_rx.clk
		.i_sl_csr_rst_n                    (i_sl_csr_rst_n),                                                       //   input,    width = 4,       i_sl_csr_rst_n.reset_n
		.i_sl_tx_rst_n                     (i_sl_tx_rst_n),                                                        //   input,    width = 4,        i_sl_tx_rst_n.reset_n
		.i_sl_rx_rst_n                     (i_sl_rx_rst_n),                                                        //   input,    width = 4,        i_sl_rx_rst_n.reset_n
		.i_aib_clk                         (i_aib_clk),                                                            //   input,    width = 1,            i_aib_clk.clk
		.i_aib_2x_clk                      (i_aib_2x_clk),                                                         //   input,    width = 1,         i_aib_2x_clk.clk
		.i_sl_tx_mii_d                     (i_sl_tx_mii_d),                                                        //   input,  width = 256,         sl_mii_ports.i_sl_tx_mii_d
		.i_sl_tx_mii_c                     (i_sl_tx_mii_c),                                                        //   input,   width = 32,                     .i_sl_tx_mii_c
		.o_sl_rx_mii_d                     (o_sl_rx_mii_d),                                                        //  output,  width = 256,                     .o_sl_rx_mii_d
		.o_sl_rx_mii_c                     (o_sl_rx_mii_c),                                                        //  output,   width = 32,                     .o_sl_rx_mii_c
		.o_tx_serial_n                     (),                                                                     // (terminated),                                    
		.i_rx_serial_n                     (4'b0000),                                                              // (terminated),                                    
		.i_sl_stats_snapshot               (4'b0000),                                                              // (terminated),                                    
		.i_sl_tx_mii_valid                 (4'b0000),                                                              // (terminated),                                    
		.o_sl_tx_mii_ready                 (),                                                                     // (terminated),                                    
		.o_sl_rx_mii_valid                 (),                                                                     // (terminated),                                    
		.o_sl_txfifo_pfull                 (),                                                                     // (terminated),                                    
		.o_sl_txfifo_pempty                (),                                                                     // (terminated),                                    
		.o_sl_txfifo_overflow              (),                                                                     // (terminated),                                    
		.o_sl_txfifo_underflow             (),                                                                     // (terminated),                                    
		.o_sl_mii_txfifo_pfull             (),                                                                     // (terminated),                                    
		.o_sl_mii_txfifo_pempty            (),                                                                     // (terminated),                                    
		.o_sl_mii_txfifo_overflow          (),                                                                     // (terminated),                                    
		.o_sl_mii_txfifo_underflow         (),                                                                     // (terminated),                                    
		.i_rsfec_reconfig_addr             (11'b00000000000),                                                      // (terminated),                                    
		.i_rsfec_reconfig_read             (1'b0),                                                                 // (terminated),                                    
		.i_rsfec_reconfig_write            (1'b0),                                                                 // (terminated),                                    
		.o_rsfec_reconfig_readdata         (),                                                                     // (terminated),                                    
		.o_rsfec_reconfig_readdata_valid   (),                                                                     // (terminated),                                    
		.i_rsfec_reconfig_writedata        (8'b00000000),                                                          // (terminated),                                    
		.o_rsfec_reconfig_waitrequest      (),                                                                     // (terminated),                                    
		.i_rsfec_rst_n                     (1'b1),                                                                 // (terminated),                                    
		.i_rsfec_tx_rst_n                  (1'b1),                                                                 // (terminated),                                    
		.i_rsfec_rx_rst_n                  (1'b1),                                                                 // (terminated),                                    
		.o_sl_tx_ready                     (),                                                                     // (terminated),                                    
		.o_sl_rx_ready                     (),                                                                     // (terminated),                                    
		.i_sl_tx_c                         (8'b00000000),                                                          // (terminated),                                    
		.i_sl_tx_d                         (64'b0000000000000000000000000000000000000000000000000000000000000000), // (terminated),                                    
		.o_sl_rx_c                         (),                                                                     // (terminated),                                    
		.o_sl_rx_d                         (),                                                                     // (terminated),                                    
		.o_sl_rx_patterndetect             (),                                                                     // (terminated),                                    
		.o_sl_rx_disperr                   (),                                                                     // (terminated),                                    
		.o_sl_rx_errdetect                 (),                                                                     // (terminated),                                    
		.i_sl_aib_rxfifo_latency_adj_ena   (4'b0000),                                                              // (terminated),                                    
		.i_sl_custom_cadence               (4'b0000)                                                               // (terminated),                                    
	);

endmodule
