// (C) 2001-2022 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.

// ============================================================================
// Copyright (c) 2021 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  No.80, Fenggong Rd., Hukou Township, Hsinchu County 303035 Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Wed Dec 22 14:16:44 2021
// ============================================================================

//`define ENABLE_DDR4A
//`define ENABLE_DDR4B
`define ENABLE_QSFP28
`define ENABLE_QSFP28RSV
//`define ENABLE_FMC
//`define ENABLE_FMCP
//`define ENABLE_HPS
`timescale 1ps/1ps
module alt_cpriphy_c3_hw(

      ///////// CLOCK /////////
      input              CLK_100_B2A,
      input              CLK_30M72,
      input              CLK_50_B2A,
      input              CLK_50_B2D,
      input              CLK_50_B3A,
      input              CLK_50_B3C,

      ///////// Buttons /////////
      input              CPU_RESET_n,
      input    [ 1: 0]   BUTTON, //BUTTON is Low-Active

      ///////// Swtiches /////////
      input    [ 1: 0]   SW,

      ///////// LED /////////
      output   [ 1: 0]   LED, //LED is Low-Active

`ifdef ENABLE_DDR4A
      ///////// DDR4A /////////
      input              DDR4A_REFCLK_p,
      output   [16: 0]   DDR4A_A,
      output   [ 1: 0]   DDR4A_BA,
      output   [ 1: 0]   DDR4A_BG,
      output             DDR4A_CK,
      output             DDR4A_CK_n,
      output             DDR4A_CKE,
      inout    [ 8: 0]   DDR4A_DQS,
      inout    [ 8: 0]   DDR4A_DQS_n,
      inout    [71: 0]   DDR4A_DQ,
      inout    [ 8: 0]   DDR4A_DBI_n,
      output             DDR4A_CS_n,
      output             DDR4A_RESET_n,
      output             DDR4A_ODT,
      output             DDR4A_PAR,
      input              DDR4A_ALERT_n,
      output             DDR4A_ACT_n,
      input              DDR4A_EVENT_n,
      inout              DDR4A_SCL,
      inout              DDR4A_SDA,
      input              DDR4A_RZQ,
`endif /*ENABLE_DDR4A*/

`ifdef ENABLE_DDR4B
      ///////// DDR4B /////////
      input              DDR4B_REFCLK_p,
      output   [16: 0]   DDR4B_A,
      output   [ 1: 0]   DDR4B_BA,
      output   [ 1: 0]   DDR4B_BG,
      output             DDR4B_CK,
      output             DDR4B_CK_n,
      output             DDR4B_CKE,
      inout    [ 8: 0]   DDR4B_DQS,
      inout    [ 8: 0]   DDR4B_DQS_n,
      inout    [71: 0]   DDR4B_DQ,
      inout    [ 8: 0]   DDR4B_DBI_n,
      output             DDR4B_CS_n,
      output             DDR4B_RESET_n,
      output             DDR4B_ODT,
      output             DDR4B_PAR,
      input              DDR4B_ALERT_n,
      output             DDR4B_ACT_n,
      input              DDR4B_EVENT_n,
      inout              DDR4B_SCL,
      inout              DDR4B_SDA,
      input              DDR4B_RZQ,
`endif /*ENABLE_DDR4B*/

      ///////// SI5340A /////////
      inout              SI5340A_I2C_SCL,
      inout              SI5340A_I2C_SDA,
      input              SI5340A_LOL,
      input              SI5340A_LOS_XAXB,
      output             SI5340A_OE_n,
      output             SI5340A_RST_n,

      ///////// 2x6 GPIO /////////
      inout    [ 7: 0]   GPIO_D,
`ifdef ENABLE_FMC
      ///////// FMC /////////
      inout              FMC_CLK2_BIDIR_p,
      inout              FMC_CLK2_BIDIR_n,
      inout              FMC_CLK3_BIDIR_p,
      inout              FMC_CLK3_BIDIR_n,
      output   [ 9: 0]   FMC_DP_C2M_p,
      output   [ 9: 0]   FMC_DP_C2M_n,
      input    [ 9: 0]   FMC_DP_M2C_p,
      input    [ 9: 0]   FMC_DP_M2C_n,
      inout    [23: 0]   FMC_HA_p,
      inout    [23: 0]   FMC_HA_n,
      inout    [21: 0]   FMC_HB_p,
      inout    [21: 0]   FMC_HB_n,
      inout    [33: 0]   FMC_LA_p,
      inout    [33: 0]   FMC_LA_n,
      input    [ 1: 0]   FMC_CLK_M2C_p,
      input    [ 1: 0]   FMC_GBTCLK_M2C_p,
      input              FMC_REFCLK0_p,
      input              FMC_REFCLK1_p,
      inout    [ 1: 0]   FMC_GA,
      inout    [ 0: 0]   FMC_RES,
      inout              FMC_SCL,
      inout              FMC_SDA,
`endif /*ENABLE_FMC*/

`ifdef ENABLE_FMCP
      ///////// FMCP /////////
      inout              FMCP_CLK2_BIDIR_p,
      inout              FMCP_CLK2_BIDIR_n,
      inout              FMCP_CLK3_BIDIR_p,
      inout              FMCP_CLK3_BIDIR_n,
      output   [15: 0]   FMCP_DP_C2M_p,
      output   [15: 0]   FMCP_DP_C2M_n,
      input    [15: 0]   FMCP_DP_M2C_p,
      input    [15: 0]   FMCP_DP_M2C_n,
      inout    [23: 0]   FMCP_HA_p,
      inout    [23: 0]   FMCP_HA_n,
      inout    [21: 0]   FMCP_HB_p,
      inout    [21: 0]   FMCP_HB_n,
      inout    [33: 0]   FMCP_LA_p,
      inout    [33: 0]   FMCP_LA_n,
      input    [ 1: 0]   FMCP_CLK_M2C_p,
      input    [ 1: 0]   FMCP_GBTCLK_M2C_p,
      output             FMCP_REFCLK_C2M_p,
      input              FMCP_REFCLK_M2C_p,
      inout    [ 1: 0]   FMCP_GA,
      input              FMCP_RES0,
      inout              FMCP_RES1,
      inout              FMCP_SCL,
      inout              FMCP_SDA,
      output             FMCP_SYNC_C2M_p,
      input              FMCP_SYNC_M2C_p,
`endif /*ENABLE_FMCP*/

`ifdef ENABLE_QSFP28
      ///////// QSFP28 /////////
      output   [ 3: 0]   QSFP28_TX_p,
      //output   [ 3: 0]   QSFP28_TX_n,
      input    [ 3: 0]   QSFP28_RX_p,
      //input    [ 3: 0]   QSFP28_RX_n,
      input              QSFP28_REFCLK_p,
      input              QSFP28_INTERRUPT_n,
      output             QSFP28_LP_MODE,
      input              QSFP28_MOD_PRS_n,
      output             QSFP28_MOD_SEL_n,
      output             QSFP28_RST_n,
      inout              QSFP28_SCL,
      inout              QSFP28_SDA,
`else
      input              QSFP28_REFCLK_p,
`endif /*ENABLE_QSFP28*/

`ifdef ENABLE_QSFP28RSV
      ///////// QSFP28RSV /////////
      input              QSFP28RSV_REFCLK_p,
`endif /*ENABLE_QSFP28RSV*/

      ///////// AG /////////
      output             AG_UART_TX,
      input              AG_UART_RX,
      input              AG_UART_CTS,
      output             AG_UART_RTS,

`ifdef ENABLE_HPS
      ///////// HPS /////////
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input              HPS_ENET_RX_CTL,
      input    [ 3: 0]   HPS_ENET_RX_DATA,
      output             HPS_ENET_TX_CLK,
      output             HPS_ENET_TX_CTL,
      output   [ 3: 0]   HPS_ENET_TX_DATA,
      inout    [ 4: 0]   HPS_GPIO,
      inout              HPS_I2C_SCL,
      inout              HPS_I2C_SDA,
      input              HPS_JTAG_TCK,
      input              HPS_JTAG_TDI,
      output             HPS_JTAG_TDO,
      input              HPS_JTAG_TMS,
      inout              HPS_KEY,
      inout              HPS_LED,
      input              HPS_OSC_CLK,
      output             HPS_SD_CLK,
      inout              HPS_SD_CMD,
      inout    [ 3: 0]   HPS_SD_DATA,
      input              HPS_UART_RX,
      output             HPS_UART_TX,
      input              HPS_USB_CLK,
      inout    [ 7: 0]   HPS_USB_DATA,
      input              HPS_USB_DIR,
      input              HPS_USB_NXT,
      output             HPS_USB_STP,
`endif /*ENABLE_HPS*/

      ///////// INFO /////////
      output             INFO_SPI_SCLK,
      input              INFO_SPI_MISO,
      output             INFO_SPI_MOSI,
      output             INFO_SPI_CS_n 

);

//---------------
wire        si5340a_controller_start;
wire        si5340a_config_done;
wire        tx_clkout_i_clk_ref ;
wire        tx_clkout_ref_clk156MHz;
wire        M50_1HZ ; 
wire        [1:0]HZ ;

//----- Configure SI5340A 

`define XCVR_REF_644M53125     4'h0  
`define XCVR_REF_625M          4'h1  
`define XCVR_REF_375M          4'h2  
`define XCVR_REF_322M265625    4'h3  
`define XCVR_REF_312M5         4'h4  
`define XCVR_REF_307M2         4'h5  
`define XCVR_REF_250M          4'h6  
`define XCVR_REF_184M32        4'h7 
`define XCVR_REF_156M25        4'h8 
`define XCVR_REF_153M6         4'h9
`define XCVR_REF_125M          4'hA  
`define XCVR_REF_100M          4'hB  

//----- reconfig Si5340-----
assign si5340a_controller_start = ~BUTTON[0];

AGILEX_SOM_SI5340A_CONFIG AGILEX_SOM_SI5340A_CONFIG_i(
   .iCLK  (CLK_50_B2A),
   .iRST_n(1'b1),
   .iStart(si5340a_controller_start), // rise edge trigger
   .iXCVR_REFCLK_0(`XCVR_REF_184M32),  // XCVR_REF_XXX for FMC_REFCLK0
   .iXCVR_REFCLK_1(`XCVR_REF_156M25),  // XCVR_REF_XXX for FMC_REFCLK1
   .iXCVR_REFCLK_2(`XCVR_REF_184M32),  // XCVR_REF_XXX for QSFP28REV_REFCLK
   .iXCVR_REFCLK_3(`XCVR_REF_156M25),  // XCVR_REF_XXX for QSFP28_REFCLK
   .oPLL_REG_CONFIG_DONE(si5340a_config_done),
   // si5340A conduit
   .I2C_CLK  (SI5340A_I2C_SCL),
   .I2C_DATA (SI5340A_I2C_SDA)
);



assign SI5340A_OE_n  = ~BUTTON[1] ;//1'b0;
assign SI5340A_RST_n = 1'b1;

//--1hz generater 
CLOCKMEM  ck2( .RESET_n(1), .CLK(CLK_50_B2A) ,.CLK_FREQ ( 50_000_000 )  ,.CK_1HZ( M50_1HZ ) ) ;
assign LED = (si5340a_config_done) ? { ~M50_1HZ , HZ[0]} :2'b00;//

CLOCKMEM  ck0( .RESET_n(1), .CLK(tx_clkout_i_clk_ref    ) ,.CLK_FREQ ( 184320000 )  ,.CK_1HZ( HZ[0] ) ) ;
CLOCKMEM  ck1( .RESET_n(1), .CLK(tx_clkout_ref_clk156MHz) ,.CLK_FREQ ( 156250000 )  ,.CK_1HZ( HZ[1] ) ) ;



//----view frequency by SignalTapeII --------
FRE_MEASURE fi_clk_ref     ( .RESET_n(1),.MES_CLK (tx_clkout_i_clk_ref    ) , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fref_clk156MHz ( .RESET_n(1),.MES_CLK (tx_clkout_ref_clk156MHz) , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fref_clk100MHz ( .RESET_n(1),.MES_CLK (ref_clk100MHz)           , .HZ1(M50_1HZ) , .FREQ(  ) ); 
FRE_MEASURE fCLK_50_B2A    ( .RESET_n(1),.MES_CLK (CLK_50_B2A)              , .HZ1(M50_1HZ) , .FREQ(  ) ); 


//--refclock by way of xcvrphy  to  pll_out1 
e_tile_pll visu1( .pll_refclk0( i_clk_ref         ), .pll_clkout1 ( tx_clkout_i_clk_ref  ));
e_tile_pll visu2( .pll_refclk0( ref_clk156MHz     ), .pll_clkout1 ( tx_clkout_ref_clk156MHz));

//---------------CPRI EXAMPLE-------------------------------
    parameter NUM_CHANNELS = 4 ;
	 
    //----QSFP set 
    assign QSFP28_RST_n     = 1'b1;
    assign QSFP28_LP_MODE   = SW[0]; //1'b0; // 1(SW UP): low power, 0(SW DOWN): not low power
    assign QSFP28_MOD_SEL_n = SW[1]; // 0: enable i2c
	
//---wire top -----
    wire                   tx_serial_data;
	 wire [NUM_CHANNELS-1:0] i_rx_serial ;
	 wire [NUM_CHANNELS-1:0] o_tx_serial ;
    wire i_clk_ref     ;//hz /10G rate	 
	 wire ref_clk156MHz ;//
    wire ref_clk100MHz ;//

	 assign i_rx_serial[0]   =QSFP28_RX_p[0];
	 assign i_rx_serial[1]   =QSFP28_RX_p[1];
	 assign i_rx_serial[2]   =QSFP28_RX_p[2];
	 assign i_rx_serial[3]   =QSFP28_RX_p[3];
	 
	 assign QSFP28_TX_p[0]   =o_tx_serial  [0];
	 assign QSFP28_TX_p[1]   =o_tx_serial  [1];
	 assign QSFP28_TX_p[2]   =o_tx_serial  [2];
	 assign QSFP28_TX_p[3]   =o_tx_serial  [3];
	 
    assign i_clk_ref     = QSFP28RSV_REFCLK_p; //184.32 Mhz
	 assign ref_clk156MHz = QSFP28_REFCLK_p ;   //156.25Mhz 
    assign ref_clk100MHz = CLK_100_B2A ;       //100Mhz 

	 
//------org ---------	 
    localparam COUNT_WIDTH        = 20;
    localparam DL_TOT_MEASURE_CNT = 128;
    localparam N                  = COUNT_WIDTH - $clog2(DL_TOT_MEASURE_CNT);
    localparam M                  = $clog2(DL_TOT_MEASURE_CNT) + 1;
    localparam CALC_WIDTH         = N + M;

    wire [NUM_CHANNELS-1:0]          i_xcvr_reconfig_write;
    wire [NUM_CHANNELS-1:0]          i_xcvr_reconfig_read;
    wire [(NUM_CHANNELS*19)-1:0]     i_xcvr_reconfig_address;
    wire [(NUM_CHANNELS*8)-1:0]      i_xcvr_reconfig_writedata;
    wire [(NUM_CHANNELS*8)-1:0]      o_xcvr_reconfig_readdata;
    wire [NUM_CHANNELS-1:0]          o_xcvr_reconfig_waitrequest;
    
    wire [NUM_CHANNELS-1:0]          i_sl_cpri_reconfig_write;
    wire [NUM_CHANNELS-1:0]          i_sl_cpri_reconfig_read;
    wire [(NUM_CHANNELS*19)-1:0]     i_sl_cpri_reconfig_addr;
    wire [(NUM_CHANNELS*32)-1:0]     i_sl_cpri_reconfig_writedata;
    wire [(NUM_CHANNELS*32)-1:0]     o_sl_cpri_reconfig_readdata;
    wire [NUM_CHANNELS-1:0]          o_sl_cpri_reconfig_readdata_valid;
    wire [NUM_CHANNELS-1:0]          o_sl_cpri_reconfig_waitrequest;
 
    wire [(1*11)-1:0]                i_rsfec_reconfig_addr;
    wire [1-1:0]                     i_rsfec_reconfig_read;
    wire [1-1:0]                     i_rsfec_reconfig_write;
    wire [(1*8)-1:0]                 i_rsfec_reconfig_writedata;
    wire [(1*8)-1:0]                 o_rsfec_reconfig_readdata = {NUM_CHANNELS{8'h0}};
    wire [1-1:0]                     o_rsfec_reconfig_waitrequest = {NUM_CHANNELS{1'b0}};



    wire [NUM_CHANNELS-1:0]          o_tx_clkout2;
    wire [NUM_CHANNELS-1:0]          o_rx_clkout;
    wire [NUM_CHANNELS-1:0]          o_rx_clkout2;
    wire [NUM_CHANNELS-1:0]          o_tx_clkout;

    wire                             i_reconfig_clk;
                    
    // ISSP inputs  
    // wire                             sl_csr_rst_n;
    // wire                             sl_tx_rst_n;
    // wire                             sl_rx_rst_n;
    wire [NUM_CHANNELS-1:0]          i_sl_csr_rst_n;
    wire [NUM_CHANNELS-1:0]          i_sl_tx_rst_n;
    wire [NUM_CHANNELS-1:0]          i_sl_rx_rst_n;
    wire                             i_reconfig_reset;
                    
    //ISSP or STP outputs
    wire [NUM_CHANNELS-1:0]          o_cdr_lock;
    wire [NUM_CHANNELS-1:0]          o_tx_pll_locked;
    wire [NUM_CHANNELS-1:0]          o_sl_rx_hi_ber;
    wire [NUM_CHANNELS-1:0]          o_sl_tx_lanes_stable;
    wire [NUM_CHANNELS-1:0]          o_sl_rx_pcs_ready;
    wire [NUM_CHANNELS-1:0]          o_sl_ehip_ready;
    wire [NUM_CHANNELS-1:0]          o_sl_rx_block_lock;


    wire [NUM_CHANNELS-1:0]          status_waitrequest_pio = {NUM_CHANNELS{1'b0}};
    wire [(NUM_CHANNELS*32)-1:0]     status_readdata_pio = {(NUM_CHANNELS*32){1'h0}};
    wire [NUM_CHANNELS-1:0]          status_readdata_valid_pio = {NUM_CHANNELS{1'b0}};

    wire [NUM_CHANNELS-1:0]          sel_pktgen;
    wire [(NUM_CHANNELS*32)-1:0]     status_readdata_pc = {(NUM_CHANNELS*32){1'h0}};
    wire [NUM_CHANNELS-1:0]          status_readdata_valid_pc = {NUM_CHANNELS{1'b0}};
    wire [NUM_CHANNELS-1:0]          status_waitrequest_pc = {NUM_CHANNELS{1'b0}};
    
    wire                             channel_pll_locked;
    wire                             iopll_sclk_locked;
    wire [NUM_CHANNELS-1:0]          checker_pass;
    wire                             restart;
    wire [NUM_CHANNELS-1:0][COUNT_WIDTH-1:0]          rt_count;
	 
    wire [3:0]     cpri_speed;
    wire [3:0]     cpri_speed_issp;
    wire [3:0]     cpri_speed_issp_sync;
    reg  [3:0]     cpri_speed_reg;
    wire           cpri_speed_en;
    wire           cpri_speed_en_sync;

    assign i_reconfig_clk = ref_clk100MHz;
	 
    assign cpri_speed = 4'b1001; // 10.1376G

    wire [31:0]     av_addr;
    wire            status_read;
    wire            status_write;
    wire            status_waitrequest;
    wire            status_readdata_valid;
    wire [31:0]     status_readdata;
    wire [31:0]     status_writedata;
    wire [23:0]     status_addr;
    wire            status_read_r      = status_read;
    wire            status_write_r     = status_write;
    wire [31:0]     status_writedata_r = status_writedata;
    wire [23:0]     status_addr_r      = status_addr;
   
    assign          status_addr = av_addr[25:2]; 
 
    //---------------------------------------------------------------------------------------------
    // ISSP instance 0
    genvar ch; 
    wire [NUM_CHANNELS-1:0][2:0] issp_reset;
    generate
    for (ch = 0; ch < NUM_CHANNELS; ch = ch + 1) begin: gen_issp_reset
        assign {i_sl_csr_rst_n[ch], i_sl_tx_rst_n[ch], i_sl_rx_rst_n[ch]} = issp_reset[ch];
    end
    endgenerate
    probe_reset issp_rst (
       .probe  ({issp_reset, i_reconfig_reset}),  //  probes.probe
       .source ({issp_reset, i_reconfig_reset})   // sources.source
    );

    //---------------------------------------------------------------------------------------------
    // ISSP instance 1
    wire [3:0] reserved_bit;
    probe4_sl issp_pll_lock (
        .probe ({reserved_bit[3:2],channel_pll_locked,iopll_sclk_locked}),  //  probes.probe
        .source (reserved_bit)  // sources.source
    );

    //---------------------------------------------------------------------------------------------
    // ISSP instance 2
    probe4_sl issp_patgen (
        .probe (checker_pass),  //  probes.probe
        .source (cpri_speed_issp)  // sources.source
    );
    
    //---------------------------------------------------------------------------------------------
    // ISSP instance 3
    probe_dl issp_dl (
        .probe  (rt_count),//{ rt_count[3] , rt_count[2],rt_count[1],rt_count[0] }  ),  //  probes.probe
        .source (restart )  // sources.source
    );
    
    //---------------------------------------------------------------------------------------------
    // ISSP instance 4
    wire [NUM_CHANNELS-1:0][19:0] issp_stat;

    generate
    for (ch = 0; ch < NUM_CHANNELS; ch = ch + 1) begin: gen_issp_status
        assign issp_stat[ch] = {{7{reserved_bit[0]}}, cpri_speed_en, cpri_speed_issp, reserved_bit[1:0], o_sl_tx_lanes_stable[ch], o_sl_rx_pcs_ready[ch], o_sl_ehip_ready[ch], o_sl_rx_block_lock[ch], o_tx_pll_locked[ch], o_cdr_lock[ch]};
    end
    endgenerate

    probe_dl issp_status (
        .probe  (issp_stat),  //  probes.probe
        .source ({cpri_speed_en})   // sources.source
    );


    //---------------------------------------------------------------------------------------------
    // JTAG2AVALON MASTER AND AVMM'S SLAVE SPLITTER BLOCK
    
    // Timeout handler and calculation 
    reg  [15:0] timer;
    wire i_status_waitrequest = (timer == 16'd2000) ? 1'b0 : status_waitrequest;
    wire i_status_readdata_valid = ((timer == 16'd2000) & status_read) ? 1'b1 : status_readdata_valid;
    wire [31:0] i_status_readdata = (timer == 16'd2000) ? 32'hdeadc0de : status_readdata;
    
    always@ (posedge i_reconfig_clk or posedge i_reconfig_reset)
    begin
     if (i_reconfig_reset)
       timer <= 16'h0;     
     else if ((timer == 16'd2000) || ~status_waitrequest)
     timer <= 16'h0;
     else if (status_read | status_write)
       timer <= timer + 1'b1;
     else 
       timer <= timer;
    end  
    
    alt_cpriphy_c3_jtag_avalon jtag_master (
        .clk_clk                (i_reconfig_clk),

        .clk_reset_reset        (i_reconfig_reset),
        .master_address         (av_addr),
        .master_readdata        (i_status_readdata),
        .master_read            (status_read),
        .master_write           (status_write),
        .master_writedata       (status_writedata),
        .master_waitrequest     (i_status_waitrequest),
        .master_readdatavalid   (i_status_readdata_valid),
        .master_byteenable      (),
        .master_reset_reset     ()
    );

    //Decoding for avmm address map readdata valid
    wire [NUM_CHANNELS-1:0]       xcvr_reconfig_readdata_valid;
    wire [1-1:0]                  rsfec_reconfig_readdata_valid;
    wire [NUM_CHANNELS-1:0]       status_readdata_valid_int;
    wire [NUM_CHANNELS-1:0][31:0] status_readdata_int;
    wire [NUM_CHANNELS-1:0]       select_waitrequest;
    wire [NUM_CHANNELS-1:0]       status_waitrequest_int;
    wire [NUM_CHANNELS-1:0]       xcvr_cs;
    wire [NUM_CHANNELS-1:0]       rsfec_cs;
    wire [NUM_CHANNELS-1:0]       cpri_cs;
    wire [2:0]                    active_ch;

    wire sel_xcvr   = ((status_addr_r[20:0] >= 21'h1_00000) && (status_addr_r[20:0] <= 21'h1_FFFFF)) ? 1'b1 : 1'b0;
    wire sel_rsfec  = ((status_addr_r[20:0] >= 21'h0_10000) && (status_addr_r[20:0] <= 21'h0_107FF)) ? 1'b1 : 1'b0;
    wire sel_pio    = ((status_addr_r[20:0] >= 21'h0_02000) && (status_addr_r[20:0] <= 21'h0_02FFF)) ? 1'b1 : 1'b0;
    wire sel_pc     = ((status_addr_r[20:0] >= 21'h0_01000) && (status_addr_r[20:0] <= 21'h0_01FFF)) ? 1'b1 : 1'b0;
    wire sel_eth    = ((status_addr_r[20:0] >= 21'h0_00000) && (status_addr_r[20:0] <= 21'h0_00FFF)) ? 1'b1 : 1'b0;
    
    assign active_ch             = (status_addr_r[23:21]); 
    assign status_readdata_valid = (|status_readdata_valid_int);
    assign status_readdata       = status_readdata_int[active_ch];
    assign status_waitrequest    = (|status_waitrequest_int);  
        
    genvar avmm_i;
    generate
    for (avmm_i=0; avmm_i<NUM_CHANNELS; avmm_i=avmm_i+1) begin : AVMM_REMAP
    assign status_readdata_valid_int[avmm_i] = status_readdata_valid_pc[avmm_i]     | o_sl_cpri_reconfig_readdata_valid[avmm_i] | 
                                               xcvr_reconfig_readdata_valid[avmm_i] | rsfec_reconfig_readdata_valid[0]         |
                                               status_readdata_valid_pio[avmm_i];

    //Decoding for avmm address map readdata
    assign status_readdata_int[avmm_i] =  status_readdata_valid_pio[avmm_i]        ?  status_readdata_pio[avmm_i*32+:32] :
                                          status_readdata_valid_pc[avmm_i]         ?  status_readdata_pc[avmm_i*32+:32] : 
                                          o_sl_cpri_reconfig_readdata_valid[avmm_i] ?  o_sl_cpri_reconfig_readdata[avmm_i*32+:32]  :
                                          xcvr_reconfig_readdata_valid[avmm_i]     ?  {24'b0, o_xcvr_reconfig_readdata[avmm_i*8+:8]} : 
                                          rsfec_reconfig_readdata_valid[0]         ?  {24'b0, o_rsfec_reconfig_readdata[0*8+:8]} :                              
                                          32'hdead_c0de;   
    //Decoding for avmm address map waitrequest 
    assign select_waitrequest[avmm_i] = (sel_xcvr)  ? o_xcvr_reconfig_waitrequest[avmm_i]    :
                                        (sel_rsfec) ? o_rsfec_reconfig_waitrequest[0]        :
                                        (sel_pio)   ? status_waitrequest_pio[avmm_i]         :
                                        (sel_pc)    ? status_waitrequest_pc[avmm_i]          :
                                        (sel_eth)   ? o_sl_cpri_reconfig_waitrequest[avmm_i] : 1'b0;
    assign status_waitrequest_int[avmm_i] = (status_write_r | status_read_r) & select_waitrequest[avmm_i] & (status_addr_r[23:21] == avmm_i);
     
    //Reconfig Decoding XCVR
    assign  xcvr_cs[avmm_i]                          = (status_addr_r[23:21] == avmm_i) & sel_xcvr;
    assign  i_xcvr_reconfig_read[avmm_i]             = status_read_r && xcvr_cs[avmm_i];
    assign  i_xcvr_reconfig_write[avmm_i]            = status_write_r && xcvr_cs[avmm_i];
    assign  xcvr_reconfig_readdata_valid[avmm_i]     = i_xcvr_reconfig_read[avmm_i] && !o_xcvr_reconfig_waitrequest[avmm_i];
    assign  i_xcvr_reconfig_address[avmm_i*19+:19]   = (i_xcvr_reconfig_read[avmm_i] || i_xcvr_reconfig_write[avmm_i]) ? status_addr_r[18:0] : 18'b0;
    assign  i_xcvr_reconfig_writedata[avmm_i*8+:8]   = status_writedata_r[7:0];

    //Reconfig Decoding RSFEC
    assign  rsfec_cs[0]                          = sel_rsfec; //(status_addr_r[23:21] == 3'b000) & sel_rsfec;
    assign  i_rsfec_reconfig_read[0]             = status_read_r && rsfec_cs[0];
    assign  i_rsfec_reconfig_write[0]            = status_write_r && rsfec_cs[0];
    assign  rsfec_reconfig_readdata_valid[0]     = i_rsfec_reconfig_read[0] && !o_rsfec_reconfig_waitrequest[0];
    assign  i_rsfec_reconfig_addr[0*11+:11]      = (i_rsfec_reconfig_read[0] || i_rsfec_reconfig_write[0]) ? status_addr_r[10:0] : 11'b0;
    assign  i_rsfec_reconfig_writedata[0*8+:8]   = status_writedata_r[7:0];
    
    //Reconfig Decoding Ethernet
    assign  cpri_cs[avmm_i]                             = (status_addr_r[23:21] == avmm_i) & sel_eth;
    assign  i_sl_cpri_reconfig_read[avmm_i]             = status_read_r && cpri_cs[avmm_i];
    assign  i_sl_cpri_reconfig_write[avmm_i]            = status_write_r && cpri_cs[avmm_i];
    assign  i_sl_cpri_reconfig_addr[avmm_i*19+:19]      = (i_sl_cpri_reconfig_read[avmm_i] || i_sl_cpri_reconfig_write[avmm_i]) ? status_addr_r[18:0] : 19'b0;
    assign  i_sl_cpri_reconfig_writedata[avmm_i*32+:32] = status_writedata_r;
 
    // PIO Control block
    assign  status_readdata_valid_pio[avmm_i] = 1'b0;
    // Packet Generator Selection
    assign  sel_pktgen[avmm_i] = (status_addr_r[23:21] == avmm_i) && (status_addr_r[20:12] == 9'b1);
    end
    endgenerate  

    // Reset Release block
    wire ninit_done, init_done;
    alt_cpriphy_c3_reset_release reset_release(
        .ninit_done (ninit_done) // active high reset
    );
    assign init_done = ~ninit_done; // active low reset
 
    alt_xcvr_resync_std #(
        .SYNC_CHAIN_LENGTH (2),  
        .INIT_VALUE        (1)
    ) __syncdata__reconfig_reset_sync(
        .clk                       (i_reconfig_clk),
        .reset                     (),
        .d                         (i_reconfig_reset),
        .q                         (i_reconfig_reset_sync) // active high
    );
	 
    alt_xcvr_resync_std #(
        .SYNC_CHAIN_LENGTH (2),
        .WIDTH(5),
        .INIT_VALUE        (0)
    ) __syncdata__cpri_speed_rcfgclksync_inst(
        .clk                       (i_reconfig_clk),
        .reset                     (),
        .d                         ({cpri_speed_en,cpri_speed_issp}),
        .q                         ({cpri_speed_en_sync,cpri_speed_issp_sync})
    );
	 
    always @( posedge i_reconfig_clk) begin
        if (i_reconfig_reset_sync)  begin
            cpri_speed_reg <= cpri_speed;
        end else begin
            if (cpri_speed_en_sync) begin 
                cpri_speed_reg <= cpri_speed_issp_sync;
            end
        end
    end 
    
    alt_cpriphy_c3_top #(
        .sim_mode                            ("disable"),
        .DL_TOT_MEASURE_CNT                  (DL_TOT_MEASURE_CNT)
    ) dut_wrapper (
        
        // Clocks
        .i_clk_ref                           ({4'b0,i_clk_ref}),
        .i_reconfig_clk                      (i_reconfig_clk),
        .o_tx_clkout                         (o_tx_clkout),
        .o_rx_clkout                         (o_rx_clkout),
        .o_tx_clkout2                        (o_tx_clkout2),
        .o_rx_clkout2                        (o_rx_clkout2),

        // Resets
        .i_sl_tx_rst_n                       (i_sl_tx_rst_n & {NUM_CHANNELS{init_done}}),
        .i_sl_rx_rst_n                       (i_sl_rx_rst_n & {NUM_CHANNELS{init_done}}),
        .i_sl_csr_rst_n                      (i_sl_csr_rst_n & {NUM_CHANNELS{init_done}}),
        
        .i_reconfig_reset                    (i_reconfig_reset | ninit_done),  //active high
        
        
        .i_clk_pll_ref                       (ref_clk156MHz),
        .tx_serial_data                      (tx_serial_data),
        .channel_pll_locked                  (channel_pll_locked),

        // Tranceiver - 24.33024Gbps for 24G, 10.1376 for 10G
        .i_rx_serial                         (i_rx_serial),
        .o_tx_serial                         (o_tx_serial),
        
        .i_sl_cpri_reconfig_addr             (i_sl_cpri_reconfig_addr[19*NUM_CHANNELS-1:0]),
        .i_sl_cpri_reconfig_read             (i_sl_cpri_reconfig_read[NUM_CHANNELS-1:0]),
        .i_sl_cpri_reconfig_write            (i_sl_cpri_reconfig_write[NUM_CHANNELS-1:0]),
        .i_sl_cpri_reconfig_writedata        (i_sl_cpri_reconfig_writedata[32*NUM_CHANNELS-1:0]),
        .o_sl_cpri_reconfig_readdata         (o_sl_cpri_reconfig_readdata[32*NUM_CHANNELS-1:0]),
        .o_sl_cpri_reconfig_readdata_valid   (o_sl_cpri_reconfig_readdata_valid[NUM_CHANNELS-1:0]),
        .o_sl_cpri_reconfig_waitrequest      (o_sl_cpri_reconfig_waitrequest[NUM_CHANNELS-1:0]),
        
        // XCVR CSR AVMM
        .i_xcvr_reconfig_address             (i_xcvr_reconfig_address[19*NUM_CHANNELS-1:0]),
        .i_xcvr_reconfig_read                (i_xcvr_reconfig_read[NUM_CHANNELS-1:0]),
        .i_xcvr_reconfig_write               (i_xcvr_reconfig_write[NUM_CHANNELS-1:0]),
        .i_xcvr_reconfig_writedata           (i_xcvr_reconfig_writedata[8*NUM_CHANNELS-1:0]),
        .o_xcvr_reconfig_readdata            (o_xcvr_reconfig_readdata[8*NUM_CHANNELS-1:0]),
        .o_xcvr_reconfig_waitrequest         (o_xcvr_reconfig_waitrequest[NUM_CHANNELS-1:0]),
        
        // Core Status
        .o_tx_pll_locked                     (o_tx_pll_locked),
        .o_cdr_lock                          (o_cdr_lock),
        .o_sl_tx_lanes_stable                (o_sl_tx_lanes_stable),
        .o_sl_rx_block_lock                  (o_sl_rx_block_lock),
        .o_sl_rx_pcs_ready                   (o_sl_rx_pcs_ready),
        .o_sl_ehip_ready                     (o_sl_ehip_ready),
        .o_sl_rx_hi_ber                      (o_sl_rx_hi_ber),
        
        .iopll_sclk_locked                   (iopll_sclk_locked),
        .checker_pass                        (checker_pass),
        .restart                             (restart     ),
        .rt_count                            (rt_count    ),
        .ehip_mode_sl_0                      (cpri_speed_reg[3]),
        .cpri_speed                          (cpri_speed_reg)
    );

endmodule

