// (C) 2001-2022 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


`timescale 1 ps / 1 ps

module alt_cpriphy_c3_avmm_if (

    input   wire             i_reconfig_clk,
    input   wire             i_avmm_resetn,

`ifdef AVMM_MASTER_BFM
    input   wire   [31:0]    avmm_mst_writedata,
    input   wire             avmm_mst_read,
    input   wire   [31:0]    avmm_mst_address,
    input   wire             avmm_mst_write,
    output  wire   [31:0]    avmm_mst_readdata,
    output  wire             avmm_mst_waitrequest,
    output  wire             avmm_mst_readdata_valid,
`endif

    output  wire [18:0]      o_ch0_xcvr_reconfig_addr,           
    output  wire             o_ch0_xcvr_reconfig_read,           
    output  wire             o_ch0_xcvr_reconfig_write,          
    output  wire [31:0]      o_ch0_xcvr_reconfig_writedata,      
    input   wire [31:0]      i_ch0_xcvr_reconfig_readdata,       
    input   wire             i_ch0_xcvr_reconfig_readdata_valid, 
    input   wire             i_ch0_xcvr_reconfig_waitrequest,    
       
    output  wire [18:0]      o_ch1_xcvr_reconfig_addr,           
    output  wire             o_ch1_xcvr_reconfig_read,           
    output  wire             o_ch1_xcvr_reconfig_write,          
    output  wire [31:0]      o_ch1_xcvr_reconfig_writedata,      
    input   wire [31:0]      i_ch1_xcvr_reconfig_readdata,       
    input   wire             i_ch1_xcvr_reconfig_readdata_valid, 
    input   wire             i_ch1_xcvr_reconfig_waitrequest,    

    output  wire [18:0]      o_ch2_xcvr_reconfig_addr,           
    output  wire             o_ch2_xcvr_reconfig_read,           
    output  wire             o_ch2_xcvr_reconfig_write,          
    output  wire [31:0]      o_ch2_xcvr_reconfig_writedata,      
    input   wire [31:0]      i_ch2_xcvr_reconfig_readdata,       
    input   wire             i_ch2_xcvr_reconfig_readdata_valid, 
    input   wire             i_ch2_xcvr_reconfig_waitrequest,

    output  wire [18:0]      o_ch3_xcvr_reconfig_addr,           
    output  wire             o_ch3_xcvr_reconfig_read,           
    output  wire             o_ch3_xcvr_reconfig_write,          
    output  wire [31:0]      o_ch3_xcvr_reconfig_writedata,      
    input   wire [31:0]      i_ch3_xcvr_reconfig_readdata,       
    input   wire             i_ch3_xcvr_reconfig_readdata_valid, 
    input   wire             i_ch3_xcvr_reconfig_waitrequest,

    output  wire [18:0]      o_ch0_cpri_reconfig_addr,
    output  wire             o_ch0_cpri_reconfig_read,
    output  wire             o_ch0_cpri_reconfig_write,
    output  wire [31:0]      o_ch0_cpri_reconfig_writedata,
    input   wire [31:0]      i_ch0_cpri_reconfig_readdata,
    input   wire             i_ch0_cpri_reconfig_readdata_valid,
    input   wire             i_ch0_cpri_reconfig_waitrequest,
    
    output  wire [18:0]      o_ch1_cpri_reconfig_addr,
    output  wire             o_ch1_cpri_reconfig_read,
    output  wire             o_ch1_cpri_reconfig_write,
    output  wire [31:0]      o_ch1_cpri_reconfig_writedata,
    input   wire [31:0]      i_ch1_cpri_reconfig_readdata,
    input   wire             i_ch1_cpri_reconfig_readdata_valid,
    input   wire             i_ch1_cpri_reconfig_waitrequest,
    
    output  wire [18:0]      o_ch2_cpri_reconfig_addr,
    output  wire             o_ch2_cpri_reconfig_read,
    output  wire             o_ch2_cpri_reconfig_write,
    output  wire [31:0]      o_ch2_cpri_reconfig_writedata,
    input   wire [31:0]      i_ch2_cpri_reconfig_readdata,
    input   wire             i_ch2_cpri_reconfig_readdata_valid,
    input   wire             i_ch2_cpri_reconfig_waitrequest,
    
    output  wire [18:0]      o_ch3_cpri_reconfig_addr,
    output  wire             o_ch3_cpri_reconfig_read,
    output  wire             o_ch3_cpri_reconfig_write,
    output  wire [31:0]      o_ch3_cpri_reconfig_writedata,
    input   wire [31:0]      i_ch3_cpri_reconfig_readdata,
    input   wire             i_ch3_cpri_reconfig_readdata_valid,
    input   wire             i_ch3_cpri_reconfig_waitrequest,

    output  wire             ch0_pkt_avl_mm_read,
    output  wire             ch0_pkt_avl_mm_write,
    output  wire [31:0]      ch0_pkt_avl_mm_writedata,
    output  wire [11:0]      ch0_pkt_avl_mm_baddress,
    input   wire [31:0]      ch0_pkt_avl_mm_readdata,
    input   wire             ch0_pkt_avl_mm_waitrequest,
 
    output  wire             ch1_pkt_avl_mm_read,
    output  wire             ch1_pkt_avl_mm_write,
    output  wire [31:0]      ch1_pkt_avl_mm_writedata,
    output  wire [11:0]      ch1_pkt_avl_mm_baddress,
    input   wire [31:0]      ch1_pkt_avl_mm_readdata,
    input   wire             ch1_pkt_avl_mm_waitrequest,

    output  wire             ch2_pkt_avl_mm_read,
    output  wire             ch2_pkt_avl_mm_write,
    output  wire [31:0]      ch2_pkt_avl_mm_writedata,
    output  wire [11:0]      ch2_pkt_avl_mm_baddress,
    input   wire [31:0]      ch2_pkt_avl_mm_readdata,
    input   wire             ch2_pkt_avl_mm_waitrequest,

    output  wire             ch3_pkt_avl_mm_read,
    output  wire             ch3_pkt_avl_mm_write,
    output  wire [31:0]      ch3_pkt_avl_mm_writedata,
    output  wire [11:0]      ch3_pkt_avl_mm_baddress,
    input   wire [31:0]      ch3_pkt_avl_mm_readdata,
    input   wire             ch3_pkt_avl_mm_waitrequest,

    output  wire [10:0]      o_rsfec_reconfig_addr,
    output  wire             o_rsfec_reconfig_read,
    output  wire             o_rsfec_reconfig_write,
    input   wire [31:0]      i_rsfec_reconfig_readdata,
    output  wire [31:0]      o_rsfec_reconfig_writedata,
    input   wire             i_rsfec_reconfig_waitrequest,
    
    input   wire [31:0]      pio_stat0,
    output  wire [31:0]      pio_ctrl0
    );

    wire   [12:0]            slave_sel;
    wire   [31:0]            avmm_slv_address;
    wire   [12:0]            avmm_slv_read;
    wire   [12:0]            avmm_slv_write;
    wire   [31:0]            avmm_slv_writedata;
    wire   [13*32-1:0]       avmm_slv_readdata;
    wire   [12:0]            avmm_slv_waitrequest;
    wire   [12:0]            avmm_slv_readdata_valid;

`ifndef AVMM_MASTER_BFM

    wire   [31:0]            avmm_mst_writedata;
    wire                     avmm_mst_read;
    wire   [31:0]            avmm_mst_address;
    wire                     avmm_mst_write;
    wire   [31:0]            avmm_mst_readdata;
    wire                     avmm_mst_waitrequest;
    wire                     avmm_mst_readdata_valid;

    alt_cpriphy_c3_jtag_avalon jtag_master
    (/*AUTOINST*/
       // Outputs
       .master_address            (avmm_mst_address[31:0]),
       .master_read               (avmm_mst_read),
       .master_write              (avmm_mst_write),
       .master_writedata          (avmm_mst_writedata[31:0]),
       .master_byteenable         (),
       .master_reset_reset        (),
       // Inputs
       .clk_clk                   (i_reconfig_clk),
       .clk_reset_reset           (~i_avmm_resetn),
       .master_readdata           (avmm_mst_readdata[31:0]),
       .master_waitrequest        (avmm_mst_waitrequest),
       .master_readdatavalid      (avmm_mst_readdata_valid)
       ); 
       
`endif


//////////////////////////////////////   DECODING   ////////////////////////////////////////////
    assign o_ch0_cpri_reconfig_addr                = {avmm_slv_address[20:2]};
    assign o_ch0_cpri_reconfig_write               = avmm_slv_write[0]; 
    assign o_ch0_cpri_reconfig_read                = avmm_slv_read[0]; 
    assign o_ch0_cpri_reconfig_writedata           = avmm_slv_writedata; 
    assign avmm_slv_readdata[(0+1)*32-1:(0)*32]    = i_ch0_cpri_reconfig_readdata; 
    assign avmm_slv_waitrequest[0]                 = i_ch0_cpri_reconfig_waitrequest; 
    assign avmm_slv_readdata_valid[0]              = i_ch0_cpri_reconfig_readdata_valid;

    assign o_ch1_cpri_reconfig_addr                = {avmm_slv_address[20:2]};
    assign o_ch1_cpri_reconfig_write               = avmm_slv_write[1]; 
    assign o_ch1_cpri_reconfig_read                = avmm_slv_read[1]; 
    assign o_ch1_cpri_reconfig_writedata           = avmm_slv_writedata; 
    assign avmm_slv_readdata[(1+1)*32-1:(1)*32]    = i_ch1_cpri_reconfig_readdata; 
    assign avmm_slv_waitrequest[1]                 = i_ch1_cpri_reconfig_waitrequest; 
    assign avmm_slv_readdata_valid[1]              = i_ch1_cpri_reconfig_readdata_valid;

    assign o_ch2_cpri_reconfig_addr                = {avmm_slv_address[20:2]};
    assign o_ch2_cpri_reconfig_write               = avmm_slv_write[2]; 
    assign o_ch2_cpri_reconfig_read                = avmm_slv_read[2]; 
    assign o_ch2_cpri_reconfig_writedata           = avmm_slv_writedata; 
    assign avmm_slv_readdata[(2+1)*32-1:(2)*32]    = i_ch2_cpri_reconfig_readdata; 
    assign avmm_slv_waitrequest[2]                 = i_ch2_cpri_reconfig_waitrequest; 
    assign avmm_slv_readdata_valid[2]              = i_ch2_cpri_reconfig_readdata_valid;

    assign o_ch3_cpri_reconfig_addr                = {avmm_slv_address[20:2]};
    assign o_ch3_cpri_reconfig_write               = avmm_slv_write[3]; 
    assign o_ch3_cpri_reconfig_read                = avmm_slv_read[3]; 
    assign o_ch3_cpri_reconfig_writedata           = avmm_slv_writedata; 
    assign avmm_slv_readdata[(3+1)*32-1:(3)*32]    = i_ch3_cpri_reconfig_readdata; 
    assign avmm_slv_waitrequest[3]                 = i_ch3_cpri_reconfig_waitrequest; 
    assign avmm_slv_readdata_valid[3]              = i_ch3_cpri_reconfig_readdata_valid;

    assign o_ch0_xcvr_reconfig_addr                = {avmm_slv_address[20:2]}; 
    assign o_ch0_xcvr_reconfig_write               = avmm_slv_write[4]; 
    assign o_ch0_xcvr_reconfig_read                = avmm_slv_read[4]; 
    assign o_ch0_xcvr_reconfig_writedata           = avmm_slv_writedata;
    assign avmm_slv_readdata[(4+1)*32-1:(4)*32]    = i_ch0_xcvr_reconfig_readdata;
    assign avmm_slv_waitrequest[4]                 = i_ch0_xcvr_reconfig_waitrequest;
    assign avmm_slv_readdata_valid[4]              = i_ch0_xcvr_reconfig_readdata_valid;

    assign o_ch1_xcvr_reconfig_addr                = {avmm_slv_address[20:2]}; 
    assign o_ch1_xcvr_reconfig_write               = avmm_slv_write[5]; 
    assign o_ch1_xcvr_reconfig_read                = avmm_slv_read[5]; 
    assign o_ch1_xcvr_reconfig_writedata           = avmm_slv_writedata;
    assign avmm_slv_readdata[(5+1)*32-1:(5)*32]    = i_ch1_xcvr_reconfig_readdata;
    assign avmm_slv_waitrequest[5]                 = i_ch1_xcvr_reconfig_waitrequest;
    assign avmm_slv_readdata_valid[5]              = i_ch1_xcvr_reconfig_readdata_valid;

    assign o_ch2_xcvr_reconfig_addr                = {avmm_slv_address[20:2]}; 
    assign o_ch2_xcvr_reconfig_write               = avmm_slv_write[6]; 
    assign o_ch2_xcvr_reconfig_read                = avmm_slv_read[6]; 
    assign o_ch2_xcvr_reconfig_writedata           = avmm_slv_writedata;
    assign avmm_slv_readdata[(6+1)*32-1:(6)*32]    = i_ch2_xcvr_reconfig_readdata;
    assign avmm_slv_waitrequest[6]                 = i_ch2_xcvr_reconfig_waitrequest;
    assign avmm_slv_readdata_valid[6]              = i_ch2_xcvr_reconfig_readdata_valid;

    assign o_ch3_xcvr_reconfig_addr                = {avmm_slv_address[20:2]}; 
    assign o_ch3_xcvr_reconfig_write               = avmm_slv_write[7]; 
    assign o_ch3_xcvr_reconfig_read                = avmm_slv_read[7]; 
    assign o_ch3_xcvr_reconfig_writedata           = avmm_slv_writedata;
    assign avmm_slv_readdata[(7+1)*32-1:(7)*32]    = i_ch3_xcvr_reconfig_readdata;
    assign avmm_slv_waitrequest[7]                 = i_ch3_xcvr_reconfig_waitrequest;
    assign avmm_slv_readdata_valid[7]              = i_ch3_xcvr_reconfig_readdata_valid;

    assign ch0_pkt_avl_mm_baddress                 = avmm_slv_address[11:0]; 
    assign ch0_pkt_avl_mm_writedata                = avmm_slv_writedata;
    assign ch0_pkt_avl_mm_write                    = avmm_slv_write[8];
    assign ch0_pkt_avl_mm_read                     = avmm_slv_read[8]; 
    assign avmm_slv_waitrequest[8]                 = ch0_pkt_avl_mm_waitrequest;    
    assign avmm_slv_readdata[(8+1)*32-1:(8)*32]    = ch0_pkt_avl_mm_readdata; 
    assign avmm_slv_readdata_valid[8]              = ch0_pkt_avl_mm_read & ~ch0_pkt_avl_mm_waitrequest;

    assign ch1_pkt_avl_mm_baddress                 = avmm_slv_address[11:0]; 
    assign ch1_pkt_avl_mm_writedata                = avmm_slv_writedata;
    assign ch1_pkt_avl_mm_write                    = avmm_slv_write[9];
    assign ch1_pkt_avl_mm_read                     = avmm_slv_read[9]; 
    assign avmm_slv_waitrequest[9]                 = ch1_pkt_avl_mm_waitrequest;    
    assign avmm_slv_readdata[(9+1)*32-1:(9)*32]    = ch1_pkt_avl_mm_readdata; 
    assign avmm_slv_readdata_valid[9]              = ch1_pkt_avl_mm_read & ~ch1_pkt_avl_mm_waitrequest;

    assign ch2_pkt_avl_mm_baddress                 = avmm_slv_address[11:0]; 
    assign ch2_pkt_avl_mm_writedata                = avmm_slv_writedata;
    assign ch2_pkt_avl_mm_write                    = avmm_slv_write[10];
    assign ch2_pkt_avl_mm_read                     = avmm_slv_read[10]; 
    assign avmm_slv_waitrequest[10]                = ch2_pkt_avl_mm_waitrequest;    
    assign avmm_slv_readdata[(10+1)*32-1:(10)*32]  = ch2_pkt_avl_mm_readdata; 
    assign avmm_slv_readdata_valid[10]             = ch2_pkt_avl_mm_read & ~ch2_pkt_avl_mm_waitrequest;

    assign ch3_pkt_avl_mm_baddress                 = avmm_slv_address[11:0]; 
    assign ch3_pkt_avl_mm_writedata                = avmm_slv_writedata;
    assign ch3_pkt_avl_mm_write                    = avmm_slv_write[11];
    assign ch3_pkt_avl_mm_read                     = avmm_slv_read[11]; 
    assign avmm_slv_waitrequest[11]                = ch3_pkt_avl_mm_waitrequest;    
    assign avmm_slv_readdata[(11+1)*32-1:(11)*32]  = ch3_pkt_avl_mm_readdata; 
    assign avmm_slv_readdata_valid[11]             = ch3_pkt_avl_mm_read & ~ch3_pkt_avl_mm_waitrequest;

    assign o_rsfec_reconfig_addr                   = avmm_slv_address[12:2];
    assign o_rsfec_reconfig_read                   = avmm_slv_read[12];
    assign o_rsfec_reconfig_write                  = avmm_slv_write[12];
    assign o_rsfec_reconfig_writedata              = avmm_slv_writedata;
    assign avmm_slv_readdata[(12+1)*32-1:(12)*32]  = i_rsfec_reconfig_readdata;
    assign avmm_slv_waitrequest[12]                = i_rsfec_reconfig_waitrequest;
    assign avmm_slv_readdata_valid[12]             = o_rsfec_reconfig_read & ~i_rsfec_reconfig_waitrequest;
       
    alt_cpriphy_c3_avmm_interconnect #(
      .NUM_SLAVE(13)
    ) alt_cpriphy_c3_avmm_interconnect
    (/*AUTOINST*/
       // Outputs
       .avmm_mst_readdata         (avmm_mst_readdata[31:0]),
       .avmm_mst_readdata_valid   (avmm_mst_readdata_valid),
       .avmm_mst_waitrequest      (avmm_mst_waitrequest),
       .avmm_slv_address          (avmm_slv_address[31:0]),
       .avmm_slv_read             (avmm_slv_read[12:0]),
       .avmm_slv_write            (avmm_slv_write[12:0]),
       .avmm_slv_writedata        (avmm_slv_writedata[31:0]),
       .slave_sel                 (slave_sel[12:0]),
       // Inputs
       .clk                       (i_reconfig_clk),
       .rst_n                     (i_avmm_resetn),
       .avmm_mst_address          (avmm_mst_address[31:0]),
       .avmm_mst_read             (avmm_mst_read),
       .avmm_mst_write            (avmm_mst_write),
       .avmm_mst_writedata        (avmm_mst_writedata[31:0]),
       .avmm_slv_readdata         (avmm_slv_readdata[13*32-1:0]),
       .avmm_slv_readdata_valid   (avmm_slv_readdata_valid[12:0]),
       .avmm_slv_waitrequest      (avmm_slv_waitrequest[12:0])
       );

     
endmodule
