# (C) 2001-2022 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


source src/common_inc.tcl
source src/system_base_addr_map.tcl
source src/c3_rsfec_cfgcsr_reg_map.tcl

 proc write_rsfec_cfgcsr_reg_byte0 {offset wdata} {
        global fileid
		set register_name [dict get $::ehip_rsfec_reg $offset]
        reg_write $::ADDR_RSFEC_AVMM_CONFIG_INT [expr $offset<<2] $wdata 
        puts $fileid "\tSuccessfully Write RSFEC Register $register_name, offset = [format "%#x" $offset], data = [format "%#x" $wdata] " 
 }

 proc read_rsfec_cfgcsr_reg_byte0 {offset compflag comprdata} {
        global fileid
        global error_count
		set register_name [dict get $::ehip_rsfec_reg $offset]
        set rdata [reg_read $::ADDR_RSFEC_AVMM_CONFIG_INT [expr $offset<<2]]		
        if {$compflag} {
		      if {$rdata == $comprdata} {
                 puts $fileid "\tSuccessfully Read  RSFEC Register $register_name, offset = [format "%#x" $offset], data = [format "%#x" $rdata] "
              } else {
			     set error_count [expr $error_count + 1]
                 puts $fileid "\tERROR: Read  RSFEC Register $register_name, offset = [format "%#x" $offset], data = [format "%#x" $rdata] but expected data = [format "%#x" $comprdata] "
              }			  
        } else {
              puts $fileid "\tSuccessfully Read  RSFEC Register $register_name, offset = [format "%#x" $offset], data = [format "%#x" $rdata] " 
        }
		return $rdata
 }

 proc write_rsfec_cfgcsr_reg {offset wdata} {
        global fileid
        set register_name [dict get $::ehip_rsfec_reg $offset]
        reg_write $::ADDR_RSFEC_AVMM_CONFIG_INT [expr $offset+0<<2] $wdata
        reg_write $::ADDR_RSFEC_AVMM_CONFIG_INT [expr $offset+1<<2] [expr $wdata>>8]
        reg_write $::ADDR_RSFEC_AVMM_CONFIG_INT [expr $offset+2<<2] [expr $wdata>>16]
        reg_write $::ADDR_RSFEC_AVMM_CONFIG_INT [expr $offset+3<<2] [expr $wdata>>24]
        puts $fileid "\tSuccessfully Write RSFEC Register $register_name, offset = [format "%#x" $offset], data = [format "%#x" $wdata] " 
 }

 proc read_rsfec_cfgcsr_reg {offset compflag comprdata} {
        global fileid
        global error_count
        set register_name [dict get $::ehip_rsfec_reg $offset]
        set rdata0 [reg_read $::ADDR_RSFEC_AVMM_CONFIG_INT [expr $offset+0<<2]]
        set rdata1 [expr [reg_read $::ADDR_RSFEC_AVMM_CONFIG_INT [expr $offset+1<<2]] <<8]
        set rdata2 [expr [reg_read $::ADDR_RSFEC_AVMM_CONFIG_INT [expr $offset+2<<2]] <<16]
        set rdata3 [expr [reg_read $::ADDR_RSFEC_AVMM_CONFIG_INT [expr $offset+3<<2]] <<24]
        set rdata  [expr $rdata0 | $rdata1 | $rdata2 | $rdata3]
        if {$compflag} {
              if {$rdata == $comprdata} {
                 puts $fileid "\tSuccessfully Read  RSFEC Register $register_name, offset = [format "%#x" $offset], data = [format "%#x" $rdata] "
              } else {
                 set error_count [expr $error_count + 1]
                 puts $fileid "\tERROR: Read  RSFEC Register $register_name, offset = [format "%#x" $offset], data = [format "%#x" $rdata] but expected data = [format "%#x" $comprdata] "
              }  
        } else {
              puts $fileid "\tSuccessfully Read  RSFEC Register $register_name, offset = [format "%#x" $offset], data = [format "%#x" $rdata] " 
        }
        return $rdata
 }