# (C) 2001-2022 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


source src/c3_xcvr_cfgcsr_inc.tcl
source src/c3_ehiplane_user_cfgcsr_inc.tcl

set fileid stdout
set service_on 0

if {[info exists jtag_port_id]} {
   set jtag_port_id $jtag_port_id
} else {
   set jtag_port_id 0
   puts "Warning: JTAG (default) Port ID       = $jtag_port_id"
}
  
if {[info exists totalChannel]} {
   set totalChannel $totalChannel
} else {
   set totalChannel 1
   puts "Warning: Number of Channels = $totalChannel"
}

set systemTime [clock seconds]
set local_dir [pwd]
set filename "$local_dir/c3_elane_xcvr_loopback_test.log"
set fileid [open $filename w]

path_jtag $jtag_port_id

open_jtag

set error_count 0

set compresult       1

set systemTime [clock seconds]
puts $fileid "\tTest Start time is: [clock format $systemTime -format %H:%M:%S]"
puts $fileid "\tTest Start date is: [clock format $systemTime -format %D]\n"
set channel_num 0
while { $channel_num < $totalChannel } {

   # Set PMA to internal loop-back mode
   c3_ehiplane_xcvr_mc_loopback_mode $channel_num $compresult $error_count
   # System Reset
   c3_ehip_mc_soft_system_reset      $channel_num $compresult $error_count
   
   incr channel_num
}
# Alignment markers setting workaround for non-FEC designs (AM Period = 81919 and AM width = 1)
#write_ehiplane_user_cfgcsr_reg $txmac_ehip_cfg 0x9fff80c8
#read_ehiplane_user_cfgcsr_reg $txmac_ehip_cfg $compresult 0x9fff80c8

set systemTime [clock seconds]
puts $fileid "\n\tTest End time is: [clock format $systemTime -format %H:%M:%S]"
puts $fileid "\tTest End date is: [clock format $systemTime -format %D]"

close_jtag

if {$error_count == 0} {
  puts $fileid "\nInfo: Test <c3_elane_xcvr_loopback_test> Passed \n" 
  } else {
  puts $fileid "\nERROR: Test <c3_elane_xcvr_loopback_test> Failed \n"
}
 
close $fileid

set local_dir [pwd]
set filename "$local_dir/main_script.log"
set fileid [open $filename a]
if {$error_count == 0} {
  puts $fileid "\nInfo: Test <c3_elane_xcvr_loopback_test> Passed \n" 
  } else {
  puts $fileid "\nERROR: Test <c3_elane_xcvr_loopback_test> Failed \n"
}
close $fileid
