
module power_on_reset #(
	parameter POR_COUNT = 20	// MUST BE 2~1023
) (
	input  wire  clk,
	output wire  reset
);


reg 			PowerOnReset;
reg [9: 0] 	ResetCount;



always @(posedge clk) begin
    if (ResetCount == POR_COUNT) begin
        PowerOnReset <= 1'b0;
    end else begin
        PowerOnReset <= 1'b1;
        ResetCount <= ResetCount + 10'b1;
    end
end

assign reset = PowerOnReset;

endmodule
