#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include "gpio_lib.h"
#include "led_lib.h"



/****************************************************************
 * Main
 ****************************************************************/
 
 int main(int argc, char **argv)
{	
	unsigned int GPIO_BASE=get_gpio_base();
	
	unsigned int io_led=0, io_key=GPIO_BASE+1;
	int i=10;
	int fd_led;
	unsigned value;

	// export gpio
	gpio_export(io_key);
	gpio_set_dir(io_key, 0);
	
	fd_led = led_fd_open(io_led);

	
	while (i >= 0) {
		gpio_get_value(io_key, &value);
		if (value)
			led_fd_write(fd_led, "1", 2);
		else
			led_fd_write(fd_led, "0", 2);
		printf("key: %x\n", value);
		sleep(1);
	}
	
	led_fd_close(fd_led);
	gpio_unexport(io_key);
	
	return 0;
}
 
 
 