#**************************************************************
# This .sdc file is created by Terasic Tool.
# Users are recommended to modify this file to match users logic.
#**************************************************************

#**************************************************************
# Create Clock
#**************************************************************
# CLOCK
create_clock -name MAIN_CLOCK -period 10 [get_ports CLK_100_B2A]
create_clock -period "30.72MHz" [get_ports CLK_30M72]
create_clock -period 20 [get_ports CLK_50_B2A]
create_clock -period 20 [get_ports CLK_50_B2D]
create_clock -period 20 [get_ports CLK_50_B3A]
create_clock -period 20 [get_ports CLK_50_B3C]
# DDR4A
create_clock -name EMIF_REF_CLOCK -period 30 [get_ports DDR4A_REFCLK_p]
# DDR4B
create_clock -period 30 [get_ports DDR4B_REFCLK_p]
# FMC
create_clock -period "156.25MHz" [get_ports FMC_REFCLK0_p]
create_clock -period "184.32MHz" [get_ports FMC_REFCLK1_p]
# FMCP PCIe clock
create_clock -period "100.0MHz" [get_ports FMCP_GBTCLK_M2C_p[0]]
create_clock -period "100.0MHz" [get_ports FMCP_GBTCLK_M2C_p[1]]
# QSFP28
create_clock -period "156.25MHz" [get_ports QSFP28_REFCLK_p]
# QSFP28RSV
create_clock -period "184.32MHz" [get_ports QSFP28RSV_REFCLK_p]


#**************************************************************
# Create Generated Clock
#**************************************************************
derive_pll_clocks


#**************************************************************
# Set Clock Latency
#**************************************************************



#**************************************************************
# Set Clock Uncertainty
#**************************************************************
derive_clock_uncertainty


#**************************************************************
# Set Input Delay
#**************************************************************



#**************************************************************
# Set Output Delay
#**************************************************************



#**************************************************************
# Set Clock Groups
#**************************************************************



#**************************************************************
# Set False Path
#**************************************************************
set_false_path -from [get_ports {CPU_RESET_n}]

# sourcing JTAG related SDC
source ./jtag.sdc

# FPGA IO port constraints
set_false_path -from [get_ports {BUTTON[0]}] -to *
set_false_path -from [get_ports {BUTTON[1]}] -to *
set_false_path -from [get_ports {SW[0]}] -to *
set_false_path -from [get_ports {SW[1]}] -to *
set_false_path -from * -to [get_ports {LED[0]}]
set_false_path -from * -to [get_ports {LED[1]}]


# False Path between debounced and reset synchronizer
set_false_path -from fpga_reset_n_debounced -to {soc_inst|rst_controller_*|altera_reset_synchronizer_int_chain[1]}



#**************************************************************
# Set Multicycle Path
#**************************************************************



#**************************************************************
# Set Maximum Delay
#**************************************************************



#**************************************************************
# Set Minimum Delay
#**************************************************************



#**************************************************************
# Set Input Transition
#**************************************************************



#**************************************************************
# Set Load
#**************************************************************



