// ============================================================================
// Copyright (c) 2021 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development
//   Kits made by Terasic.  Other use of this code, including the selling
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use
//   or functionality of this code.
//
// ============================================================================
//
//  Terasic Technologies Inc
//  No.80, Fenggong Rd., Hukou Township, Hsinchu County 303035 Taiwan
//
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Wed Dec 22 14:16:44 2021
// ============================================================================

`define ENABLE_DDR4A
//`define ENABLE_DDR4B
//`define ENABLE_QSFP28
//`define ENABLE_QSFP28RSV
//`define ENABLE_FMC
//`define ENABLE_FMCP
`define ENABLE_HPS

module Agilex_SOM(

      ///////// CLOCK /////////
      input              CLK_100_B2A,
      input              CLK_30M72,
      input              CLK_50_B2A,
      input              CLK_50_B2D,
      input              CLK_50_B3A,
      input              CLK_50_B3C,

      ///////// Buttons /////////
      input              CPU_RESET_n,
      input    [ 1: 0]   BUTTON, //BUTTON is Low-Active

      ///////// Swtiches /////////
      input    [ 1: 0]   SW,

      ///////// LED /////////
      output   [ 1: 0]   LED, //LED is Low-Active

`ifdef ENABLE_DDR4A
      ///////// DDR4A /////////
      input              DDR4A_REFCLK_p,
      output   [16: 0]   DDR4A_A,
      output   [ 1: 0]   DDR4A_BA,
      output   [ 1: 0]   DDR4A_BG,
      output             DDR4A_CK,
      output             DDR4A_CK_n,
      output             DDR4A_CKE,
      inout    [ 8: 0]   DDR4A_DQS,
      inout    [ 8: 0]   DDR4A_DQS_n,
      inout    [71: 0]   DDR4A_DQ,
      inout    [ 8: 0]   DDR4A_DBI_n,
      output             DDR4A_CS_n,
      output             DDR4A_RESET_n,
      output             DDR4A_ODT,
      output             DDR4A_PAR,
      input              DDR4A_ALERT_n,
      output             DDR4A_ACT_n,
      input              DDR4A_EVENT_n,
      inout              DDR4A_SCL,
      inout              DDR4A_SDA,
      input              DDR4A_RZQ,
`endif /*ENABLE_DDR4A*/

`ifdef ENABLE_DDR4B
      ///////// DDR4B /////////
      input              DDR4B_REFCLK_p,
      output   [16: 0]   DDR4B_A,
      output   [ 1: 0]   DDR4B_BA,
      output   [ 1: 0]   DDR4B_BG,
      output             DDR4B_CK,
      output             DDR4B_CK_n,
      output             DDR4B_CKE,
      inout    [ 8: 0]   DDR4B_DQS,
      inout    [ 8: 0]   DDR4B_DQS_n,
      inout    [71: 0]   DDR4B_DQ,
      inout    [ 8: 0]   DDR4B_DBI_n,
      output             DDR4B_CS_n,
      output             DDR4B_RESET_n,
      output             DDR4B_ODT,
      output             DDR4B_PAR,
      input              DDR4B_ALERT_n,
      output             DDR4B_ACT_n,
      input              DDR4B_EVENT_n,
      inout              DDR4B_SCL,
      inout              DDR4B_SDA,
      input              DDR4B_RZQ,
`endif /*ENABLE_DDR4B*/

      ///////// SI5340A /////////
      inout              SI5340A_I2C_SCL,
      inout              SI5340A_I2C_SDA,
      input              SI5340A_LOL,
      input              SI5340A_LOS_XAXB,
      output             SI5340A_OE_n,
      output             SI5340A_RST_n,

      ///////// 2x6 GPIO /////////
      inout    [ 7: 0]   GPIO_D,

`ifdef ENABLE_FMC
      ///////// FMC /////////
      inout              FMC_CLK2_BIDIR_p,
      inout              FMC_CLK2_BIDIR_n,
      inout              FMC_CLK3_BIDIR_p,
      inout              FMC_CLK3_BIDIR_n,
      output   [ 9: 0]   FMC_DP_C2M_p,
      output   [ 9: 0]   FMC_DP_C2M_n,
      input    [ 9: 0]   FMC_DP_M2C_p,
      input    [ 9: 0]   FMC_DP_M2C_n,
      inout    [23: 0]   FMC_HA_p,
      inout    [23: 0]   FMC_HA_n,
      inout    [21: 0]   FMC_HB_p,
      inout    [21: 0]   FMC_HB_n,
      inout    [33: 0]   FMC_LA_p,
      inout    [33: 0]   FMC_LA_n,
      input    [ 1: 0]   FMC_CLK_M2C_p,
      input    [ 1: 0]   FMC_GBTCLK_M2C_p,
      input              FMC_REFCLK0_p,
      input              FMC_REFCLK1_p,
      inout    [ 1: 0]   FMC_GA,
      inout    [ 0: 0]   FMC_RES,
      inout              FMC_SCL,
      inout              FMC_SDA,
`endif /*ENABLE_FMC*/

`ifdef ENABLE_FMCP
      ///////// FMCP /////////
      inout              FMCP_CLK2_BIDIR_p,
      inout              FMCP_CLK2_BIDIR_n,
      inout              FMCP_CLK3_BIDIR_p,
      inout              FMCP_CLK3_BIDIR_n,
      output   [15: 0]   FMCP_DP_C2M_p,
      output   [15: 0]   FMCP_DP_C2M_n,
      input    [15: 0]   FMCP_DP_M2C_p,
      input    [15: 0]   FMCP_DP_M2C_n,
      inout    [23: 0]   FMCP_HA_p,
      inout    [23: 0]   FMCP_HA_n,
      inout    [21: 0]   FMCP_HB_p,
      inout    [21: 0]   FMCP_HB_n,
      inout    [33: 0]   FMCP_LA_p,
      inout    [33: 0]   FMCP_LA_n,
      input    [ 1: 0]   FMCP_CLK_M2C_p,
      input    [ 1: 0]   FMCP_GBTCLK_M2C_p,
      output             FMCP_REFCLK_C2M_p,
      input              FMCP_REFCLK_M2C_p,
      inout    [ 1: 0]   FMCP_GA,
      input              FMCP_RES0,
      inout              FMCP_RES1,
      inout              FMCP_SCL,
      inout              FMCP_SDA,
      output             FMCP_SYNC_C2M_p,
      input              FMCP_SYNC_M2C_p,
`endif /*ENABLE_FMCP*/

`ifdef ENABLE_QSFP28
      ///////// QSFP28 /////////
      output   [ 3: 0]   QSFP28_TX_p,
      output   [ 3: 0]   QSFP28_TX_n,
      input    [ 3: 0]   QSFP28_RX_p,
      input    [ 3: 0]   QSFP28_RX_n,
      input              QSFP28_REFCLK_p,
      input              QSFP28_INTERRUPT_n,
      output             QSFP28_LP_MODE,
      input              QSFP28_MOD_PRS_n,
      output             QSFP28_MOD_SEL_n,
      output             QSFP28_RST_n,
      inout              QSFP28_SCL,
      inout              QSFP28_SDA,
`else
      input              QSFP28_REFCLK_p,
`endif /*ENABLE_QSFP28*/

`ifdef ENABLE_QSFP28RSV
      ///////// QSFP28RSV /////////
      input              QSFP28RSV_REFCLK_p,
`endif /*ENABLE_QSFP28RSV*/

      ///////// AG /////////
      output             AG_UART_TX,
      input              AG_UART_RX,
      input              AG_UART_CTS,
      output             AG_UART_RTS,

`ifdef ENABLE_HPS
      ///////// HPS /////////
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input              HPS_ENET_RX_CTL,
      input    [ 3: 0]   HPS_ENET_RX_DATA,
      output             HPS_ENET_TX_CLK,
      output             HPS_ENET_TX_CTL,
      output   [ 3: 0]   HPS_ENET_TX_DATA,
      inout    [ 4: 0]   HPS_GPIO,
      inout              HPS_I2C_SCL,
      inout              HPS_I2C_SDA,
      input              HPS_JTAG_TCK,
      input              HPS_JTAG_TDI,
      output             HPS_JTAG_TDO,
      input              HPS_JTAG_TMS,
      inout              HPS_KEY,
      inout              HPS_LED,
      input              HPS_OSC_CLK,
      output             HPS_SD_CLK,
      inout              HPS_SD_CMD,
      inout    [ 3: 0]   HPS_SD_DATA,
      input              HPS_UART_RX,
      output             HPS_UART_TX,
      input              HPS_USB_CLK,
      inout    [ 7: 0]   HPS_USB_DATA,
      input              HPS_USB_DIR,
      input              HPS_USB_NXT,
      output             HPS_USB_STP,
`endif /*ENABLE_HPS*/

      ///////// INFO /////////
      output             INFO_SPI_SCLK,
      input              INFO_SPI_MISO,
      output             INFO_SPI_MOSI,
      output             INFO_SPI_CS_n

);


assign SI5340A_RST_n = 1'b1;
assign SI5340A_OE_n = 1'b0;

wire         system_clk_100;
wire         system_clk_100_internal;
wire         ninit_done;
wire         fpga_reset_n_debounced_wire;
reg          fpga_reset_n_debounced;
wire         src_reset_n;
wire         system_reset_n;
wire         h2f_reset;


assign system_reset_n = fpga_reset_n_debounced & src_reset_n & ~h2f_reset & ~ninit_done;

assign system_clk_100   = CLK_100_B2A;

assign system_clk_100_internal  = system_clk_100;

wire [2-1:0]     fpga_debounced_buttons;
wire [2-2:0]     fpga_led_internal;
wire [2-1:0]     fpga_led_pio;
wire [2-1:0]     fpga_dipsw_pio;
wire [2-1:0]     fpga_button_pio;
wire [1-1:0]     fpga_reset_n;
wire           heartbeat_led;
reg  [22:0]    heartbeat_count;
assign fpga_led_pio = {fpga_led_internal,heartbeat_led};
assign heartbeat_led = ~heartbeat_count[22];
assign LED = fpga_led_pio;
assign fpga_dipsw_pio = SW;
assign fpga_button_pio = BUTTON;
assign fpga_reset_n = CPU_RESET_n;

wire [31:0]    f2h_irq1_irq;


wire [43:0]    stm_hw_events;

assign stm_hw_events    = {{37{1'b0}}, heartbeat_led, fpga_led_internal, fpga_dipsw_pio, fpga_debounced_buttons};




assign f2h_irq1_irq    = {32'b0};

//Temporary disable src_reset_n
assign src_reset_n = 1'b1;

// Qsys Top module
qsys_top soc_inst (
//.src_prb_rst_sources_source             (src_reset_n),
.clk_100_clk                            (system_clk_100_internal),
.ninit_done_ninit_done                  (ninit_done),
.led_pio_external_connection_export     (fpga_led_internal),
.dipsw_pio_external_connection_export   (fpga_dipsw_pio),
.button_pio_external_connection_export  (fpga_debounced_buttons),
.agilex_hps_f2h_stm_hw_events_stm_hwevents (stm_hw_events),
//Terminate the CS_JTAG.
.agilex_hps_h2f_cs_ntrst                   (1'b1),
.agilex_hps_h2f_cs_tck                     (1'b1),
.agilex_hps_h2f_cs_tdi                     (1'b1),
.agilex_hps_h2f_cs_tdo                     (),
.agilex_hps_h2f_cs_tdoen                   (),
.agilex_hps_h2f_cs_tms                     (1'b1),
.emif_hps_pll_ref_clk_clk               (DDR4A_REFCLK_p),
.emif_hps_mem_mem_ck                    (DDR4A_CK),
.emif_hps_mem_mem_ck_n                  (DDR4A_CK_n),
.emif_hps_mem_mem_a                     (DDR4A_A),
.emif_hps_mem_mem_act_n                 (DDR4A_ACT_n),
.emif_hps_mem_mem_ba                    (DDR4A_BA),
.emif_hps_mem_mem_bg                    (DDR4A_BG),
.emif_hps_mem_mem_cke                   (DDR4A_CKE),
.emif_hps_mem_mem_cs_n                  (DDR4A_CS_n),
.emif_hps_mem_mem_odt                   (DDR4A_ODT),
.emif_hps_mem_mem_reset_n               (DDR4A_RESET_n),
.emif_hps_mem_mem_par                   (DDR4A_PAR),
.emif_hps_mem_mem_alert_n               (DDR4A_ALERT_n),
.emif_hps_mem_mem_dqs                   (DDR4A_DQS),
.emif_hps_mem_mem_dqs_n                 (DDR4A_DQS_n),
.emif_hps_mem_mem_dq                    (DDR4A_DQ),
.emif_hps_mem_mem_dbi_n                 (DDR4A_DBI_n),
.emif_hps_oct_oct_rzqin                 (DDR4A_RZQ),
.hps_io_jtag_tck                 (HPS_JTAG_TCK),
.hps_io_jtag_tms                 (HPS_JTAG_TMS),
.hps_io_jtag_tdo                 (HPS_JTAG_TDO),
.hps_io_jtag_tdi                 (HPS_JTAG_TDI),
.hps_io_EMAC0_TX_CLK       (HPS_ENET_TX_CLK),
.hps_io_EMAC0_RX_CLK       (HPS_ENET_RX_CLK),
.hps_io_EMAC0_TX_CTL       (HPS_ENET_TX_CTL),
.hps_io_EMAC0_RX_CTL       (HPS_ENET_RX_CTL),
.hps_io_EMAC0_TXD0         (HPS_ENET_TX_DATA[0]),
.hps_io_EMAC0_TXD1         (HPS_ENET_TX_DATA[1]),
.hps_io_EMAC0_RXD0         (HPS_ENET_RX_DATA[0]),
.hps_io_EMAC0_RXD1         (HPS_ENET_RX_DATA[1]),
.hps_io_EMAC0_TXD2         (HPS_ENET_TX_DATA[2]),
.hps_io_EMAC0_TXD3         (HPS_ENET_TX_DATA[3]),
.hps_io_EMAC0_RXD2         (HPS_ENET_RX_DATA[2]),
.hps_io_EMAC0_RXD3         (HPS_ENET_RX_DATA[3]),
.hps_io_EMAC0_MDIO         (HPS_ENET_MDIO),
.hps_io_EMAC0_MDC          (HPS_ENET_MDC),
.hps_io_SDMMC_CCLK         (HPS_SD_CLK),
.hps_io_SDMMC_CMD          (HPS_SD_CMD),
.hps_io_SDMMC_D0           (HPS_SD_DATA[0]),
.hps_io_SDMMC_D1           (HPS_SD_DATA[1]),
.hps_io_SDMMC_D2           (HPS_SD_DATA[2]),
.hps_io_SDMMC_D3           (HPS_SD_DATA[3]),
.hps_io_I2C1_SDA           (HPS_I2C_SDA),
.hps_io_I2C1_SCL           (HPS_I2C_SCL),
.hps_io_UART0_RX           (HPS_UART_RX),
.hps_io_UART0_TX           (HPS_UART_TX),
.hps_io_USB0_CLK           (HPS_USB_CLK),
.hps_io_USB0_STP           (HPS_USB_STP),
.hps_io_USB0_DIR           (HPS_USB_DIR),
.hps_io_USB0_NXT           (HPS_USB_NXT),
.hps_io_USB0_DATA0         (HPS_USB_DATA[0]),
.hps_io_USB0_DATA1         (HPS_USB_DATA[1]),
.hps_io_USB0_DATA2         (HPS_USB_DATA[2]),
.hps_io_USB0_DATA3         (HPS_USB_DATA[3]),
.hps_io_USB0_DATA4         (HPS_USB_DATA[4]),
.hps_io_USB0_DATA5         (HPS_USB_DATA[5]),
.hps_io_USB0_DATA6         (HPS_USB_DATA[6]),
.hps_io_USB0_DATA7         (HPS_USB_DATA[7]),
.hps_io_gpio1_io0           (HPS_LED),
.hps_io_gpio1_io1           (HPS_KEY),
.hps_io_gpio1_io4           (HPS_GPIO[4]),
.hps_io_gpio1_io18           (HPS_GPIO[0]),
.hps_io_gpio1_io19           (HPS_GPIO[1]),
.hps_io_gpio1_io20           (HPS_GPIO[2]),
.hps_io_gpio1_io21           (HPS_GPIO[3]),
.f2h_irq1_irq                           (f2h_irq1_irq),
.hps_io_hps_osc_clk                     (HPS_OSC_CLK),
.h2f_reset_reset                        (h2f_reset),
.reset_reset_n                          (system_reset_n)
);

// debounce fpga_reset_n
debounce fpga_reset_n_debounce_inst (
.clk          (system_clk_100_internal),
.reset_n      (~ninit_done),
.data_in      (fpga_reset_n),
.data_out     (fpga_reset_n_debounced_wire)
);
defparam fpga_reset_n_debounce_inst.WIDTH = 1;
defparam fpga_reset_n_debounce_inst.POLARITY = "LOW";
defparam fpga_reset_n_debounce_inst.TIMEOUT = 10000;               // at 100Mhz this is a debounce time of 1ms
defparam fpga_reset_n_debounce_inst.TIMEOUT_WIDTH = 32;            // ceil(log2(TIMEOUT))

always @ (posedge system_clk_100_internal or posedge ninit_done)
begin
    if (ninit_done == 1'b1)
        fpga_reset_n_debounced <= 1'b0;
    else
        fpga_reset_n_debounced <= fpga_reset_n_debounced_wire;
end

// Debounce logic to clean out glitches within 1ms
debounce debounce_inst (
.clk          (system_clk_100_internal),
.reset_n      (system_reset_n),
.data_in      (fpga_button_pio),
.data_out     (fpga_debounced_buttons)
);
defparam debounce_inst.WIDTH = 2;
defparam debounce_inst.POLARITY = "LOW";
defparam debounce_inst.TIMEOUT = 10000;               // at 100Mhz this is a debounce time of 1ms
defparam debounce_inst.TIMEOUT_WIDTH = 32;            // ceil(log2(TIMEOUT))

always @(posedge system_clk_100_internal or negedge system_reset_n) begin
  if (~system_reset_n)
    heartbeat_count <= 23'd0;
  else
    heartbeat_count <= heartbeat_count + 23'd1;
end


endmodule
